2006-02-09  Tim Omernick  <timo@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/4198378> Crash on a CFRelease when visiting http://www.akella.com/

        * Plugins/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView requestWithURLCString:]):
	The true source of this crash is that the URL string is sometimes not NULL-terminated, which is the
	Real Player plugin's fault.  That has been filed as 4439591.
	However, we can be more bulletproof here by switching the URL string encoding from Windows Latin 1
	to ISO Latin 1, so that any NULL-terminated string can be represented.  (As Darin and I found out
	last night, Windows Latin 1 has "holes" in certain character ranges and	thus cannot encode arbitrary
	C strings).

2006-02-09  Maciej Stachowiak  <mjs@apple.com>

        Rubber stamped by Anders. 
        
        - Moved all the default delegate classes to their own directory.

        * DefaultDelegates: Added.
        * DefaultDelegates/WebDefaultContextMenuDelegate.h: Added.
        * DefaultDelegates/WebDefaultContextMenuDelegate.m: Added.
        * DefaultDelegates/WebDefaultEditingDelegate.h: Added.
        * DefaultDelegates/WebDefaultEditingDelegate.m: Added.
        * DefaultDelegates/WebDefaultFrameLoadDelegate.h: Added.
        * DefaultDelegates/WebDefaultFrameLoadDelegate.m: Added.
        * DefaultDelegates/WebDefaultPolicyDelegate.h: Added.
        * DefaultDelegates/WebDefaultPolicyDelegate.m: Added.
        * DefaultDelegates/WebDefaultResourceLoadDelegate.h: Added.
        * DefaultDelegates/WebDefaultResourceLoadDelegate.m: Added.
        * DefaultDelegates/WebDefaultScriptDebugDelegate.h: Added.
        * DefaultDelegates/WebDefaultScriptDebugDelegate.m: Added.
        * DefaultDelegates/WebDefaultUIDelegate.h: Added.
        * DefaultDelegates/WebDefaultUIDelegate.m: Added.
        * WebKit.xcodeproj/project.pbxproj:
        * WebView/WebDefaultContextMenuDelegate.h: Removed.
        * WebView/WebDefaultContextMenuDelegate.m: Removed.
        * WebView/WebDefaultEditingDelegate.h: Removed.
        * WebView/WebDefaultEditingDelegate.m: Removed.
        * WebView/WebDefaultFrameLoadDelegate.h: Removed.
        * WebView/WebDefaultFrameLoadDelegate.m: Removed.
        * WebView/WebDefaultPolicyDelegate.h: Removed.
        * WebView/WebDefaultPolicyDelegate.m: Removed.
        * WebView/WebDefaultResourceLoadDelegate.h: Removed.
        * WebView/WebDefaultResourceLoadDelegate.m: Removed.
        * WebView/WebDefaultScriptDebugDelegate.h: Removed.
        * WebView/WebDefaultScriptDebugDelegate.m: Removed.
        * WebView/WebDefaultUIDelegate.h: Removed.
        * WebView/WebDefaultUIDelegate.m: Removed.

2006-02-08  Justin Garcia  <justin.garcia@apple.com>

        Original patch by Graham Dennis, reviewed by me:
        
        <http://bugs.webkit.org/show_bug.cgi?id=3982>
        webViewDidBeginEditing, webViewDidEndEditing notification methods not called on delegate
        
        Changes made by me, reviewed by thatcher:
        
        Made _setWindowHasFocus: and _setDisplaysWithFocusAttributes: into private SPI to allow
        for the testing of window.onFocus, window.onBlur, caret and focus halo painting, and 
        the focusing of content editable regions that happens as side effect of setting a selection,
        but only if the window has focus (7128).

        * WebCoreSupport/WebFrameBridge.m:
        (-[WebFrameBridge didBeginEditing]):
        (-[WebFrameBridge didEndEditing]):
        * WebView/WebHTMLView.m:
        (-[WebHTMLView updateFocusState]):
        (-[WebHTMLView _setWindowHasFocus:]):
        (-[WebHTMLView _setDisplaysWithFocusAttributes:]):
        * WebView/WebHTMLViewPrivate.h:

2006-02-08  David Kilzer  <ddkilzer@kilzer.net>

        Reviewed by Darin.

        - Fix http://bugs.webkit.org/show_bug.cgi?id=3527
        Allow Safari to open postscript files in browser windows as well

        * WebView/WebPDFRepresentation.m:
        (+[WebPDFRepresentation postScriptMIMETypes]): Added.
        (+[WebPDFRepresentation supportedMIMETypes]): Include PostScript MIME types.
        (-[WebPDFRepresentation convertPostScriptDataSourceToPDF:]): Added.
        (-[WebPDFRepresentation finishedLoadingWithDataSource:]):
        Handle PostScript conversion using new convertPostScriptDataSourceToPDF method.

2006-02-07  Alexey Proskuryakov  <ap@nypop.com>

        Reviewed by Timothy.

        Convert JavaScript objects to appropriate AppleScript types, instead of only strings
        http://bugs.webkit.org/show_bug.cgi?id=7012

        Tests: fast/AppleScript/*

        * WebView/WebView.m:
        (-[WebView aeDescByEvaluatingJavaScriptFromString:]): Added.
        * WebView/WebViewPrivate.h:

2006-02-06  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Eric.

        - fixed "remove frame, renderer and completed flag from ChildFrame, make Frame track these"
        http://bugs.webkit.org/show_bug.cgi?id=7125
        
        - fixed "onload event never called for iframe element with emtpy or about:blank src"
        http://bugs.webkit.org/show_bug.cgi?id=3609

        * WebCoreSupport/WebFrameBridge.h:
        * WebCoreSupport/WebFrameBridge.m:
        (-[WebFrameBridge initWithPage:webView:renderer:frameName:view:]): Pass along renderer.
        (-[WebFrameBridge createChildFrameNamed:withURL:referrer:renderPart:allowsScrolling:marginWidth:marginHeight:]): Pass along renderer.
        * WebCoreSupport/WebPageBridge.m:
        (-[WebPageBridge initWithMainFrameName:webView:frameView:]): Pass null for renderer.
        * WebView/WebView.m:
        * WebView/WebViewPrivate.h:

2006-02-06  John Sullivan  <sullivan@apple.com>

        Reviewed by Maciej Stachowiak.

        * WebView/WebPDFView.m:
        (-[WebPDFView menuForEvent:]):
        Removed use of WKExecutableLinkedInTigerOrEarlier() by modifying backward-compatibility
        hack involving PDF view context menus. Now we only bother to make sure that the PDFKit-
        supplied context menu items are present in Safari, for the benefit of the open source
        folks using tip of tree WebKit but older released Safari; it's possible that some other
        existing WebKit apps won't show all the PDF view context menu items.

2006-02-06  Maciej Stachowiak  <mjs@apple.com>

        Remove remaining .subproj references to fix release build.

        * WebKit.xcodeproj/project.pbxproj:

2006-02-06  Maciej Stachowiak  <mjs@apple.com>

        Rubber stamped by Hyatt.
        
        - renamed subproject directories to not end with .subproj

        * Carbon: renamed from Carbon.subproj
        * DOM: renamed from DOM.subproj
        * History: renamed from History.subproj
        * Misc: renamed from Misc.subproj
        * Panels: renamed from Panels.subproj
        * Plugins: renamed from Plugins.subproj
        * WebCoreSupport: renamed from WebCoreSupport.subproj
        * WebInspector: renamed from WebInspector.subproj
        * WebView: renamed from WebView.subproj
        
2006-02-06  Maciej Stachowiak  <mjs@apple.com>

        Ooops, I made a last-minute change to my last patch that broke the build - fixed.

        * WebView.subproj/WebFrame.m:
        (-[WebFrame _closeOldDataSources]):
        (-[WebFrame _detachFromParent]):
        (-[WebFrame _transitionToCommitted:]):
        (-[WebFrame _checkLoadCompleteForThisFrame]):
        (-[WebFrame _handledOnloadEvents]):
        (-[WebFrame _loadItem:withLoadType:]):
        (-[WebFrame _goToItem:withLoadType:]):
        (-[WebFrame _continueFragmentScrollAfterNavigationPolicy:formState:]):
        (-[WebFrame _clientRedirectedTo:delay:fireDate:lockHistory:isJavaScriptFormAction:]):
        (-[WebFrame _clientRedirectCancelled:]):
        * WebView.subproj/WebFramePrivate.h:

2006-02-05  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.
        
        - shuffle things around so that WebFrame no longer has a WebView backpointer, the backpointer is
        at the bridge level.
        http://bugs.webkit.org/show_bug.cgi?id=7093

        * WebCoreSupport.subproj/WebFrameBridge.h:
        * WebCoreSupport.subproj/WebFrameBridge.m:
        (-[WebFrameBridge initWithPage:webView:frameName:view:]):
        (-[WebFrameBridge page]):
        (-[WebFrameBridge mainFrame]):
        (-[WebFrameBridge webView]):
        (-[WebFrameBridge createWindowWithURL:frameName:]):
        (-[WebFrameBridge showWindow]):
        (-[WebFrameBridge areToolbarsVisible]):
        (-[WebFrameBridge setToolbarsVisible:]):
        (-[WebFrameBridge isStatusbarVisible]):
        (-[WebFrameBridge setStatusbarVisible:]):
        (-[WebFrameBridge setWindowFrame:]):
        (-[WebFrameBridge windowFrame]):
        (-[WebFrameBridge setWindowContentRect:]):
        (-[WebFrameBridge windowContentRect]):
        (-[WebFrameBridge setWindowIsResizable:]):
        (-[WebFrameBridge windowIsResizable]):
        (-[WebFrameBridge firstResponder]):
        (-[WebFrameBridge makeFirstResponder:]):
        (-[WebFrameBridge closeWindowSoon]):
        (-[WebFrameBridge runJavaScriptAlertPanelWithMessage:]):
        (-[WebFrameBridge runJavaScriptConfirmPanelWithMessage:]):
        (-[WebFrameBridge canRunBeforeUnloadConfirmPanel]):
        (-[WebFrameBridge runBeforeUnloadConfirmPanelWithMessage:]):
        (-[WebFrameBridge runJavaScriptTextInputPanelWithPrompt:defaultText:returningText:]):
        (-[WebFrameBridge addMessageToConsole:]):
        (-[WebFrameBridge runOpenPanelForFileButtonWithResultListener:]):
        (-[WebFrameBridge setStatusText:]):
        (-[WebFrameBridge startLoadingResource:withURL:customHeaders:]):
        (-[WebFrameBridge startLoadingResource:withURL:customHeaders:postData:]):
        (-[WebFrameBridge syncLoadResourceWithURL:customHeaders:postData:finalURL:responseHeaders:statusCode:]):
        (-[WebFrameBridge focusWindow]):
        (-[WebFrameBridge createChildFrameNamed:withURL:referrer:renderPart:allowsScrolling:marginWidth:marginHeight:]):
        (-[WebFrameBridge userAgentForURL:]):
        (-[WebFrameBridge _nextKeyViewOutsideWebFrameViewsWithValidityCheck:]):
        (-[WebFrameBridge previousKeyViewOutsideWebFrameViews]):
        (-[WebFrameBridge defersLoading]):
        (-[WebFrameBridge setDefersLoading:]):
        (-[WebFrameBridge viewForPluginWithURL:attributeNames:attributeValues:MIMEType:]):
        (-[WebFrameBridge _preferences]):
        (-[WebFrameBridge selectWordBeforeMenuEvent]):
        (-[WebFrameBridge historyLength]):
        (-[WebFrameBridge canGoBackOrForward:]):
        (-[WebFrameBridge goBackOrForward:]):
        (-[WebFrameBridge print]):
        (-[WebFrameBridge pollForAppletInView:]):
        (-[WebFrameBridge respondToChangedContents]):
        (-[WebFrameBridge respondToChangedSelection]):
        (-[WebFrameBridge undoManager]):
        (-[WebFrameBridge issueCutCommand]):
        (-[WebFrameBridge issueCopyCommand]):
        (-[WebFrameBridge issuePasteCommand]):
        (-[WebFrameBridge issuePasteAndMatchStyleCommand]):
        (-[WebFrameBridge canPaste]):
        (-[WebFrameBridge overrideMediaType]):
        (-[WebFrameBridge isEditable]):
        (-[WebFrameBridge shouldChangeSelectedDOMRange:toDOMRange:affinity:stillSelecting:]):
        (-[WebFrameBridge shouldBeginEditing:]):
        (-[WebFrameBridge shouldEndEditing:]):
        (-[WebFrameBridge windowObjectCleared]):
        (-[WebFrameBridge spellCheckerDocumentTag]):
        (-[WebFrameBridge isContinuousSpellCheckingEnabled]):
        (-[WebFrameBridge didFirstLayout]):
        (-[WebFrameBridge dashboardRegionsChanged:]):
        (-[WebFrameBridge createModalDialogWithURL:]):
        (-[WebFrameBridge canRunModal]):
        (-[WebFrameBridge runModal]):
        * WebCoreSupport.subproj/WebPageBridge.h:
        * WebCoreSupport.subproj/WebPageBridge.m:
        (-[WebPageBridge initWithMainFrameName:webView:frameView:]):
        (-[WebPageBridge webView]):
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource _fileWrapperForURL:]):
        (-[WebDataSource _webView]):
        (-[WebDataSource _setLoading:]):
        (-[WebDataSource _startLoading:]):
        (-[WebDataSource _setTitle:]):
        (-[WebDataSource _setRequest:]):
        (-[WebDataSource _updateIconDatabaseWithURL:]):
        (-[WebDataSource _defersCallbacksChanged]):
        (-[WebDataSource _setWebFrame:]):
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _traverseNextFrameStayWithin::]):
        (-[WebFrame _detachFromParent]):
        (-[WebFrame _setDataSource:]):
        (-[WebFrame _loadDataSource:withLoadType:formState:]):
        (-[WebFrame _initWithWebFrameView:webView:bridge:]):
        (-[WebFrame dealloc]):
        (-[WebFrame finalize]):
        (-[WebFrame webView]):
        * WebView.subproj/WebFrameView.m:
        (-[WebFrameView _webView]):
        (-[WebFrameView _goBack]):
        (-[WebFrameView _goForward]):
        * WebView.subproj/WebFrameViewInternal.h:
        * WebView.subproj/WebView.m:
        (-[WebView _createFrameNamed:inParent:allowsScrolling:]):
        (-[WebView _commonInitializationWithFrameName:groupName:]):

2006-02-04  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        * Misc.subproj/WebCoreStatistics.h:
        * Misc.subproj/WebCoreStatistics.m:
        (+[WebCoreStatistics javaScriptRootObjectTypeCounts]):
        javaScriptRootObjecTypeCounts -> javaScriptRootObjectTypeCounts

2006-02-04  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Hyatt.

        - change JavaScript collector statistics calls to use HashCountedSet instead
        of CFSet; other misc cleanup
        http://bugs.webkit.org/show_bug.cgi?id=7072

        * Misc.subproj/WebCoreStatistics.h:
        * Misc.subproj/WebCoreStatistics.m:
        (+[WebCoreStatistics javaScriptProtectedObjectsCount]): new
        (+[WebCoreStatistics javaScriptRootObjecTypeCounts]): new
        (+[WebCoreStatistics javaScriptRootObjectClasses]): deprecated
        (+[WebCoreStatistics javaScriptReferencedObjectsCount]): deprecated
        (+[WebCoreStatistics javaScriptNoGCAllowedObjectsCount]): Just return 0. Deprecated.

2006-02-03  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.
        
        - change spellchecker preflighting to happen via class methods instead of
        object methods.

        * WebView.subproj/WebView.m:
        (-[WebView setContinuousSpellCheckingEnabled:]):
        (+[WebView _preflightSpellCheckerNow:]):
        (+[WebView _preflightSpellChecker]):

2006-02-03  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Justin.

        Renamed configuration names to Debug, Release and Production.

        * WebKit.xcodeproj/project.pbxproj:

2006-02-02  David Hyatt  <hyatt@apple.com>

	Fix for bug 6957, rewrite image rendering in C++ and move it to
        WebCore.  Animation now stops lazily and just uses the CachedObject
        notification system to push updates so that rects no longer need to
        be cached (or sets of animating renderers in specific views).

        Reviewed by darin

        * Misc.subproj/WebNSPasteboardExtras.h:
        * Misc.subproj/WebNSPasteboardExtras.m:
        (-[NSPasteboard _web_writeImage:element:URL:title:archive:types:]):
        (-[NSPasteboard _web_declareAndWriteDragImage:element:URL:title:archive:source:]):
        * Misc.subproj/WebNSViewExtras.h:
        * Misc.subproj/WebNSViewExtras.m:
        (-[NSView _web_dragImage:element:rect:event:pasteboard:source:offset:]):
        * WebCoreSupport.subproj/WebImageData.m:
        (-[WebImageData init]):
        * WebCoreSupport.subproj/WebImageRendererFactory.m:
        (+[WebImageRendererFactory shouldUseThreadedDecoding]):
        (+[WebImageRendererFactory setShouldUseThreadedDecoding:]):
        (-[WebImageRendererFactory setPatternPhaseForContext:inUserSpace:]):
        (-[WebImageRendererFactory imageDataForName:]):
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _startDraggingImage:at:operation:event:sourceIsDHTML:DHTMLWroteData:]):
        (-[NSArray elementAtPoint:]):
        * WebView.subproj/WebImageView.m:
        (-[WebImageView writeImageToPasteboard:types:]):
        (-[WebImageView elementAtPoint:]):
        (-[WebImageView mouseDragged:]):
        * WebView.subproj/WebView.m:
        (-[WebView _writeImageElement:withPasteboardTypes:toPasteboard:]):

2006-01-31  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Omernick.
        
        - fixed <rdar://problem/4267144> REGRESSION (10.4.2): Safari pages auto-scroll too easily 
        during drag over content [5853]
        
        There were two issues here:
        (1) dragging over a non-editable webview (such as a typical Safari page) should not have
        auto-scrolled at all; the fact that it did was an uninentional side effect of making
        auto-scroll work for editable webviews a la Blot.
        (2) the speed & hot area of the auto-scroll changed between 10.4.1 and 10.4.2.
        
        I have a fix for (1), which is the much more important issue. I'll modify the bugzilla bug
        to be about the remaining issue.

        * WebView.subproj/WebView.m:
        (-[WebView _autoscrollForDraggingInfo:timeDelta:]):
        do nothing if not editable
        (-[WebView _shouldAutoscrollForDraggingInfo:]):
        return NO if not editable

2006-01-31  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Omernick.
        
        Support for programmatic scrolling one line at a time for PDFs. (We already had support for
        programmatic scrolling one page at a time, and to top/end.)

        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView _fakeKeyEventWithFunctionKey:]):
        generalized comment
        (-[WebPDFView scrollLineDown:]):
        pass a faked arrow-down key event
        (-[WebPDFView scrollLineUp:]):
        pass a faked arrow-up key event

2006-01-31  Darin Adler  <darin@apple.com>

        Reviewed by Hyatt.

        * WebCoreSupport.subproj/WebFrameBridge.m:
        (-[WebFrameBridge createChildFrameNamed:withURL:referrer:renderPart:allowsScrolling:marginWidth:marginHeight:]):
        Updated for name change.

2006-01-30  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Tim O.

        Add -Wno-deprecated-declarations to the compile flags for WebNetscapePluginPackage.m.
        <rdar://problem/4427068> LMGetCurApRefNum, CloseConnection and GetDiskFragment now deprecated.
        When we workaround these we can remove this compile flag.

        * WebKit.xcodeproj/project.pbxproj:

2006-01-30  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Justin.

        Remove the only use of -[NSFont glyphPacking]. This method was deprecated in Tiger
        and always returns NSNativeShortGlyphPacking.

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer initWithFont:]):

2006-01-28  David Hyatt  <hyatt@apple.com>

        Clean up RenderImage, eliminating unneeded members and methods.
	
        Reviewed by darin

        * WebCoreSupport.subproj/WebImageRenderer.h:
        * WebCoreSupport.subproj/WebImageRenderer.m:
        (-[WebImageRenderer copyWithZone:]):
        (-[WebImageRenderer size]):
        (-[WebImageRenderer drawImageInRect:fromRect:compositeOperator:context:]):

2006-01-26  Tim Omernick  <timo@apple.com>

        Reviewed by John Sullivan.

	<rdar://problem/4422365>

        * WebView.subproj/WebHTMLView.m:
        (-[NSArray addSuperviewObservers]):
        In addition to registering for frame/bounds change notifications, call -_frameOrBoundsChanged.
        It will check the current size/scroll against the previous layout's size/scroll.  We need to
        do this here to catch the case where the WebView is laid out at one size, removed from its
        window, resized, and inserted into another window.  Our frame/bounds changed notifications
        will not be sent in that situation, since we only watch for changes while in the view hierarchy.

	I have verified that this does not cause unnecessary layouts while running the PLT.

2006-01-25  Vicki Murley  <vicki@apple.com>

        Reviewed by Beth Dakin.

	- fix <rdar://problem/4351664> REGRESSION (420+): extra URL in b/f list - navigating back to 
	previous page fails at apple.com/retail/)
 
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _loadURL:referrer:loadType:target:triggeringEvent:form:formValues:]): grab the 
	redirect flag of the current load before calling _loadURL, which clears this flag, 
        (-[WebFrame _transitionToCommitted:]): remove misleading comment
        * History.subproj/WebHistoryItem.m:
        (-[WebHistoryItem setURL:]): release resources in the page cache when setting
        the URL on a WebHistoryItem

2006-01-25  Timothy Hatcher  <timothy@apple.com>

        Move off of -[NSFont widthOfString:] since it is now deprecated.
        Use the NSStringDrawing -[NSString sizeWithAttributes:] API.

        * WebCoreSupport.subproj/WebFileButton.m:
        (-[WebFileChooserButton bestVisualFrameSizeForCharacterCount:]):

2006-01-23  Darin Adler  <darin@apple.com>

        - fixed some small localizable strings issues

        * WebInspector.subproj/WebInspector.m:
        (-[DOMNode _nodeTypeName]): Changed so we don't have two localizable strings that
        are both "Document". I'm not sure we want to localize the DOM inspector UI at all,
        but this fixes things for now.
        (-[DOMNode _displayName]): Ditto.

        * English.lproj/Localizable.strings: Updated.
        * English.lproj/StringsNotToBeLocalized.txt: Updated for recent changes.

2006-01-23  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by thatcher
        
        Turned on -O2 for B&I build.

        * WebKit.xcodeproj/project.pbxproj:

2006-01-22  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Anders Carlsson.
        
        Makes the Inspector's Style pane take !important into account
        when marking overloaded properties.

        * WebInspector.subproj/webInspector/inspector.js:

2006-01-21  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Anders Carlsson.

        Make sure shorthand properties get striked-out if
        all the properties they expand into are overloaded.

        * WebInspector.subproj/webInspector/inspector.js:

2006-01-21  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        Adds computed style to the Web Inspector.
        Adds a "mapped style" link to the mapped attributes.

        * WebInspector.subproj/webInspector/inspector.css:
        * WebInspector.subproj/webInspector/inspector.html:
        * WebInspector.subproj/webInspector/inspector.js:

2006-01-20  Timothy Hatcher  <timothy@apple.com>

        Reviewed by John, some parts by Darin.

        Removes the old WebDebugDOMNode code, superseded by the ObjC DOM and the Web Inspector.
        Since Safari 2.0 still relies on these classes for the Debug menu's "Show DOM Tree", we remove
        that menu item to prevent a crash.

        * WebKit.exp: adds WebInspector, removes WebDebugDOMNode
        * WebKit.xcodeproj/project.pbxproj: added the REMOVE_SAFARI_DOM_TREE_DEBUG_ITEM define so the new WebView code doesn't build in the Default config
        * WebView.subproj/WebDebugDOMNode.h: Removed.
        * WebView.subproj/WebDebugDOMNode.m: Removed.
        * WebView.subproj/WebView.m:
        (+[WebView initialize]): check if we are in Safari and IncludeDebugMenu is true then observe for NSApplicationDidFinishLaunchingNotification and call _finishedLaunching
        (+[WebView _finishedLaunching]): observe for NSMenuDidAddItemNotification now that the main menu is loaded and wait for the Debug menu to be added
        (+[WebView _removeDOMTreeMenuItem:]): when the debug menu is added remove the "Show DOM Tree" item

2006-01-20  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Hyatt.

        Corrects the cascade order for mapped attributes.
        Shows "inline stylesheet" rather than "null" for rules in <style> tags.

        * WebInspector.subproj/webInspector/inspector.js:

2006-01-19  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Eric.

        Adds inline style reporting and mapped attribute support to the Inspector Style pane.
        Cleans up the node attributes area with a more natural attr = "value" look.
        Slight optimization to only update visible scrollbars during a window resize.

        * WebInspector.subproj/webInspector/inspector.css:
        * WebInspector.subproj/webInspector/inspector.js:

2006-01-19  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.
        
        http://bugs.webkit.org/show_bug.cgi?id=6631
        Inspector window has inappropriate maximum height

        * WebInspector.subproj/WebInspector.m:
        (-[WebInspector window]): removes the maximum size constraint

2006-01-19  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Omernick.

        * WebKit.xcodeproj/project.pbxproj:
        made WebNSUserDefaultsExtras.h private (SPI) so its one method can be called from
        Safari, so Safari can stop calling the similar method in Foundation.

2006-01-19  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Omernick.
        
        Made _webKit_guessedMIMEType SPI so Safari can use it in order to stop using
        the similar SPI method in Foundation. This involved splitting it out of the file
        it was in, to avoid creating any other new SPI here. Poor svn diff got mighty
        confused in the process.

        * Misc.subproj/WebNSDataExtras.h:
        removed _webkit_guessedMIMEType from here
        * Misc.subproj/WebNSDataExtrasPrivate.h: 
        Added. Contains only _webkit_guessedMIMEType. This file is private (SPI), whereas
        WebNSDataExtras.h is project-internal. I could have renamed WebNSDateExtras.h to
        WebNSDateExtrasInternal.h also, but I minimized the gratuitous change level here
        by not doing that.
        
        * Misc.subproj/WebNSDataExtras.m:
        Despite the great confusion of svn diff, all I actually did here was move 
        _webkit_guessedMIMEType and its helper _webkit_guessedMIMETypeForXML into a new
        category. No lines of code were harmed while creating this patch.

        * WebKit.xcodeproj/project.pbxproj:
        updated for new file

        * WebView.subproj/WebView.m:
        Added #import for new file since WebView uses _webkit_guessedMIMEType

2006-01-19  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Omernick.

        * Misc.subproj/WebNSURLExtras.h:
        added declaration of _webkit_rangeOfURLScheme so Safari can call it as a step
        towards weaning Safari from Foundation SPI.

2006-01-17  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by eric
        
        Deployment builds now use -O2

        * WebKit.xcodeproj/project.pbxproj:

2006-01-17  Beth Dakin  <bdakin@apple.com>

        Reviewed by Darin.

        Fix for <rdar://problem/4112029> With Quartz scaling on, Safari incorrectly 
        handles mouseover effects

        The location of an event in the window should be converted to the superview 
        of the contentView to do accurate hitTesting.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _updateMouseoverWithEvent:]): Convert the point to the
        contentView's superview from nil. 

2006-01-16  Timothy Hatcher  <timothy@apple.com>

        Rubber stamped by Maciej.

        Check for a new "WebKitDeveloperExtras" default when
        including the "Inspect Element" context menu item.
        We should retire the other one eventually.

        * WebView.subproj/WebView.m:
        (-[WebView _menuForElement:defaultItems:]):

2006-01-17  Anders Carlsson  <andersca@mac.com>

        Reviewed by Timothy Hatcher.

        - http://bugs.webkit.org/show_bug.cgi?id=6594
        Web Inspector: finish node attributes
        
        * WebInspector.subproj/webInspector/inspector.css:
        * WebInspector.subproj/webInspector/inspector.html:
        * WebInspector.subproj/webInspector/inspector.js:
        Add initial support for element attributes.

2006-01-16  John Sullivan  <sullivan@apple.com>

        Reviewed by Vicki Murley.
        
        - fixed <rdar://problem/4409288> REGRESSION (TOT): When no selection is present on page, 
        Jump to Selection doesn't beep

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _hasInsertionPoint]):
        new helper method
        (-[NSArray validateUserInterfaceItem:]):
        Don't validate this menu item (or a couple of others) if the selection is a caret and
        the page isn't editable. In that state, there is no visible selection so this menu item
        doesn't make sense. I suspect this was broken by some editing-related change that makes
        selectionState return WebSelectionStateCaret here where it used to return WebSelectionStateNone.

2006-01-16  Tim Omernick  <timo@apple.com>

        Reviewed by John Sullivan.

	WebKit part of <rdar://problem/4211707> NPAPI ref count behavior differs with Mozilla

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView getVariable:value:]):
	The returned window script object is expected to be retained, as described here:
	<http://www.mozilla.org/projects/plugins/npruntime.html#browseraccess>

2006-01-16  Anders Carlsson  <andersca@mac.com>

        Reviewed by Darin.

        * WebInspector.subproj/webInspector/inspector.js:
        Use defined NodeType values instead of integers.

2006-01-15  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.
 
        New DOM Inspector that lives in WebKit and is accessible from any WebView.
        Accessible from a contextual menu when the WebKitEnableInspectElementContextMenuItem default is
        true or you have a development build. Browsing the tree, serialized HTML and CSS rules work.
 
        To always enable enter the following in the Terminal (change the bundle id to affect other WebKit apps):
        defaults write com.apple.Safari WebKitEnableInspectElementContextMenuItem -bool true
 
        http://bugs.webkit.org/show_bug.cgi?id=6571

        * English.lproj/Localizable.strings:
        * English.lproj/StringsNotToBeLocalized.txt: reorder of the entries
        * Misc.subproj/WebKitNSStringExtras.h:
        * Misc.subproj/WebKitNSStringExtras.m:
        (-[NSString _webkit_stringByCollapsingWhitespaceCharacters]): collapses consecutive whitespace into a single space
        * WebCoreSupport.subproj/WebFrameBridge.m:
        (-[WebFrameBridge pluginViewWithPackage:attributeNames:attributeValues:baseURL:]): cleanup
        (-[WebFrameBridge viewForPluginWithURL:attributeNames:attributeValues:MIMEType:]): call the new UI delegate method
        * WebInspector.subproj: Added.
        * WebInspector.subproj/WebInspector.h: Added.
        * WebInspector.subproj/WebInspector.m: Added.
        (+[WebInspector sharedWebInspector]):
        (-[WebInspector init]):
        (-[WebInspector initWithWebFrame:]):
        (-[WebInspector dealloc]):
        (-[WebInspector window]):
        (-[WebInspector windowDidLoad]):
        (-[WebInspector windowWillClose:]):
        (-[WebInspector showWindow:]):
        (-[WebInspector setWebFrame:]):
        (-[WebInspector webFrame]):
        (-[WebInspector setRootDOMNode:]):
        (-[WebInspector rootDOMNode]):
        (-[WebInspector setFocusedDOMNode:]):
        (-[WebInspector focusedDOMNode]):
        (-[WebInspector setSearchQuery:]):
        (-[WebInspector searchQuery]):
        (-[WebInspector searchResults]):
        (-[WebInspector showOptionsMenu]):
        (-[WebInspector selectNewRoot:]):
        (-[WebInspector resizeTopArea:]):
        (-[WebInspector treeViewScrollTo:]):
        (-[WebInspector treeViewOffsetTop]):
        (-[WebInspector treeViewScrollHeight]):
        (-[WebInspector traverseTreeBackward]):
        (-[WebInspector traverseTreeForward]):
        (-[WebInspector _toggleIgnoreWhitespace:]):
        (-[WebInspector _highlightNode:]):
        (-[WebInspector _nodeHighlightExpired:]):
        (-[WebInspector _focusRootNode:]):
        (-[WebInspector _revealAndSelectNodeInTree:]):
        (-[WebInspector _showSearchResults:]):
        (-[WebInspector _refreshSearch]):
        (-[WebInspector _update]):
        (-[WebInspector _updateRoot]):
        (-[WebInspector _updateTreeScrollbar]):
        (+[WebInspector isSelectorExcludedFromWebScript:]):
        (+[WebInspector webScriptNameForSelector:]):
        (+[WebInspector isKeyExcludedFromWebScript:]):
        (-[WebInspector handleEvent:]):
        (-[WebInspector webView:didFinishLoadForFrame:]):
        (-[WebInspector webView:plugInViewWithArguments:]):
        (-[WebInspector outlineView:numberOfChildrenOfItem:]):
        (-[WebInspector outlineView:isItemExpandable:]):
        (-[WebInspector outlineView:child:ofItem:]):
        (-[WebInspector outlineView:objectValueForTableColumn:byItem:]):
        (-[WebInspector outlineView:willDisplayOutlineCell:forTableColumn:item:]):
        (-[WebInspector outlineViewItemDidCollapse:]):
        (-[WebInspector outlineViewSelectionDidChange:]):
        (-[WebInspectorPrivate dealloc]):
        (-[DOMHTMLElement _addClassName:]): Helper method for the Inspector to append style classes
        (-[DOMHTMLElement _removeClassName:]): Helper method for the Inspector to remove style classes
        (-[DOMNode _contentPreview]):
        (-[DOMNode _isAncestorOfNode:]):
        (-[DOMNode _isDescendantOfNode:]):
        (-[DOMNode _isWhitespace]):
        (-[DOMNode _lengthOfChildNodesIgnoringWhitespace]):
        (-[DOMNode _childNodeAtIndexIgnoringWhitespace:]):
        (-[DOMNode _nextSiblingSkippingWhitespace]):
        (-[DOMNode _previousSiblingSkippingWhitespace]):
        (-[DOMNode _firstChildSkippingWhitespace]):
        (-[DOMNode _lastChildSkippingWhitespace]):
        (-[DOMNode _firstAncestorCommonWithNode:]):
        (-[DOMNode _traverseNextNodeStayingWithin:]):
        (-[DOMNode _traverseNextNodeSkippingWhitespaceStayingWithin:]):
        (-[DOMNode _traversePreviousNode]):
        (-[DOMNode _traversePreviousNodeSkippingWhitespace]):
        (-[DOMNode _nodeTypeName]):
        (-[DOMNode _shortDisplayName]):
        (-[DOMNode _displayName]):
        * WebInspector.subproj/WebInspectorInternal.h: Added.
        * WebInspector.subproj/WebInspectorOutlineView.h: Added.
        * WebInspector.subproj/WebInspectorOutlineView.m: Added.
        (-[WebInspectorOutlineView isOpaque]):
        (-[WebInspectorOutlineView _highlightColorForCell:]):
        (-[WebInspectorOutlineView _highlightRow:clipRect:]):
        (-[WebInspectorOutlineView drawBackgroundInClipRect:]):
        * WebInspector.subproj/WebInspectorPanel.h: Added.
        * WebInspector.subproj/WebInspectorPanel.m: Added.
        (-[WebInspectorPanel canBecomeKeyWindow]):
        (-[WebInspectorPanel canBecomeMainWindow]):
        (-[WebInspectorPanel moveWindow:]):
        (-[WebInspectorPanel resizeWindow:]):
        (-[WebInspectorPanel sendEvent:]):
        * WebInspector.subproj/WebNodeHighlight.h: Added.
        * WebInspector.subproj/WebNodeHighlight.m: Added.
        (-[WebNodeHighlight initWithBounds:andRects:forView:]):
        (-[WebNodeHighlight dealloc]):
        (-[WebNodeHighlight fractionComplete]):
        (-[WebNodeHighlight expire]):
        (-[WebNodeHighlight redraw:]):
        * WebInspector.subproj/WebNodeHighlightView.h: Added.
        * WebInspector.subproj/WebNodeHighlightView.m: Added.
        (-[WebNodeHighlightView roundedRect:withRadius:]):
        (-[WebNodeHighlightView initWithHighlight:andRects:forView:]):
        (-[WebNodeHighlightView dealloc]):
        (-[WebNodeHighlightView isOpaque]):
        (-[WebNodeHighlightView drawRect:]):
        * WebInspector.subproj/webInspector: Added.
        * WebInspector.subproj/webInspector/Images: Added.
        * WebInspector.subproj/webInspector/Images/close.png: Added.
        * WebInspector.subproj/webInspector/Images/closePressed.png: Added.
        * WebInspector.subproj/webInspector/Images/downTriangle.png: Added.
        * WebInspector.subproj/webInspector/Images/menu.png: Added.
        * WebInspector.subproj/webInspector/Images/menuPressed.png: Added.
        * WebInspector.subproj/webInspector/Images/popupFill.png: Added.
        * WebInspector.subproj/webInspector/Images/popupFillPressed.png: Added.
        * WebInspector.subproj/webInspector/Images/popupLeft.png: Added.
        * WebInspector.subproj/webInspector/Images/popupLeftPressed.png: Added.
        * WebInspector.subproj/webInspector/Images/popupRight.png: Added.
        * WebInspector.subproj/webInspector/Images/popupRightPressed.png: Added.
        * WebInspector.subproj/webInspector/Images/rightTriangle.png: Added.
        * WebInspector.subproj/webInspector/Images/scrollThumbBottom.png: Added.
        * WebInspector.subproj/webInspector/Images/scrollThumbMiddle.png: Added.
        * WebInspector.subproj/webInspector/Images/scrollThumbTop.png: Added.
        * WebInspector.subproj/webInspector/Images/scrollTrackBottom.png: Added.
        * WebInspector.subproj/webInspector/Images/scrollTrackMiddle.png: Added.
        * WebInspector.subproj/webInspector/Images/scrollTrackTop.png: Added.
        * WebInspector.subproj/webInspector/Images/squareButtonRight.png: Added.
        * WebInspector.subproj/webInspector/Images/squareButtonRightPressed.png: Added.
        * WebInspector.subproj/webInspector/Images/upTriangle.png: Added.
        * WebInspector.subproj/webInspector/inspector.css: Added.
        * WebInspector.subproj/webInspector/inspector.html: Added.
        * WebInspector.subproj/webInspector/inspector.js: Added.
        * WebKit.xcodeproj/project.pbxproj: Adds Web Inspector files
        * WebView.subproj/WebUIDelegatePrivate.h: new UI delegate method to supply a replacement view for plugins
        * WebView.subproj/WebView.m:
        (-[WebView _menuForElement:defaultItems:]): Add a new context menu item for inspecting
        (-[WebView _inspectElement:]): Context menu item target for inspecting

2006-01-14  Alexey Proskuryakov  <ap@nypop.com>

        Reviewed by Darin.

        - Fix http://bugs.webkit.org/show_bug.cgi?id=6531
        document.cookie="killmenothing" doesn't set the cookie

        * WebCoreSupport.subproj/WebCookieAdapter.m: (-[WebCookieAdapter setCookies:forURL:policyBaseURL:]):
        Append an '=' to the cookie string if it has none, so that 
        +[NSHTTPCookie cookiesWithResponseHeaderFields:forURL:] can parse it.

2006-01-14  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Eric.

        - added bridging infrastructure for Page class
        
        * WebCoreSupport.subproj/WebPageBridge.h: Added.
        * WebCoreSupport.subproj/WebPageBridge.m: Added.
        (-[WebPageBridge initWithMainFrameName:view:]): New class, somewhat obvious.
        * WebKit.xcodeproj/project.pbxproj:
        * WebView.subproj/WebView.m:
        (-[WebViewPrivate dealloc]): Don't use _mainFrameBrige, use _pageBridge
        (-[WebView _close]): ditto
        (-[WebView _commonInitializationWithFrameName:groupName:]): ditto
        (-[WebView mainFrame]): ditto

2006-01-12  Maciej Stachowiak  <mjs@apple.com>

        Rubber stamped by Eric.

        - rename WebBridge to WebFrameBridge
        
        - also removed all tabs from WebFrameBridge.m

        * DOM.subproj/WebDOMOperations.m:
        (-[DOMNode _bridge]):
        (-[DOMNode webArchive]):
        (-[DOMRange _bridge]):
        (-[DOMRange webArchive]):
        * DOM.subproj/WebDOMOperationsPrivate.h:
        * English.lproj/StringsNotToBeLocalized.txt:
        * Misc.subproj/WebCoreStatistics.m:
        * Misc.subproj/WebNSViewExtras.h:
        * Misc.subproj/WebNSViewExtras.m:
        (-[NSView _bridge]):
        * Plugins.subproj/WebBaseNetscapePluginView.m:
        * Plugins.subproj/WebNetscapePluginEmbeddedView.m:
        * Plugins.subproj/WebNetscapePluginStream.m:
        (-[WebNetscapePluginStream initWithRequest:pluginPointer:notifyData:sendNotification:]):
        * Plugins.subproj/WebPluginContainerCheck.m:
        (-[WebPluginContainerCheck _isForbiddenFileLoad]):
        * Plugins.subproj/WebPluginController.h:
        * Plugins.subproj/WebPluginController.m:
        (-[WebPluginController bridge]):
        * WebCoreSupport.subproj/WebBridge.h: Removed.
        * WebCoreSupport.subproj/WebBridge.m: Removed.
        * WebCoreSupport.subproj/WebFileButton.h:
        * WebCoreSupport.subproj/WebFileButton.m:
        (-[WebFileChooserButton initWithBridge:delegate:]):
        * WebCoreSupport.subproj/WebFrameBridge.h: Added.
        * WebCoreSupport.subproj/WebFrameBridge.m: Added.
        (-[WebFrameBridge mainFrame]):
        (-[WebFrameBridge createWindowWithURL:frameName:]):
        (-[WebFrameBridge canTargetLoadInFrame:]):
        (-[WebFrameBridge createChildFrameNamed:withURL:referrer:renderPart:allowsScrolling:marginWidth:marginHeight:]):
        (formDelegate):
        (-[WebFrameBridge createModalDialogWithURL:]):
        * WebCoreSupport.subproj/WebSubresourceLoader.m:
        * WebCoreSupport.subproj/WebTextRendererFactory.m:
        * WebCoreSupport.subproj/WebViewFactory.m:
        (-[WebViewFactory bridgeForView:]):
        * WebKit.xcodeproj/project.pbxproj:
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource _bridge]):
        (-[WebDataSource _receivedMainResourceError:complete:]):
        (-[WebDataSource _stringWithData:]):
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebDebugDOMNode.m:
        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _traverseNextFrameStayWithin::]):
        (Frame):
        (-[WebFrame _detachFromParent]):
        (-[WebFrame _bridge]):
        (-[WebFrame _initWithWebFrameView:webView:bridge:]):
        * WebView.subproj/WebFrameInternal.h:
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFrameView.m:
        (-[WebFrameView webCoreBridge]):
        (-[WebFrameView _bridge]):
        * WebView.subproj/WebHTMLRepresentation.m:
        (+[WebHTMLRepresentation supportedMIMETypes]):
        (-[WebHTMLRepresentation _bridge]):
        (-[WebHTMLRepresentation documentSource]):
        * WebView.subproj/WebHTMLRepresentationPrivate.h:
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _pasteWithPasteboard:allowPlainText:]):
        (-[WebHTMLView _deleteRange:killRing:prepend:smartDeleteOK:deletionAction:]):
        (-[WebHTMLView updateFocusState]):
        (-[NSArray validateUserInterfaceItem:]):
        (-[NSArray attributedString]):
        (-[NSArray selectedAttributedString]):
        (-[NSArray concludeDragForDraggingInfo:actionMask:]):
        (-[NSArray keyDown:]):
        (-[NSArray _alterCurrentSelection:direction:granularity:]):
        (-[NSArray _alterCurrentSelection:verticalDistance:]):
        (-[NSArray _expandSelectionToGranularity:]):
        (-[NSArray cut:]):
        (-[NSArray _applyStyleToSelection:withUndoAction:]):
        (-[NSArray _applyParagraphStyleToSelection:withUndoAction:]):
        (-[NSArray pasteAsPlainText:]):
        (-[NSArray insertNewline:]):
        (-[NSArray insertLineBreak:]):
        (-[NSArray insertParagraphSeparator:]):
        (-[NSArray _changeWordCaseWithSelector:]):
        (-[NSArray startSpeaking:]):
        (-[NSArray selectToMark:]):
        (-[NSArray swapWithMark:]):
        (-[NSArray transpose:]):
        (-[WebHTMLView characterIndexForPoint:]):
        (-[WebHTMLView firstRectForCharacterRange:]):
        (-[WebHTMLView selectedRange]):
        (-[WebHTMLView attributedSubstringFromRange:]):
        (-[WebHTMLView _selectMarkedText]):
        (-[WebHTMLView _selectRangeInMarkedText:]):
        (-[WebHTMLView setMarkedText:selectedRange:]):
        (-[WebHTMLView _selectionIsInsideMarkedText]):
        (-[WebTextCompleteController _insertMatch:]):
        (-[WebTextCompleteController doCompletion]):
        (-[WebTextCompleteController endRevertingChange:moveLeft:]):
        * WebView.subproj/WebHTMLViewPrivate.h:
        * WebView.subproj/WebImageView.m:
        * WebView.subproj/WebMainResourceLoader.m:
        * WebView.subproj/WebRenderNode.m:
        * WebView.subproj/WebResource.m:
        (-[WebResource _stringValue]):
        * WebView.subproj/WebScriptDebugDelegate.m:
        * WebView.subproj/WebTextView.m:
        * WebView.subproj/WebView.m:
        (-[WebView _createFrameNamed:inParent:allowsScrolling:]):
        (-[WebView _commonInitializationWithFrameName:groupName:]):
        (-[WebView writeSelectionWithPasteboardTypes:toPasteboard:]):
        (-[WebView moveDragCaretToPoint:]):
        (-[WebView shouldClose]):
        (-[WebView editableDOMRangeForPoint:]):
        (-[WebView setEditable:]):
        (-[WebView deleteSelection]):
        (-[WebView _bridgeForSelectedOrMainFrame]):
        (-[WebView _bridgeAtPoint:]):

2006-01-13  Darin Adler  <darin@apple.com>

        - Replaced tabs with spaces in source files that had less than 10 lines with tabs.
        - Set allow-tabs Subversion property in source files that have more than 10 lines with tabs.

2006-01-12  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim O.
        
        - fixed <rdar://problem/4406994> REGRESSION (TOT): zooming window at cnn.com 
        makes window fill width of screen

        * WebView.subproj/WebFrameView.m:
        (-[WebFrameView _largestChildWithScrollBars]):
        now skips zero-area frames, used by some evil ads

2006-01-10  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim H.
        
        - fixed <rdar://problem/4265966> PDFs continue to show a (secondary) selection 
        when the focus moves elsewhere

        * WebView.subproj/WebPDFView.h:
        added trackedFirstResponder ivar
        
        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView dealloc]):
        assert that trackedFirstResponder is nil, as it was released/cleared in viewWillMoveToWindow:
        (-[WebPDFView _trackFirstResponder]):
        If the tracked first responder was the PDFView's documentView, and the current first responder isn't,
        deselect all. This is equivalent to overriding resignFirstResponder in the PDFView's 
        documentView and deselecting all there, as other web document view classes do. Also, keep track of
        the new first responder for next time.
        (-[WebPDFView viewWillMoveToWindow:]):
        stop observing NSWindowDidUpdateNotification on the old window
        (-[WebPDFView viewDidMoveToWindow]):
        start observing NSWindowDidUpdateNotification on the new window, with _trackFirstResponder
        as the callback. Ideally we'd use a notification that tells us that the first responder is
        changing, but there is no such notification, so we have to use this very frequent one instead.
        The archaic 2573089 tracks the desire to have a responder-changed notification.
        (-[WebPDFView becomeFirstResponder]):
        removed comment about this bug that's now obsolete

2006-01-11  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Updated for recent changes.

2006-01-09  Darin Adler  <darin@apple.com>

        * Makefile.am: Removed.

2006-01-09  John Sullivan  <sullivan@apple.com>

        Reviewed by Beth Dakin.
                
        - fixed <rdar://problem/4302263> CrashTracer: 504 crashes in Safari at 
        com.apple.AppKit: NSTargetForSendAction + 1060
        
        The problem was that back/forward/stop/reload context menu items had nil targets,
        and thus were relying on AppKit to start from the context menu target (the clicked-upon 
        view) and use the responder chain to find the WebView to act as the target. In Tiger, 
        context menus don't retain their implicit target (the clicked-upon view again), and
        there was a race condition where the WebHTMLView could be dealloc'ed while the menu item
        was being processed, eventually crashing in AppKit. The fix is to explicitly set the
        target of these four menu items to the WebView, since the WebView is not dealloc'ed
        in the loading process.
        
        This might be fixed in a future version of AppKit by making the context menu retain its
        implicit target until it is dismissed, but with this change it will be fixed regardless
        of potential AppKit changes.

        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        (-[WebDefaultUIDelegate menuItemWithTag:target:]):
        Added target: parameter and removed code that set the target for some menu items; now the
        caller is responsible for supplying the target.
        (-[WebDefaultUIDelegate contextMenuItemsForElement:defaultMenuItems:]):
        Supply target (or nil) in calls to menuItemWithTag:target:. This matches existing behavior
        except for Back/Forward/Stop/Reload, which used to supply no target but now supply the
        WebView as the target.
        (-[WebDefaultUIDelegate editingContextMenuItemsForElement:defaultMenuItems:]):
        Supply target (or nil) in calls to menuItemWithTag:target:

2006-01-09  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin.
        
        - Second cut at fixing <rdar://problem/4268278> Submitting a form 
        in onUnload event handler causes crash in 
        -[WebDataSource(WebPrivate) _commitIfReady:].)

        - Fixes http://bugs.webkit.org/show_bug.cgi?id=6331
        REGRESSION: form events don't fire after back/forward navigation, 
        due to inconsistent load state
        
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource _stopLoading]): 
        (1) If there are no resource loaders to signal the WebView that we've
        been canceled, manufacture the signal. Otherwise, the cancel gets 
        ignored and nobody cleans up after the load. (We signal the WebView but
        not the WebFrame because we don't want the WebFrame to tear down the 
        data source.  Unlike most canceled data sources, this one has valid data 
        because it's in the back/forward cache.)
        (2) Update _private->stopping before returning because if the 
        data source is in the back/forward cache it can be reused, so it 
        needs to be in a consistent state. (We never encountered this 
        situation before because we would always crash first.)
        (-[WebDataSource _commitLoadWithData:]): Move _commitIfReady call 
        inside retain block because the commit may cause an unload event 
        to fire, which may start a new load, deallocating the current 
        data source. (This is the same reason the rest of the function is 
        in the retain block.)
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _transitionToCommitted:]): If the unload handler 
        started a new load, return early to avoid stomping it.
        (-[WebFrame _continueLoadRequestAfterNavigationPolicy:formState:]): 
        Undo previous incorrect fix.
        (-[WebFrame stopLoading]): Remove misleading comment. Setting 
        provisionalDataSource to nil is not optional but required for 
        internal consistency.

2006-01-09  Alexey Proskuryakov  <ap@nypop.com>

        Reviewed by Maciej.

        Affects many layout tests (when running with primary Russian language).

        - Fix http://bugs.webkit.org/show_bug.cgi?id=4759
        'ex' length unit calculation (Some layout tests fail if the system primary language is Russian)

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer xHeight]): Use glyphForCharacter() instead of -[NSFont glyphWithName:].

2006-01-07  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed by Darin, landed by ap.
        
        Test: fast/text/atsui-small-caps-punctuation-size.html
        
        - fix http://bugs.webkit.org/show_bug.cgi?id=6397
          ATSUI small caps use small punctuation
          
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (createATSULayoutParameters): Changed the characters for which size must
        not change from !u_isbase() to the M* categories.

2006-01-06  John Sullivan  <sullivan@apple.com>

        Reviewed by Vicki Murley (full credit) and Tim Omernick (half credit).
        
        - fixed <rdar://problem/4401102> REGRESSION (420+): When displaying a PDF, tabbing around stops working after reaching page

        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView setNextKeyView:]):
        Use [PDFSubview documentView] rather than PDFSubview here, since that's the view that we now hand off first-responderhood to.

2006-01-05  Tim Omernick  <timo@apple.com>

        Reviewed by Geoff.

	<rdar://problem/4400804> Client-side redirect to a non-HTTP URL confuses Safari

        * WebView.subproj/WebFrame.m:
        (-[WebFrame _continueLoadRequestAfterNavigationPolicy:formState:]):
	If we were waiting for a quick redirect, but the policy delegate decided to ignore it, then we 
	need to report that the client redirect was cancelled.
	
2006-01-05  John Sullivan  <sullivan@apple.com>

        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView _fakeKeyEventWithFunctionKey:]):
        Just added a FIXME comment about how to clean up this minor hack in the future.

2006-01-05  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim O.
        
        - fixed these bugs:
        <rdar://problem/3021785> page up/down don't work on frameset pages unless you click        
        <rdar://problem/3021788> Page Up/Down moves an unscrollable frame if you click on it first
        
        and the WebKit part of this (need new Safari too for complete fix):
        <rdar://problem/4378905> Page up/down don't work in PDFs when address field is focused
        
        I moved some logic down from Safari that dealt with finding the largest scrollable child frame in a frameset,
        and added support for standard scrolling-related selectors to WebPDFView. The latter was needed for 4378905;
        the former was needed due to side effects of the Safari part of the change. As long as I was doing the former,
        I also used that logic to fix 3021785 and 3021788.
        
        * WebView.subproj/WebFrameViewPrivate.h:
        new currently-private methods _hasScrollBars and _largestChildWithScrollBars

        * WebView.subproj/WebFrameView.m:
        (-[WebFrameView scrollToBeginningOfDocument:]):
        if we don't have scroll bars, operate on our largest child with scroll bars instead
        (-[WebFrameView scrollToEndOfDocument:]):
        ditto
        (-[WebFrameView _pageVertically:]):
        ditto
        (-[WebFrameView _pageHorizontally:]):
        ditto
        (-[WebFrameView _scrollLineVertically:]):
        ditto
        (-[WebFrameView _scrollLineHorizontally:]):
        ditto
        (-[WebFrameView keyDown:]):
        where we were bailing out if ![self allowsScrolling], also check for whether there's a
        child with scroll bars, and don't bail out if so
        (-[WebFrameView _area]):
        new helper method used to implement _largestChildWithScrollBars (code moved from Safari)
        (-[WebFrameView _hasScrollBars]):
        new method, just returns YES if either scroll bar is showing (code moved from Safari)
        (-[WebFrameView _largestChildWithScrollBars]):
        new method, returns the child with the largest area that is showing at least one scroll bar
        (code moved from Safari and tweaked a little)
        
        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView _fakeKeyEventWithFunctionKey:]):
        new method, hackaround for the fact that PDFView handles key downs from standard scrolling keys
        but does not implement the standard responder selectors
        (-[WebPDFView scrollPageDown:]):
        use _fakeKeyEventWithFunctionKey: to get the PDFView to scroll appropriately
        (-[WebPDFView scrollPageUp:]):
        ditto
        (-[WebPDFView scrollToBeginningOfDocument:]):
        ditto
        (-[WebPDFView scrollToEndOfDocument:]):
        ditto
        
        * WebView.subproj/WebView.m:
        add scrollToBeginningOfDocument and scrollToEndOfDocument to the list of responder operations
        that we hand off appropriately to the responder chain. These two aren't defined in any header
        but are generated by Home and End keys and used by the text system.

2006-01-05  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin.

        - Fixed http://bugs.webkit.org/show_bug.cgi?id=6361
        Add plugin support to DumpRenderTree

        * WebKit.exp: export WebPluginDatabase class, which DumpRenderTree
        needs to add plugins to the runtime.

2006-01-03  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	- move frame management and finding code from WebKit to WebCore
	http://bugs.webkit.org/show_bug.cgi?id=6368

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView loadPluginRequest:]): Set frame name straight on the bridge,
	instead of having it bubble through the view and frame.
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge initWithFrameName:view:]): don't pass name to frame, we own it now; set it
	on ourselves directly
	(-[WebBridge findFrameNamed:]): removed
        (-[WebBridge createWindowWithURL:frameName:]): set name on bridge, not webview
        (-[WebBridge createChildFrameNamed:withURL:referrer:renderPart:allowsScrolling:marginWidth:marginHeight:]):
        (-[WebBridge runModal]): remove excess braces
        * WebKit.xcodeproj/project.pbxproj:
        * WebView.subproj/WebControllerSets.h: Removed.
        * WebView.subproj/WebControllerSets.m: Removed.
        * WebView.subproj/WebFrame.m:
        (-[WebFramePrivate name]): removed
        (-[WebFramePrivate setName:]): removed
        (-[WebFramePrivate dealloc]): don't release name, we no longer have one
        (-[WebFrame _appendChild:]): removed
        (-[WebFrame _removeChild:]): removed
        (-[WebFrame _createItem:]): removed stray space
        (-[WebFrame _immediateChildFrameNamed:]): Just call the bridge
        (-[WebFrame _setName:]): removed
        (-[WebFrame _detachFromParent]): remove bridge from parent note self
        (-[WebFrame _continueLoadRequestAfterNewWindowPolicy:frameName:formState:]):
        (-[WebFrame _addChild:]): Call appendChild: on bridge, not self
        (-[WebFrame _nextFrameWithWrap:]): just call bridge (and moved helpers there)
        (-[WebFrame _previousFrameWithWrap:]): just call bridge (and moved helpers there)
        (-[WebFrame _initWithWebFrameView:webView:bridge:]): don't take a name any more
        (-[WebFrame _setFrameNamespace:]): just call bridge
        (-[WebFrame _frameNamespace]): just call bridge
        (-[WebFrame _hasSelection]): remove excess braces
        (-[WebFrame _clearSelection]): ditto
        (-[WebFrame initWithName:webFrameView:webView:]): no more name
        (-[WebFrame name]): just call bridge
        (-[WebFrame findFrameNamed:]): just call bridge (and moved helpers there)
        (-[WebFrame parentFrame]): fixed for new style
        * WebView.subproj/WebFrameInternal.h:
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebView.m:
        * WebView.subproj/WebViewPrivate.h:

2006-01-03  Darin Adler  <darin@apple.com>

        Reviewed by Beth.

	This is a fix for <rdar://problem/3710994> HiDPI: Link underlines are 
	still one pixel high even if the UI resolution is > 100%

	This fix refactors -drawLineForCharacters to make its organization
	more logical. It changes behavior when printing to the screen by
	rounding the parameters of the line (x- and y-values, width, and 
	thickness) to integer boundaries in device space. Previously,
	this part of the routine just hardcoded a 1 pixel line.

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (drawHorizontalLine): This just takes care of drawing the line once everything
	has been calculated in -drawLineForCharacters
        (-[WebTextRenderer drawLineForCharacters:yOffset:width:color:thickness:]):
	Now takes device space into account. Calls drawHorizontalLine

2006-01-03  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Vicki.

        - moved frame traversal code across from bridge, also dropped the children
	array

        * WebCoreSupport.subproj/WebBridge.h:
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge dealloc]): Don't release children array, that was moved
	down to WebCore.
        (-[WebBridge saveDocumentState:]):
	- many methods moved to WebCore.
        * WebView.subproj/WebFrame.m:
        (Frame): New convenience method to get a WebFrame * from a method that
	returns WebCoreBridge *.
        (-[WebFrame _firstChildFrame]): use Frame()
        (-[WebFrame _lastChildFrame]): ditto
        (-[WebFrame _previousSiblingFrame]): ditto
        (-[WebFrame _nextSiblingFrame]): ditto
        (-[WebFrame _traverseNextFrameStayWithin:]): ditto

2006-01-03  Anders Carlsson  <andersca@mac.com>

        Reviewed by Darin.

        - Fix http://bugs.webkit.org/show_bug.cgi?id=6357
        REGRESSION: iframe and target is broken
        
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _descendantFrameNamed:sourceFrame:]):
        Return the correct frame.

2006-01-02  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Eric.

	    - moved frame traversal logic from WebFrame to WebBridge
	    http://bugs.webkit.org/show_bug.cgi?id=6341

	    To do this, I had to invert the ownership so that WebBridge now
	    owns WebFrame instead of vice versa. As a result, WebView now owns
	    a WebBridge pointer and does not have a direct WebFrame pointer.

        * WebCoreSupport.subproj/WebBridge.h:
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge initWithFrameName:view:]): The initializer is now responsible for creating
	the frame, so pass it what it needs to do that.
        (-[WebBridge dealloc]): The bridge now owns the frame, so release it.
        (-[WebBridge close]): ditto
        (-[WebBridge firstChild]): Moved from WebFrame
        (-[WebBridge lastChild]): ditto
        (-[WebBridge childCount]): ditto
        (-[WebBridge previousSibling]): ditto
        (-[WebBridge nextSibling]): ditto
        (-[WebBridge isDescendantOfFrame:]): ditto
        (-[WebBridge traverseNextFrameStayWithin:]): ditto
        (-[WebBridge appendChild:]): ditto
        (-[WebBridge removeChild:]): ditto
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _removeChild::]): Call WebBridge version
        (-[WebFramePrivate dealloc]): ditto
        (-[WebFrame _firstChildFrame]): ditto
        (-[WebFrame _lastChildFrame]): ditto
        (-[WebFrame _childFrameCount]): ditto
        (-[WebFrame _previousSiblingFrame]): ditto
        (-[WebFrame _nextSiblingFrame]): ditto
        (-[WebFrame _traverseNextFrameStayWithin:]): ditto
        (-[WebFrame _appendChild:]): ditto
        (-[WebFrame _removeChild:]): ditto
        (-[WebFrame _isDescendantOfFrame:]): ditto,
        (-[WebFrame _detachFromParent]): reorder a bit to avoid losing our bridge
	pointer before the bridge is due to release us, and don't release the
	bridge any more since it now owns us
        (-[WebFrame _initWithName:webFrameView:webView:bridge:]): new initializer,
	we no longer create the bridge, instead it is passed in
        (-[WebFrame initWithName:webFrameView:webView:]): Call the new designated
	initializer, but this method is no longer viable and should be deprecated.
        * WebView.subproj/WebFrameInternal.h:
        
	* WebView.subproj/WebView.m: WebView was changed to hold onto
	the WebBridge for the main frame instead of the WebFrame.
	
        (-[WebViewPrivate dealloc]): update for the fact that we hold
	a bridge now, not a frame.
        (-[WebView _close]): ditto
        (-[WebView _createFrameNamed:inParent:allowsScrolling:]): Create
	a bridge, not a frame.
        (-[WebView _commonInitializationWithFrameName:groupName:]): ditto.
        (-[WebView setDefersCallbacks:]): get mainFrame via method
        (-[WebView mainFrame]): Update to get the main frame properly

2005-12-30  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed by Darin, landed by ap.
        
        Test: fast/text/justified-text-rect.html
        
        - WebKit part of fix for
          http://bugs.webkit.org/show_bug.cgi?id=5461
          Text width measured incorrectly when text-align: justify

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer selectionRectForRun:style:geometry:]): Added.
        (CG_drawHighlight): Use new function CG_selectionRect.
        (CG_selectionRect): New function to compute the selection rect.
        Eliminated rounding hackery that was required for keeping the highlight
        rect within the selection rect computed by
        InlineTextBox::selectionRect, since the latter uses this function now.
        The new selection rect is wider and matches AppKit more closely,
        although the right hand side is roundf()ed instead of cielf()ed for
        optimal caret positioning.
        (ATSU_drawHighlight): Use new function ATSU_selectionRect.
        (ATSU_selectionRect): New function to compute the selection rect.
        Much like CG_selectionRect.

2005-12-29  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Eric.

        Manual testcase added:
        WebCore/manual-tests/onunload-form-submit-crash.html

        - Fixed <rdar://problem/4268278> Submitting a form in onUnload event 
        handler causes crash in -[WebDataSource(WebPrivate) _commitIfReady:] 

        The problem is that the form submission in the unload event kicks off 
        a new load in the midst of the load that caused the unload event to 
        fire in the first place, so the two loads stomp each other.

        The solution is to cancel the first load and let the unload handler's 
        load win. (Firefox does the same.)

        * WebView.subproj/WebFrame.m:
        (-[WebFrame _transitionToCommitted:]): Moved call to -closeURL up
        the call stack to _continueLoadRequest. (See below.) This has the 
        side-effect of always firing the unload event, even if the new 
        datasource never becomes committed, which seems like a good thing. 

        (-[WebFrame _continueLoadRequestAfterNavigationPolicy:formState:]):
        Call -closeURL here, instead of in _transitionToCommitted,  so that the
        unload handler can fire before we initialize any part of the load.
        
        Check provisionalDataSource for nil to discover if the unload event
        kicked off its own load.

        Cleared up some coments.

        (-[WebFrame _detachFromParent]):
        It turns out that if you close the window instead of just navigating
        to a new page, you get an alternate assertion failure/crash because
        the load kicked off by the unload event handler generates resource
        loader callbacks after the associated WebFrame/WebView has disappeared.

        The nifty solution here is just to reverse the order of calls to
        -stopLoading and -closeURL, thus guaranteeing that -stopLoading has the
        last word when you close a window.

2005-12-30  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed by Eric, committed by Maciej.
        
        - fix for http://bugs.webkit.org/show_bug.cgi?id=6288
          HEAD build broken 12/29/2005

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (overrideLayoutOperation): Use previous character from the buffer
        instead of ch which may be uninitialized on the first iteration.

2005-12-29  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Eric.

        - finished frame traversal cleanup
        http://bugs.webkit.org/show_bug.cgi?id=6293

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge childFrames]): Removed (this was unused)
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _removeChild::]): Moved to FrameTraversal category.
        (-[WebFrame _childFrameCount]): New frame traversal method to avoid
	getting the count from the array directly.
        (-[WebFrame _appendChild:]): Factored out the parts of addChild: that
	seem directly relevant to adding a child.
        (-[WebFrame _removeChild:]): Moved to FrameTraversal category.
        (-[WebFrame _detachChildren]): Don't deallocate children array because
	there's no particular need to.
        (-[WebFrame _setDataSource:]): make the assert use _childFrameCount
        (-[WebFrame _opened]):
        (-[WebFrame _checkLoadComplete]): Instead of checking all frames starting
	from the main frame, check this frame and all ancestors. If a resource
	for a frame completes, that con only possibly finish loading for that
	frame and its ancestors, not any other frame in the tree.
	(-[WebFrame _recursiveCheckLoadComplete]): Removed, no longer needed.
        (-[WebFrame _childFramesMatchItem:]): Get child frame count in the new 
	approved way.
        (-[WebFrame _internalChildFrames]): removed
	(-[WebFrame _addChild:]): Use _appendChild: for most of the work.
        (-[WebFrame _generateFrameName]): Get child frame count in the new 
	approved way.
        (-[WebFrame _stopLoadingSubframes]): Use new frame traversal mechanisms,
	upon further consideration there's no need to copy part of the frame tree here.
        (-[WebFrame findFrameNamed:]): Remove extra braces.
        (-[WebFrame childFrames]): Make a new array using the frame traversal methods.
        * WebView.subproj/WebFramePrivate.h: Remove some methods.
        * WebView.subproj/WebMainResourceLoader.m:
        (-[WebMainResourceLoader didReceiveResponse:]): Do _checkLoadComplete on the current
	frame not the main frame (before there was no difference and now the new version is
	what is desired).
        * WebView.subproj/WebView.m:
        (-[WebView _finishedLoadingResourceFromDataSource:]): Remove stray space
        (-[WebView _mainReceivedBytesSoFar:fromDataSource:complete:]): Remove stray spaces
	and update FIXME comment.
        (-[WebView _receivedError:fromDataSource:]): Remove stray space

2005-12-29  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	- abstract frame traversal in WebFrame more
	http://bugs.webkit.org/show_bug.cgi?id=6283
	
	Rewrote most of the frame traversal code in WebFrame to use DOM-style 
	first/last/next/previous methods, to abstract access better in preparation 
	for moving it down. 

	As an added bonus, many formerly recursive methods are now iterative.

        * WebKit.xcodeproj/project.pbxproj: Use gnu99 dialect of C, so that
	variables can be declared in for loop initializers.

	- added new frame traversal methods, to avoid dealing with the children array
	directly:
	
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _firstChildFrame]): New method.
        (-[WebFrame _lastChildFrame]): New method.
        (-[WebFrame _previousSiblingFrame]): New method.
        (-[WebFrame _nextSiblingFrame]): New method.
        (-[WebFrame _traverseNextFrameStayWithin:]): Like traverseNextNode() in the DOM;
	uses some of the previous.

	- apply the new methods
	
        (-[WebFrame _createItemTreeWithTargetFrame:clippedAtTarget:]): Rewrite loop
	to use new traversal methods.
        (-[WebFrame _immediateChildFrameNamed:]): ditto, also added FIXME
        (-[WebFrame _setName:]): Improved comment, removed gratuitous brace
        (-[WebFrame _isDescendantOfFrame:]): Rewrote to chase parent pointers instead
	of looking in child arrays (duh)
        (-[WebFrame _detachChildren]): Rewrite loop to use new traversal methods,
	still walk backwards for now.
        (-[WebFrame _closeOldDataSources]): Rewrite using new traversal methods.
        (-[WebFrame _childFramesMatchItem:]): ditto
        (-[WebFrame _defersCallbacksChanged]): ditto
        (-[WebFrame _viewWillMoveToHostWindow:]): ditto
        (-[WebFrame _viewDidMoveToHostWindow]): ditto
        (-[WebFrame _addChild:]): don't use childFrames method
        (-[WebFrame _removeChild:]): Clear out the sibling pointers after unlinking from the list, 
	not obvious if anything needs this but it seems like the right thing to do.
        (-[WebFrame _generateFrameName]): don't bother to nil-check children array, since
	calling count on nil still gives 0.
        (-[WebFrame _saveDocumentAndScrollState]): Rewrite to use frame traversal methods
        (-[WebFrame _deepLastChildFrame]): renamed from _lastChildFrame, rewrite to use child
	traversal methods.
        (-[WebFrame _nextFrameWithWrap:]): Use new frame traversal stuff (mostly just
	a thin wrapper on _traverseNextFrameStayWithin: 
        (-[WebFrame _previousFrameWithWrap:]): Use new traversal functions
        (-[WebFrame _numPendingOrLoadingRequests:]): Rewrite loop with new tracrsal functions
        (-[WebFrame _reloadForPluginChanges]): ditto
        (-[WebFrame _recursive_pauseNullEventsForAllNetscapePlugins]): ditto
        (-[WebFrame _recursive_resumeNullEventsForAllNetscapePlugins]): ditto
        (-[WebFrame _documentViews]): ditto
        (-[WebFrame _updateDrawsBackground]): ditto
        (-[WebFrame _unmarkAllMisspellings]): ditto
        (-[WebFrame _atMostOneFrameHasSelection]): ditto
        (-[WebFrame _findFrameWithSelection]): ditto
        (-[WebFrame _stopLoadingSubframes]): ditto
        (-[WebFrame _subframeIsLoading]): ditto
        (-[WebFrame _descendantFrameNamed:sourceFrame:]): ditto

2005-12-29  Darin Adler  <darin@apple.com>

        * WebView.subproj/WebFrameView.m: (-[WebFrameViewPrivate dealloc]):
        Removed unused "draggingTypes" instance variable.

2005-12-29  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed by darin 
        
        Test: fast/text/atsui-spacing-features.html

        - WebKit part of fix for
          http://bugs.webkit.org/show_bug.cgi?id=3922
          Variable word/letter spacing and full justification not supported for
          ATSUI-rendered text

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (overrideLayoutOperation): Add letter- and word-spacing and padding for
        justification.
        (createATSULayoutParameters): Compute padding per space.

2005-12-27  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed by Maciej, landed by Darin.

        - fix http://bugs.webkit.org/show_bug.cgi?id=4844
        Render "simple" Hebrew using the CG codepath

        * WebCoreSupport.subproj/WebTextRenderer.m: (shouldUseATSU): Exclude Hebrew letters and maqaf.

2005-12-25  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Geoff

        - Remove WebFrame's parent frame pointer, instead rely on WebCore's parent concept
        http://bugs.webkit.org/show_bug.cgi?id=6241

        * WebCoreSupport.subproj/WebBridge.h:
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge canTargetLoadInFrame:]): Use bridge parent method instead of needlessly
	asking for parent via WebFrame
        (-[WebBridge frameDetached]): Don't call _removeChild on the parent frame any more
	because WebFame's _detachFromParent takes care of that now.
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _createItemTreeWithTargetFrame:clippedAtTarget:]): Fix stray spaces
        (-[WebFrame _detachChildren]): Don't remove children as we loop any more, they
	can remove themselves.
        (-[WebFrame _detachFromParent]): Remove self from parent; don't nil out bridge
	until we are done with it.
        (-[WebFrame _transitionToCommitted:]): Remove some extra braces.
        (-[WebFrame _goToItem:withLoadType:]): Use parentFrame method in assert instead of parent
	field directly.
        (-[WebFrame _addChild:]): Don't poke at parent frame pointer in _private
	since it is not there any more.
        (-[WebFrame _removeChild:]): Remove extra braces and don't clear parent pointer
	explicitly any more.
        (-[WebFrame _addFramePathToString:]): Get parentFrame from method, not field.
        (-[WebFrame _loadDataSource:withLoadType:formState:]): Remove extra braces.
        (-[WebFrame _nextFrameWithWrap:]): Get parent in the proper way and clean up the
	coding style.
        (-[WebFrame _previousFrameWithWrap:]): Ditto.
        (-[WebFrame parentFrame]): Get parent from the bridge.

2005-12-25  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Hyatt.

	- fixed REGRESSION: world leak of WebDataSource
	http://bugs.webkit.org/show_bug.cgi?id=6242

        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource _stopLoading]): don't retain self until after
	the possible early return.

2005-12-24  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Geoff.

	- rearrange some code in WebDataSource so that more of the frame traversal logic
	is in WebFrame, in preparation for moving it down to WebBridge.
	http://bugs.webkit.org/show_bug.cgi?id=6239

        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource _archiveWithMarkupString:nodes:]): Assert that the
	data source is committed, doesn't make sense to archive otherwise.
        (-[WebDataSource _subframeArchivesWithCurrentState:]): New helper method.
        (-[WebDataSource _archiveWithCurrentState:]): Assert that the data source
	is committed. Use the helper.
        (-[WebDataSource _setWebView:]): Comment that we won't tell subframes that
	defers callback changed.
        (-[WebDataSource _startLoading]): Remove stray space.
        (-[WebDataSource _stopLoading]): Only handle local _stopLoading business.
	Cound on WebFrame to tell subframes to stop loading. Fold in _stopLoadingInternal
	and remove _recursiveStopLoading.
        (-[WebDataSource _startLoading:]): Clean up an assert slightly.
        (-[WebDataSource _setTitle:]): Remove stray spaces.
        (-[WebDataSource _defersCallbacksChanged]): Don't call subframes. WebFrame
	can do that.
        (-[WebDataSource isLoading]): Move checking of subframes down to WebFrame.
        (-[WebDataSource webArchive]): Return nil if the data source is not yet
	committed. It makes no sense to archive a provisional data source since it
	has no data yet.
        (-[WebDataSource addSubresource:]): Replace an assert with an early return,
	ASSERT is not an appropriate way to flag problems with the argument of a public
	method.
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _setLoadType:]): Remove stray space.
        (-[WebFrame _checkLoadCompleteForThisFrame]): Stop loading subframes
	manually and add a FIXME about confusingness of stopping loading here.
        (-[WebFrame _defersCallbacksChanged]): Tell our subframes.
        (-[WebFrame _addChild:]): Remove stray space.
        (-[WebFrame _stopLoadingSubframes]): New helper method.
        (-[WebFrame _subframeIsLoading]): New helper method, code moved
	from WebDataSource.
        (-[WebFrame stopLoading]): Tell subframes to stop loading.
        (-[WebFrame reload]): Remove extra braces.
        * WebView.subproj/WebFrameInternal.h:

2005-12-23  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by John.

	- move more frame tree traversal code from WebView to WebFrame

        * WebView.subproj/WebFrame.m:
        (-[WebFrame _atMostOneFrameHasSelection]): Moved this debug
	method from WebView, renamed it and changed it to return a boolean
	so it is appropriate for use in assertions instead of giving its own
	errors.
        (-[WebFrame _accumulateFramesWithSelection:]): Helper for the above.
        (-[WebFrame _findFrameWithSelection]):  Moved from WebView and renamed from
	_findSelectedFrame, also removed the skipping variant.
        (-[WebFrame _clearSelectionInOtherFrames]): Moved from WebView and
	changed how the logic works. Instead of clearing selection in any frame
	but the focus frame, it clears selection in all but this one.
        * WebView.subproj/WebFrameInternal.h:
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView becomeFirstResponder]): Call _clearSelectionInOtherFrames
        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView PDFViewWillClickOnLink:withURL:]): Stop getting WebFrame
	in needlessly roundabout way.
        (-[WebPDFView becomeFirstResponder]): Call _clearSelectionInOtherFrames
        * WebView.subproj/WebTextView.m:
        (-[WebTextView _webFrame]): New helper method.
        (-[WebTextView _elementAtWindowPoint:]): Use it.
        (-[WebTextView becomeFirstResponder]): Call _clearSelectionInOtherFrames
        (-[WebTextView resignFirstResponder]): Fix style issue
        (-[WebTextView clickedOnLink:atIndex:]): Use new helkper
        * WebView.subproj/WebView.m:
        (-[WebView selectedFrame]): Call to WebFrame as appropriate
        (-[WebView _selectedOrMainFrame]): Fix style issue
        * WebView.subproj/WebViewInternal.h:

2005-12-22  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Eric.

	- move a few more methods from WebView to WebFrame.	

        * WebView.subproj/WebFrame.m:
        (-[WebFrame _hasSelection]): Renamed from _frameIsSelected: and moved from
	WebView.
        (-[WebFrame _clearSelection]): Renamed from _deselectFrame: and moved from 
	WebView.
        * WebView.subproj/WebFrameInternal.h:
        * WebView.subproj/WebView.m:
        (-[WebView searchFor:direction:caseSensitive:wrap:]): Update for renames.
        (-[WebView _findSelectedFrameStartingFromFrame:skippingFrame:]): Ditto.
        (-[WebView _debugCollectSelectedFramesIntoArray:startingFromFrame:]): Ditto.
        (-[WebView _selectedFrameDidChange]):

2005-12-21  Timothy Hatcher  <timothy@apple.com>

        * WebKit.xcodeproj/project.pbxproj:
          Set tab width to 8, indent width to 4 and uses tabs to false per file.

2005-12-20  Alexey Proskuryakov  <ap@nypop.com>

        Reviewed by justin
        
        <http://bugs.webkit.org/show_bug.cgi?id=4682>
        -[WebHTMLView firstRectForCharacterRange:] is using _selectedRange instead of the given range if no marked text

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView firstRectForCharacterRange:]): 
        Handle some large unsigned values the way NSTextView does.
        Actually use the range passed in instead of _selectedRange,
        use of _selectedRange was a workaround that is no longer necessary.

2005-12-20  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin Adler.
        
        - fixed http://bugs.webkit.org/show_bug.cgi?id=6146
          (REGRESSION: Bold font used for Google search result pages is too thick)
          
        This is a problem with a particular font that was installed by Microsoft Office X. Though the
        font and/or lower levels of font-handling code in the system are buggy, this bad symptom will
        occur for users of Safari and other WebKit clients who happen to have one of these bad fonts.
        This adds a workaround to avoid the problem.

        * WebCoreSupport.subproj/WebTextRendererFactory.m:
        (-[WebTextRendererFactory fontWithFamilies:traits:size:]):
        When we're going to synthesize bold or italic, yet the font we looked up was apparently a
        match for the traits, try to look up a font that without the to-be-synthesized traits.
        This way, instead of applying synthetic bold over Arial Bold, we'll apply synthetic
        bold over Arial Regular, which is uglier than just using Arial Bold, but far less ugly
        than using Arial Bold with synthetic bold too.

 2005-12-16  Justin Garcia  <justin.garcia@apple.com>
 
         <rdar://problem/4103393> Frequent Safari crash on lexisnexus.com (khtml::Selection::xPosForVerticalArrowNavigation)
         <rdar://problem/4330451> CrashTracer: [REGRESSION] 2235 crashes in Safari at com.apple.WebCore: khtml::Selection::xPosForVerticalArrowNavigation const  436
         
         Reviewed by darin
         
         WebCore will crash when a selection that starts or ends in a node 
         that has been removed from the document is modify()d.  This can occur:
         (1) in non-editable regions (4103393 and 4330451), (2) in editable 
         regions (4383146) as the result of arbitrary DOM operations, and (3) in 
         Mail (4099739) as the result of an editing operation that sets a 
         bad ending selection.
         
         Crashes of type (1) can occur when the user uses the arrow keys 
         to interact with a web app, or when the user tries to use 
         command-shift-arrow to switch tabs (this is a depricated
         combo that will work if no one else responds to it). The easiest 
         way to fix these crashes is to disallow editing'ish selection changes 
         like moveDown:, selectWord:, pageDown:, etc, when the selection 
         is in a non-editable region.
         
         Crashes of type (2) will require a more complicated fix (but occur 
         much less often than type (1)).  Crashes of type (3) must be 
         fixed by tracking down the editing operation that sets bad selections.
         
         Added a layout-test:
         * editing/selection/selection-actions.html
 
         * WebView.subproj/WebHTMLView.m:
         (-[WebHTMLView _canAlterCurrentSelection]):
         (-[WebHTMLView _alterCurrentSelection:direction:granularity:]):
         (-[WebHTMLView _alterCurrentSelection:verticalDistance:]):
         (-[WebHTMLView _expandSelectionToGranularity:]):
         * WebView.subproj/WebHTMLViewPrivate.h:

2005-12-20  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by mitz
        
        Fixed more uninitialized variable warnings, and 
        removed an extra semicolon.

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (overrideLayoutOperation):
        (createATSULayoutParameters):

2005-12-20  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	- push more of frame lookup and management from WebView to
	WebFrame, this is in preparation for shifting this to WebCore
	http://bugs.webkit.org/show_bug.cgi?id=6163
	
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge closeWindowSoon]): Adjust for change to WebFrameNamespaces
        (-[WebBridge runModal]): ditto
        * WebView.subproj/WebControllerSets.h:
        * WebView.subproj/WebControllerSets.m:
        (+[WebFrameNamespaces addFrame:toNamespace:]): This now operates in terms
	of WebFrames (expected to be the main frame) not WebViews.
        (+[WebFrameNamespaces framesInNamespace:]): Ditto.
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _setFrameNamespace:]): Set self, not WebView.
        (-[WebFrame _shouldAllowAccessFrom:]): Moved this code above use
	to avoid prototyping the method.
        (-[WebFrame _descendantFrameNamed:sourceFrame:]): Ditto.
        (-[WebFrame _frameInAnyWindowNamed:sourceFrame:]): Copied logic
	over from WebView.
        (-[WebFrame findFrameNamed:]): Do it all here, don't call WebView.
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebView.m:
        * WebView.subproj/WebViewPrivate.h:

2005-12-20  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by adele.

        Fixed build failure due to missing 'b's in my last checkin.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge isStatusbarVisible]): changed 'B' to 'b'
        (-[WebBridge setStatusbarVisible:]): ditto

2005-12-20  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed by Darin, committed by Adele.

        - fix deployment builds broken by the ATSUI multiple renderers patch
        http://bugs.webkit.org/show_bug.cgi?id=6153

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (createATSULayoutParameters): Assign initial values, which will never be used,
        to substituteRenderer and firstSmallCap, to avoid uninitialized variable warnings.

2005-12-20  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by John.

        Part of fix for <rdar://problem/4310363> JavaScript window.open: Height
        is 1 pixel short, and related bugs. See WebCore ChageLog.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge webView]): Added method.

2005-12-20  Eric Seidel  <eseidel@apple.com>

        Reviewed by mjs.

        Development-only build fix.

        * WebView.subproj/WebFrame.m:
        (-[WebFramePrivate dealloc]): fixed typo

2005-12-20  Maciej Stachowiak  <mjs@apple.com>

        Not reviewed.

	- revert accidental commit of this file.

2005-12-19  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Eric.

	- Move handling of frame namespaces down to WebFrame.
	- Put some internal class declarations in the implementation file.

        * WebView.subproj/WebControllerSets.m:
        (+[WebFrameNamespaces addWebView:toFrameNamespace:]):
        (+[WebFrameNamespaces webViewsInFrameNamespace:]):
        * WebView.subproj/WebFrame.m:
        (-[WebFramePrivate dealloc]):
        (-[WebFrame _setFrameNamespace:]):
        (-[WebFrame _frameNamespace]):
        * WebView.subproj/WebFrameInternal.h:
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebView.m:
        (-[WebView _close]):
        (-[WebView _findFrameNamed:sourceFrame:]):
        (-[WebView setGroupName:]):
        (-[WebView groupName]):
        * WebView.subproj/WebViewInternal.h:

2005-12-19  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed by Darin, committed by Adele.
        
        Test: fast/text/atsui-multiple-renderers.html

        - fix http://bugs.webkit.org/show_bug.cgi?id=6139
          ATSUI code path should implement small caps, synthetic bold and oblique and correct metrics for fallback fonts

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (overrideLayoutOperation): Fetch renderer info from the renderers array;
        add synthetic bold offset; render only synthetic bold in the synthetic bold pass.
        (drawGlyphs): Replaced 14 with new SYNTHETIC_OBLIQUE_ANGLE define.
        (initializeATSUStyle): Apply a skewing transform for synthetic oblique.
        (createATSUTextLayout): Merged into createATSUTextLayout.
        (createATSULayoutParameters): Merged in createATSUTextLayout; allocate
        and fill a renderers array and a character buffer for small caps and mirroring;
        (applyMirroringToRun): Merged into createATSULayoutParameters.
        (ATSU_drawHighlight): Deleted mirroring code.
        (ATSU_draw): Deleted mirroring code; added second pass for synthetic bold.
        (ATSU_pointToOffset): Deleted mirroring code.

2005-12-19  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed by Darin, committed by Adele.
        
        Test: fast/text/atsui-kerning-and-ligatures.html

        - fix http://bugs.webkit.org/show_bug.cgi?id=6137
          Disable kerning and some ligatures in the ATSUI code path

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (initializeATSUStyle): Disable kerning; disable ligatures unless the font
        does not contain 'a', in which case it is assumed to never be rendered
        by the CG code path.

2005-12-19  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed by Darin, committed by Adele.
        
        Test: fast/text/should-use-atsui.html

        - fix for http://bugs.webkit.org/show_bug.cgi?id=6132
          Incorrect selection highlighting for ATSUI text when selected range is "CG-safe"

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (shouldUseATSU): Always start scanning from 0 since drawing and
        highlighting also measure everything up to run->from.

2005-12-17  Maciej Stachowiak  <mjs@apple.com>

        Rubber stamped by Eric.

	- remove some unused SPI headers.

        * DOM.subproj/WebDOMDocument.h: Removed.
        * DOM.subproj/WebDOMElement.h: Removed.
        * DOM.subproj/WebDOMNode.h: Removed.
        * WebKit.xcodeproj/project.pbxproj:

2005-12-17  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed and landed by Darin.

        - fix http://bugs.webkit.org/show_bug.cgi?id=5479
          Can't select text with RTL override rendered by ATSUI

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (overrideLayoutOperation): Update since the layout only includes from -> to now.
        (-[WebTextRenderer pointToOffset:style:position:includePartialGlyphs:]): Remove
        reversed parameter.
        (CG_floatWidthForRun): Add code to handle RTL case.
        (addDirectionalOverride): Put the override around the entire run.
        (ATSU_drawHighlight): Rearrange and reuse ATSU_floatWidthForRun for more of the work.
        Also round.
        (ATSU_pointToOffset): Remove reversed parameter and run swapping.
        (CG_pointToOffset): Remove reversed parameter, using rtl flag in style instead.

2005-12-16  Evan Gross  <evan@rainmakerinc.com>

        Reviewed and landed by Darin.

        - fix http://bugs.webkit.org/show_bug.cgi?id=4680
          WebHTMLView (WebNSTextInputSupport) - attributedSubstringFromRange "not yet implemented"

        * WebView.subproj/WebHTMLView.m: (-[WebHTMLView attributedSubstringFromRange:]):
        Implement by calling the same RTF conversion used when copying to the pasteboard.

2005-12-16  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed and landed by Darin.

        - fix http://bugs.webkit.org/show_bug.cgi?id=6090
          REGRESSION: Assertion failure when choosing Copy from a WebImageView's contextual menu

        * WebView.subproj/WebImageView.m:
        (-[WebImageView elementAtPoint:]): Use WebCoreElementImageRendererKey
        for the image renderer and WebElementImageKey for the image.

2005-12-15  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	- remove _frameForView: method from WebView and replace with a direct pointer on the WebFrameView in the WebFrame

        * Misc.subproj/WebNSViewExtras.m:
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _detachFromParent]):
        (-[WebFrame _loadDataSource:withLoadType:formState:]):
        (-[WebFrame initWithName:webFrameView:webView:]):
        * WebView.subproj/WebFrameView.m:
        (-[WebFrameView _setWebFrame:]):
        (-[WebFrameView webFrame]):
        * WebView.subproj/WebFrameViewInternal.h:
        * WebView.subproj/WebView.m:
        * WebView.subproj/WebViewPrivate.h:

2005-12-13  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	- remove the dead _frameForDataSource: method (WebDataSource now knows its WebFrame)
	http://bugs.webkit.org/show_bug.cgi?id=6072
	
        * WebView.subproj/WebView.m:
        * WebView.subproj/WebViewPrivate.h:

=== Safari-521~5 ===

2005-12-12  Timothy Hatcher  <timothy@apple.com>

        Reviewed by nobody, simple build fix.

        Fixes a couple ambiguous selector build errors when building with GCC 3.3.

        * Misc.subproj/WebIconDatabase.m:
        (-[WebIconDatabase releaseIconForURL:]):
        * WebView.subproj/WebHTMLView.m:
        (-[NSView _web_layoutIfNeededRecursive:testDirtyRect:]):
        (-[NSArray elementAtPoint:]):

2005-12-12  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed and checked in by John Sullivan.
        
        Fix for: http://bugs.webkit.org/show_bug.cgi?id=6053
        WebIconDatabase returns the Accessibility Verifier app icon instead of
        a generic document icon
        
        * Misc.subproj/WebIconDatabase.m:
        (-[WebIconDatabase _iconForFileURL:withSize:]):
        use file type iconForFileType:NSFileTypeForHFSTypeCode(kGenericDocumentIcon) instead of '????'
        to get the generic document icon.

2005-12-12  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Omernick.
        
        - Made protocol <WebDocumentSelection> include protocol <WebDocumentText>, for clarity.
        This required moving some methods from WebTextView, which conformed to <WebDocumentText>,
        up into superclass WebSearchableTextView, which conformed to <WebDocumentSelection>.

        * Misc.subproj/WebSearchableTextView.m:
        (-[NSString supportsTextEncoding]):
        moved this method (unchanged) from subclass WebTextView
        (-[NSString string]):
        ditto
        (-[NSString attributedString]):
        ditto
        (-[NSString selectedString]):
        ditto
        (-[NSString selectedAttributedString]):
        ditto
        (-[NSString selectAll]):
        ditto
        (-[NSString deselectAll]):
        ditto
        
        * WebView.subproj/WebDocumentPrivate.h:
        made <WebDocumentSelection> incorporate <WebDocumentText> rather than just <NSObject>
        * WebView.subproj/WebHTMLView.h:
        removed <WebDocumentText> from protocol list since it's covered by <WebDocumentSelection>
        * WebView.subproj/WebPDFView.h:
        ditto
        * WebView.subproj/WebTextView.h:
        ditto
        * WebView.subproj/WebTextView.m:
        removed the methods that were moved into WebSearchableTextView.m

2005-12-10  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan.

        - fix http://bugs.webkit.org/show_bug.cgi?id=6032
          REGRESSION: Uncaught exception when image is dragged out of webpage

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _startDraggingImage:at:operation:event:sourceIsDHTML:DHTMLWroteData:]):
        Pass the image renderer, not the NSImage.
        (-[WebHTMLView elementAtPoint:]): Add an NSImage to the dictionary, which now comes from
        WebCore with only an image renderer.
        * WebView.subproj/WebView.m: (-[WebView _writeImageElement:withPasteboardTypes:toPasteboard:]):
        Pass the image renderer, not the NSImage.

2005-12-10  Darin Adler  <darin@apple.com>

        Was getting build failures related to "count" methods.
        Made Tim's build fix Leopard-only.

        * WebView.subproj/WebPreferencesPrivate.h: Go back to <PDFKit/PDFKit.h> on Tiger.

2005-12-09  John Sullivan  <sullivan@apple.com>

        Reviewed by Adele Peterson.
        
        - fixed <rdar://problem/4373905> Cannot paste in Tiger Mail using TOT WebKit

        * WebView.subproj/WebView.m:
        (-[WebView _frameForCurrentSelection]):
        I removed this method many moons ago when restructuring the code involving frames and selection.
        Too bad Mail was still using it (d'oh!). In Leopard Mail has updated to use newer SPI (which should
        become API), but to continue to work with Mail on Tiger we need this method to be around. Now it's
        just a cover for the method _selectedOrMainFrame, to which it was renamed so very long ago.

2005-12-09  Tim Omernick  <timo@apple.com>

        Reviewed by John Sullivan.

        * Carbon.subproj/HIWebView.m:
        (UpdateCommandStatus):
	Don't call -performSelector:withObject: on a method that returns a BOOL; this is not guaranteed to work on all architectures.
	-performSelector:withObject:'s return value should only be checked if the method returns an object.

2005-12-09  Timothy Hatcher  <timothy@apple.com>

        Reviewed by nobody, build fix.

        Using <PDFKit/PDFKit.h> was causing build failures for the Mail team.
        The comment about getting an ambiguous signature conflict anywhere the
        method "count" is used seems to no longer be an issue.

        * WebView.subproj/WebPreferencesPrivate.h: Use <Quartz/Quartz.h>

2005-12-08  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Hatcher.
        
        Some cleanup of how selection rects are associated with NSViews.

        * WebView.subproj/WebDocumentPrivate.h:
        Added a -selectionView method to <WebDocumentSelection>, and clarified that the
        selectionRect is in the coordinate system of this view.

        * Misc.subproj/WebSearchableTextView.m:
        (-[WebSearchableTextView selectionView]):
        new method, returns self
        
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView selectionView]):
        new method, returns self
        
        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView selectionRect]):
        translate result into coordinate system of [PDFSubview documentView]
        (-[WebPDFView selectionView]):
        new method, returns [PDFSubview documentView]

2005-12-08  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Omernick and Dave Hyatt.
        
        - fixed these semi-legendary bugs:
        <rdar://problem/4032405> Inline PDF doesn't get keyboard focus like web pages do, so can't scroll with keys without clicking
        <rdar://problem/4265684> PDFs use secondary selection when displaying found text (4748)

        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView becomeFirstResponder]):
        Discovered that there is indeed PDFKit API for accessing the view that becomes focused; now
        passes the focus down to that view.

2005-12-08  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Omernick.
        
        - Added WebKit mechanism to help correctly pass the first responder into the PDF view hierarchy,
        in order to start addressing keyboard focus and selection highlight issues. Unfortunately this 
        doesn't actually have any user effect yet due to problems that must be fixed in PDFKit.

        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView acceptsFirstResponder]):
        Overridden to returns YES. Needed so NSClipView knows it's OK to pass focus down to this level.
        (-[WebPDFView becomeFirstResponder]):
        With setNextKeyView:, splices the PDF view into the focus-passing mechanism in much the same
        way as NSScrollView and NSClipView.
        (-[WebPDFView setNextKeyView:]):
        With becomeFirstResponder:, splices the PDF view into the focus-passing mechanism in much the same
        way as NSScrollView and NSClipView.
        (-[WebPDFView resignFirstResponder]):
        Removed this method because the WebPDFView itself is never first responder except transiently.

2005-12-08  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by John.

	- some small changes towards frame tree refactoring

	Renamed WebViewSets to WebFrameNamespaces, and put the method for
	performing a selector on all extant WebViews to WebView itself,
	with a separate set tracking live WebViews. This should allow
	moving the storage of this info down to WebCore more easily.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge closeWindowSoon]):
        (-[WebBridge runModal]):
        * WebCoreSupport.subproj/WebViewFactory.m:
        (-[WebViewFactory refreshPlugins:]):
        * WebView.subproj/WebControllerSets.h:
        * WebView.subproj/WebControllerSets.m:
        (+[WebFrameNamespaces addWebView:toFrameNamespace:]):
        (webView::if):
        (+[WebFrameNamespaces webViewsInFrameNamespace:]):
        * WebView.subproj/WebView.m:
        (+[WebView _makeAllWebViewsPerformSelector:]):
        (-[WebView _removeFromAllWebViewsSet]):
        (-[WebView _addToAllWebViewsSet]):
        (-[WebView _close]):
        (-[WebView _findFrameNamed:sourceFrame:]):
        (-[WebView _commonInitializationWithFrameName:groupName:]):
        (-[WebView setGroupName:]):
        * WebView.subproj/WebViewInternal.h:

2005-12-08  Darin Adler  <darin@apple.com>

        Reviewed by Eric.

        - fixed http://bugs.webkit.org/show_bug.cgi?id=5689
          add support for CSS "custom cursors" (cursor images)

        * WebCoreSupport.subproj/WebImageRenderer.h: Remove declaration of TIFFRepresentation and
        image methods since both are required by the WebCoreImageRenderer protocol now and we don't
        have to re-declare them.

        * Misc.subproj/WebNSPasteboardExtras.m: Add an import of the WebCoreImageRenderer.h file
        since we need to use methods inherited from that protocol.
        * Misc.subproj/WebNSViewExtras.m: Ditto.
        * WebCoreSupport.subproj/WebImageRenderer.m: Ditto. (Use and implement.)

2005-12-07  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed by Maciej, landed by Darin.

        - fix http://bugs.webkit.org/show_bug.cgi?id=5878
          REGRESSION (WebTextRenderer.m r1.201): pointToOffset always takes the CG code path

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer pointToOffset:style:position:reversed:includePartialGlyphs:]):
        Added the missing "return".

2005-12-07  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Omernick.
        
        - <rdar://problem/4331488> TOT Assertion failure in -[WebHTMLView nextValidKeyView] 
        @ home.netscape.com

        * WebView.subproj/WebHTMLView.m:
        (-[NSArray nextValidKeyView]):
        Removed assert that I added a while back. In this case at least, the assertion is
        overzealous, and I can't recreate the tortured chain of logic that led me to adding
        this assertion in the first place.

2005-12-06  David Harrison  <harrison@apple.com>

	Reviewed by Darin.

	- fix <rdar://problem/4365308> Glendale Regression: Floating dictionary doesn't work well in Safari text areas/fields
	
	Add use of NSAccessibilityHitTest to the list of exceptions.

	* WebView.subproj/WebHTMLView.m:
	(-[WebHTMLView hitTest:]): check for NSFlagsChanged event. 

2005-12-05  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin Adler.

        * WebView.subproj/WebHTMLView.m:
        (-[NSArray validateUserInterfaceItem:]):
        one more tweak: moved jumpToSelection: to be validated the same way as
        centerSelectionInVisibleArea:, since it now calls the same code. Might not
        make a difference in any real code, but you never know.

2005-12-05  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin Adler.

        * WebView.subproj/WebHTMLView.m:
        (-[NSArray validateUserInterfaceItem:]):
        removed double handling of centerSelectionInVisibleArea

2005-12-05  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Omernick.
        
        - WebKit part of fix for 
        <rdar://problem/4365690> Find > Jump to Selection does nothing on plain-text documents (inc. source HTML)        

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView jumpToSelection:]):
        Reimplement jumpToSelection: to call centerSelectionInVisibleArea:, and added a comment explaining why
        jumpToSelection: exists at all. Note that centerSelectionInVisibleArea: was already implemented here; it
        was added as part of HTML editing implementation without us realizing that it was the API replacement
        for jumpToSelection:.
        (-[WebHTMLView validateUserInterfaceItem:]):
        validate centerSelectionInVisibleArea: the same way we validate jumpToSelection: (we should have done
        this when centerSelectionInVisibleArea: was implemented)
        
        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView centerSelectionInVisibleArea:]):
        new method, same code that jumpToSelection: used to have
        (-[WebPDFView jumpToSelection:]):
        now calls centerSelectionInVisibleArea:, and there's now a comment about why it exists at all.
        (-[WebPDFView validateUserInterfaceItem:]):
        validate centerSelectionInVisibleArea: the same way we validate jumpToSelection:

2005-12-04  Tim Omernick  <timo@apple.com>

        Reviewed by Dave Harrison, John Sullivan.

	<rdar://problem/4364847> REGRESSION: QuickTime movies open without controller or don't open at all (5928)

	I changed WebFrameView on 2005-11-29 so that it avoids creating duplicate WebPluginDocumentViews.
	Unfortunately, this change caused a regression due to the fact that it subtly changed when plugins are
	initialized.  Certain plugins (e.g. QuickTime) expect to be initialized after the WebPluginDocumentView
	has been "committed" (inserted into the view hierarchy).

	My fix is to ensure that the plugin is initialized where we previously would have created that second
	WebPluginDocumentView -- that is, the plugin is created after the WebPluginDocumentView has been committed.
	
        * Plugins.subproj/WebPluginDocumentView.m:
        (-[WebPluginDocumentView setDataSource:]):
	Don't initialize the plugin if the WebPluginDocumentView has not been inserted into the view hierarchy.
	We assume here that a later call to -setDataSource: will pass this conditional, once the WebDocumentView
	has been committed.
	
2005-12-02  Justin Garcia <justin.garcia@apple.com>

        <rdar://problem/4345030>
        Denver REGRESSION (10.4.2-10.4.3): Two identical warnings on "Back" from Amazon's package tracker
        
        Before checking the navigation policy for a request, the request is compared
        against the last checked request.  If the two are the same, no check is done.
        In the bug, the two requests are identical except for the boolean on
        NSURLRequests that tells Foundation to support multipart loads for that request.
        One request was the one that was used to start servicing "Back" operation, and
        the second was being used to start loading the page (it needed to be reloaded 
        because it was the result of a form submission). Set the boolean on all 
        NSURLRequests, not just one's that are about to be used to start a load.   

        Reviewed by harrison

        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource _startLoading:]):
        (-[WebDataSource initWithRequest:]):
        * WebView.subproj/WebDataSourcePrivate.h:

2005-12-01  Darin Adler <darin@apple.com>

        Reviewed by Vicki.
	
	- fix <rdar://problem/4349721> Regression: Hovering over menu item doesn't highlight menu item or 
	mousing up on menu item in applet does not open URL in new window at smartmoney.com

	Since Java depends on doing a hit test inside it's mouse moved handling, let hit testing on Java 
	applets go through the standard NSView code path. Since this should only happen for Java, add a global
	so that we can Use our own WebHTMLView hit testing when calling from _updateMouseoverWithEvent.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _hitViewForEvent:]): rename forceRealHitTest to forceNSViewHitTest
        (-[WebHTMLView _updateMouseoverWithEvent:]): set global variable  to force a WebHTMLView-style hit test from here
        (-[WebHTMLView hitTest:]): perform the appropriate hit test based on global variables 

2005-11-29  Andrew Wellington  <proton@wiretapped.net>

        Reviewed by darin.  Committed by eseidel.

        Fix for: http://bugs.webkit.org/show_bug.cgi?id=4726
        Drop of multiple non-image file URLs only yields one item

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _documentFragmentWithPaths:]):

2005-11-29  Tim Omernick  <timo@apple.com>

        Reviewed by John Sullivan, Eric Seidel

	<rdar://problem/4340787> Safari & Dashcode create 2 instances of the QC plug-in
	
        * WebView.subproj/WebFrameView.m:
        (-[WebFrameView _makeDocumentViewForDataSource:]):
	Instead of creating a new WebDocumentView, use the WebDataSource's representation if it is a WebDocumentView
	of the appropriate class.  Right now, this can only happen when the loading document is a standalone WebKit
	plugin, because WebPluginDocumentView is both the WebDocumentView and the WebDocumentRepresentation for that
	kind of page load.
	
	I have verified that this does not affect other kinds of page loads; in all other cases, the representation
	class is distinct from the document view class.

	I talked with Chris Blumenberg about this change (he knows this code), and he agreed that this is the right
	approach.

2005-11-28  Alexey Proskuryakov  <ap@nypop.com>

        Reviewed by Darin. Committed by Maciej.

	- fixed "Word completion doesn't work at end of word (unless last word)"
	(http://bugs.webkit.org/show_bug.cgi?id=4062)

        * WebView.subproj/WebHTMLView.m:
        (-[WebTextCompleteController doCompletion]):

2005-11-28  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Omernick.
        
        Probable fix for <rdar://problem/4356060> crash in -[WebHistoryItem _mergeAutoCompleteHints:]

        * History.subproj/WebHistory.m:
        (-[WebHistoryPrivate addItem:]):
        retain/release oldEntry until we're done with it, since removing it from dictionary might
        cause it to be dealloc'ed otherwise.
        
        * History.subproj/WebHistoryItem.m:
        (-[WebHistoryItem _mergeAutoCompleteHints:]):
        added an assert

2005-11-26  Alexey Proskuryakov  <ap@nypop.com>

        Reviewed by mjs.  Committed by eseidel.

        Fix for http://bugs.webkit.org/show_bug.cgi?id=5230
        "characterIndexForPoint: not yet implemented"

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView characterIndexForPoint:]):
        (-[WebHTMLView firstRectForCharacterRange:]):

2005-11-22  Darin Adler  <darin@apple.com>

        * WebView.subproj/WebView.h: Fixed incorrect comment in public header.

2005-11-18  Vicki Murley  <vicki@apple.com>

	Changes by Tim H, reviewed by Vicki.

	- call shouldClose on the bridge for the main frame

        * WebView.subproj/WebView.m:
        (-[WebView shouldClose]):

2005-11-18  Vicki Murley  <vicki@apple.com>

        Changes by Darin, reviewed by Beth and Vicki.

        - fix <rdar://problem/3939265> support "before unload" event and onbeforeunload handler (supported by both IE and Mozilla)

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge canRunBeforeUnloadConfirmPanel]):
        (-[WebBridge runBeforeUnloadConfirmPanelWithMessage:]):
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _checkNavigationPolicyForRequest:dataSource:formState:andCall:withSelector:]):
        (-[WebFrame _continueLoadRequestAfterNavigationPolicy:formState:]):
        * WebView.subproj/WebUIDelegatePrivate.h:
        * WebView.subproj/WebView.m:
        (-[WebView shouldClose]):
        * WebView.subproj/WebViewPrivate.h:

2005-11-10  Maciej Stachowiak  <mjs@apple.com>

        Build fix, not reviewed.

        * Plugins.subproj/WebBaseNetscapePluginViewInternal.h: Added.

2005-11-10  Tim Omernick  <timo@apple.com>

        Reviewed by Geoff.

	<rdar://problem/4237941> Dashboard needs a way to stop Netscape plug-ins from getting null events

        * Plugins.subproj/WebBaseNetscapePluginViewInternal.h: Added.
	Added WebInternal category, with -stopNullEvents and -restartNullEvents.  These methods already exist on WebBaseNetscapePluginView.
	I am just exposing them	to callers elsewhere within WebKit.

        * WebKit.xcodeproj/project.pbxproj:
	Added WebBaseNetscapePluginViewInternal.h.

        * WebView.subproj/WebFrame.m:
        (-[WebFrame _recursive_pauseNullEventsForAllNetscapePlugins]):
	Walks down the web frame hierarchy and calls -_pauseNullEventsForAllNetscapePlugins on each WebHTMLView.
        (-[WebFrame _recursive_resumeNullEventsForAllNetscapePlugins]):
	Same as above, but calls -_resumeNullEventsForAllNetscapePlugins.
	
        * WebView.subproj/WebFramePrivate.h:
	Declared -_recursive_pauseNullEventsForAllNetscapePlugins and -_recursive_pauseNullEventsForAllNetscapePlugins.
	
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _pauseNullEventsForAllNetscapePlugins]):
	Checks subviews for WebBaseNetscapePluginViews, and calls -stopNullEvents on them.
        (-[WebHTMLView _resumeNullEventsForAllNetscapePlugins]):
	Same as above, but calls -restartNullEvents.

        * WebView.subproj/WebHTMLViewInternal.h:
	Declared -_pauseNullEventsForAllNetscapePlugins and -_resumeNullEventsForAllNetscapePlugins.

2005-11-07  Geoffrey Garen  <ggaren@apple.com>

        Darin reviewed this a while back.

        - Fixed <rdar://problem/4161660> window.close followed by window.print
        in onload handler crashes Safari in KJS::ScopeChain::bottom
        (redmccombstoyota.com)
        
        Added a call to stopLoading inside closeWindowSoon to prevent load
        events from firing after a window has torn down.
        
        Manual test case: WebCore/manual-tests/window-close-during-parsing.html

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge closeWindowSoon]):

2005-11-03  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin and Vicki.

        * WebKit.xcodeproj/project.pbxproj:
          Change to use $(SYSTEM_LIBRARY_DIR) consistently and place
          $(NEXT_ROOT) in a few spots to make build-root work.

2005-11-01  Tim Omernick  <timo@apple.com>

        Reviewed by John Sullivan.

	<rdar://problem/4318632>

	I've added a new notification, WebPluginWillPresentNativeUserInterfaceNotification.  Plugins are expected to post this
	notification before presenting "native UI", such as dialog boxes.  A Dashboard client can observe this notification to
	hide the Dashboard layer when plugins present external UI.
	
        * English.lproj/StringsNotToBeLocalized.txt:
	Added "WebPluginWillPresentNativeUserInterface".

        * Plugins.subproj/WebPluginsPrivate.h: Added.
        * Plugins.subproj/WebPluginsPrivate.m: Added.
	Declare WebPluginWillPresentNativeUserInterfaceNotification.

        * WebKit.xcodeproj/project.pbxproj:
	Added WebPluginsPrivate.[hm]

	* WebKit.exp:
	Added _WebPluginWillPresentNativeUserInterfaceNotification.

2005-11-01  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin Adler.
        
        fixed deployment build by hiding local variables used only in ASSERTs on builds for
        which ASSERT_DISABLED is true.

        * History.subproj/WebHistory.m:
        (-[WebHistoryPrivate removeItemForURLString:]):
        (-[WebHistoryPrivate setLastVisitedTimeInterval:forItem:]):

2005-11-01  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Omernick.
        
        - fixed <rdar://problem/4324104> Assertion failure (foundDate) in WebHistory
        
        WebFrame was updating the last visited date on a WebHistoryItem behind WebHistory's
        back, causing WebHistory's caches of items by date to get out of sync with reality.
        Changed to set the date through WebHistory rather than directly.

        * History.subproj/WebHistory.m:
        (-[WebHistoryPrivate _removeItemFromDateCaches:]):
        New method, extracted from removeItemForURLString.
        (-[WebHistoryPrivate removeItemForURLString:]):
        Now calls extracted method. Cleaned up white space a little.
        (-[WebHistoryPrivate _addItemToDateCaches:]):
        New method, extracted from addItem:
        (-[WebHistoryPrivate addItem:]):
        Now calls extracted method. Cleaned up white space a little.
        (-[WebHistoryPrivate setLastVisitedTimeInterval:forItem:]):
        New method, removes item from date caches, changes date, then adds item back to
        date caches and sends notification.
        (-[WebHistory setLastVisitedTimeInterval:forItem:]):
        New method, cover for WebHistoryPrivate version.
        
        * History.subproj/WebHistoryItem.m:
        (-[WebHistoryItem _setLastVisitedTimeInterval:]):
        Don't send notification here; send from new WebHistory method instead.
        
        * History.subproj/WebHistoryItemPrivate.h:
        Added comment about avoiding incorrect use of _setLastVisitedTimeInterval:
        * History.subproj/WebHistoryPrivate.h:
        Added declarations for WebHistory and WebHistoryPrivate versions of 
        setLastVisitedTimeInterval:forItem:
        
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _transitionToCommitted:]):
        change history item's date via new WebHistory method rather than directly

2005-10-25  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        Remove the use of a stamp file in the Frameworks symlink build phase.
        This lets us pass the build verification.

        * WebKit.xcodeproj/project.pbxproj:

2005-10-24  Darin Adler  <darin@apple.com>

        Reviewed by Geoff.

        - change internal methods in WebTextRenderer to be functions in case this
          has any effect on speed (also makes things a bit clearer, in my opinion)

        * WebCoreSupport.subproj/WebTextRenderer.h: Made all fields public, which is
        OK since this is really a private class. Made setAlwaysUseATSU: class method
        public too for the same reason.

        * WebCoreSupport.subproj/WebTextRenderer.m: Change all methods to functions.
        (destroy): Function name for method free.
        (-[WebTextRenderer drawLineForCharacters:yOffset:width:color:thickness:]): Removed code to first subtract
        lineSpacing - descent, then later add it back.
        (getSmallCapsRenderer): Function name for method smallCapsRenderer.
        (findSubstituteFont): Function name for method substituteFontForString:families:.
        (findSubstituteRenderer): Function name for method substituteRendererForCharacters:length:families:.
        (updateGlyphMapEntry): Function name for method updateGlyphEntryForCharacter:glyphID:substituteRenderer:.
        (extendGlyphMap): Function name for method extendCharacterToGlyphMapToInclude:.
        (extendWidthMap): Function name for method extendGlyphToWidthMapToInclude:.
        (getTextBounds): Function name for method trapezoidForRun:style:atPoint:.

2005-10-24  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed by Darin.  Committed by David Harrison.

        http://bugs.webkit.org/show_bug.cgi?id=5415
        "Left border of selection highlight leaves behind a trail"
        
        * manual-tests/drag_select_highlighting.html: Added.
        (this test case was added to WebCore)
   
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (overrideLayoutOperation):
        (-[WebTextRenderer CG_drawHighlightForRun:style:geometry:]):
        (-[WebTextRenderer ATSU_drawHighlightForRun:style:geometry:]):
        (advanceWidthIterator):


2005-10-23  Tim Omernick  <tomernick@apple.com>

        Reviewed by Dave Hyatt.

	<http://bugs.webkit.org/show_bug.cgi?id=5365>

	Send -webPlugInStop (or -pluginStop) and -webPluginDestroy (or -pluginDestroy)
	to complying plugins right when they're removed from the WebHTMLView, and also
	release them from the plugin controller's arrays.
	
	I think this patch makes WebKit behave more like plugins expect it to, which is
	the way it already behaves with Netscape plugins.
	
	I expect complying plugins to stop making noise when receiving the stop
	message, but QuickTime doesn't. If it's lucky, then it will be deallocated
	because of the release and will stop then. However, JS, for one, can retain the
	plugin (e.g. if you execute <javascript:document.getElementById('obj').width;>
	before clicking Remove OBJECT), in which case it will just keep playing.
	
        * Plugins.subproj/WebPluginController.h:
        * Plugins.subproj/WebPluginController.m:
        (-[WebPluginController destroyPlugin:]):
	Stop and destroy the plugin.
        * WebView.subproj/WebHTMLView.m:
        (-[NSArray willRemoveSubview:]):
	Destroy plugins when they are removed from the HTML view.
	
2005-10-23  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Maciej.

        For better abstraction, made the tokenizer -- instead of the 
        data source -- responsible for calling [WebFrame _checkLoadComplete]
        when the tokenizer stops.

        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource _stopLoadingInternal]):

2005-10-21  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by darin.
        
        WebKit side of the fix for <rdar://problem/4184719> window.print() followed by 
        window.close() causes world leak
        
        No test case added because I have another reviewed patch that will include a test
        for this bug as well as many others.

        Under some conditions, [WebDataSource stopLoading] did not set [WebDataSource isLoading]
        to false, so the didFInishLoad delegates never fired.
        
        The reason isLoading didn't become false was that the tokenizer was still running.
        The fix here is to move the call to [WebCoreBridge stopLoading] above the early return
        inside [WebDataSource stopLoading] -- since the tokenizer may still be running even if the
        loader is finished loading -- and then to call [WebFrame _checkLoadComplete] to 
        give the frame a chance to fire its delegates.
        
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource _stopLoadingInternal]):

2005-10-21  Beth Dakin  <bdakin@apple.com>

        Reviewed by Darin??

	Fix for <rdar://problem/3853672> Malformed HTML using crashes Safari in NSFireTimer

	The webFrame was being deleted prematurely by a call to stop(), so we changed it
	so that the calls to _receivedMainResourceError and _mainReceivedError happen 
	before the stop(), and we retain the bridge.

        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource _receivedMainResourceError:complete:]):

2005-10-21  Geoffrey Garen  <ggaren@apple.com>

        Patch by TimO, Reviewed by hyatt, tested and landed by me.

        Found what appears to be a misguided optimization that actually causes a measurable performance problem.
        A fixed-size buffer was allocated on the stack to pass into CFURLGetBytes(), presumably to avoid malloc()
        for URLs less than 2048 bytes.  There was also a fallback which malloc()'ed a buffer in case the fixed-size
        buffer was too small to hold the URL's bytes.  This malloc()'ed buffer was then wrapped in an NSData using
        +dataWithBytesNoCopy:length:, avoiding a memory copy (yay!)

        The problem with this approach is two-fold:
    
        1. Regardless of how the buffer was allocated and filled, it is immediately wrapped in an NSData using
        +dataWithBytes:length:, which copies the input bytes.  This is pretty much unavoidable; we need to get
        the data into a malloc()'ed buffer to return it to the caller, unless the caller provides its own storage
        (which would be super inconvenient).
    
        2. The size of the fixed buffer was large enough that it fit most (if not all) URLs involved in our Page
        Load Test.  This means the unintentionally-inefficient case was by far the most *common* case!
        
        My fix is to malloc() the buffer from the start, and then use +[NSData dataWithBytes:length:freeWhenDone:]
        to wrap the buffer in an NSData.  This avoids a memory copy for the normal case where a URL is less than
        2048 bytes, and keeps the efficient behavior for the uncommon long URL case.

        * Misc.subproj/WebNSURLExtras.m:
        (-[NSURL _web_originalData]):

2005-10-21  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed and landed by Darin.

        - fixed a couple regressions caused by my last check-in
          http://bugs.webkit.org/show_bug.cgi?id=5437
          http://bugs.webkit.org/show_bug.cgi?id=5443

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer CG_drawHighlightForRun:style:geometry:]): Compute background width
        correctly, by subtracting position after run from position before run.
        (addDirectionalOverride): Make the range include only the characters between the
        directional override characters, not the directional override characters themselves.
        (initializeWidthIterator): Correctly compute "widthToStart" based on the offset to
        the beginning of the run, not to the end of the run!

2005-10-19  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - optimizations for a total of about 1% speed-up on PLT

        * WebCoreSupport.subproj/WebTextRenderer.h: Updated to use bool instead of BOOL,
        since BOOL is a signed char (which is not so efficient, at least on PPC).
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (isSpace): Changed BOOL to bool and UniChar to UChar32. This actually fixes a
        potential bug when the passed-in character is a non-BMP character (> FFFF).
        (isRoundingHackCharacter): Ditto.
        (widthForGlyph): Merged getUncachedWidth, widthFromMap, and widthForGlyph into
        one function. Marked it inline. Changed to include syntheticBoldOffset in the
        cached widths to save an add in the cached case. Instead of the special constant
        UNINITIALIZED_GLYPH_WIDTH, just check for a width >= 0. This allows us to use
        a negative number or NAN for the uninitialized width value -- I chose NAN.
        (overrideLayoutOperation): Use bool instead of Boolean in one place.
        (-[WebTextRenderer initWithFont:]): Use lroundf instead of ROUND_TO_INT.
        (-[WebTextRenderer floatWidthForRun:style:]): Put the code to choose the ATSU
        vs. CG code path back in here, because there are no callers inside the class
        that need to call both.
        (-[WebTextRenderer drawLineForCharacters:yOffset:width:color:thickness:]):
        Use bool instead of BOOL.
        (+[WebTextRenderer setAlwaysUseATSU:]): Ditto.
        (fontContainsString): Ditto.
        (-[WebTextRenderer computeWidthForSpace]): Ditto. Also use roundf instead of
        using ROUND_TO_INT.
        (-[WebTextRenderer setUpFont]): Use bool instead of BOOL.
        (drawGlyphs): Ditto.
        (-[WebTextRenderer CG_drawHighlightForRun:style:geometry:]): Restructure the
        code so it can use the new advanceWidthIterator function instead of the old
        widthForNextCharacter function.
        (-[WebTextRenderer CG_drawRun:style:geometry:]): Use malloc instead of calloc
        since we don't need initialization. Call CG_floatWidthForRun instead of
        floatWidthForRun -- no need to re-check whether to use the CG or ATSU code path.
        Removed code to handle a renderer of 0 since we no longer generate that in
        the renderers array in advanceWidthIterator.
        (CG_floatWidthForRun): Changed to call the new advanceWidthIterator instead of
        the old widthForNextCharacter.
        (-[WebTextRenderer extendCharacterToGlyphMapToInclude:]): Use malloc instead of
        calloc and explicitly initialize the one field that needs it. Fixed a potential
        storage leak by adding a call to WKClearGlyphVector. Initialize the renderers
        to self instead of to 0.
        (-[WebTextRenderer extendGlyphToWidthMapToInclude:]): Initialize the widths to
        NAN instead of UNINITIALIZED_GLYPH_WIDTH.
        (addDirectionalOverride): Fixed bug where the first and last character in the buffer
        could be uninitialized and where characters before and after the direction override
        could be incorrect.
        (-[WebTextRenderer ATSU_drawRun:style:geometry:]): Use bool instead of BOOL.
        (-[WebTextRenderer ATSU_pointToOffset:style:position:reversed:includePartialGlyphs:]):
        Ditto.
        (advanceWidthIteratorOneCharacter): Added new helper function for CG_pointToOffset.
        (-[WebTextRenderer CG_pointToOffset:style:position:reversed:includePartialGlyphs:]):
        Reimplemented to use advanceWidthIteratorOneCharacter instead of widthForNextCharacter.
        Also call CG_floatWidthForRun instead of floatWidthForRun since we don't need to
        reconsider whether to use CG or ATSU.
        (glyphForCharacter): Removed the map parameter and changed the renderer parameter to
        be an in-out one. Removed uneeded special case for when map is 0 and always get the
        renderer from the map. Also call extendCharacterToGlyphMapToInclude in here instead of
        making that the caller's responsibility.
        (initializeWidthIterator): Renamed to make the name shorter (removed "Character").
        Streamlned common cases like "no padding" and removed some unneeded casts. Changed to
        use advanceWidthIterator to compute width fo the first part of the run.
        (normalizeVoicingMarks): Factored this out into a separate function, since it's not part
        of the common case.
        (advanceWidthIterator): Changed widthForNextCharacter to this, eliminating per-character
        function overhead for iterating past a few characters. Merged the handling of surrogate
        pairs and of voicing marks so that we typically only have to do one "if" to rule out both.
        Merged the mirroring for RTL and uppercasing for small caps into a single boolean so that
        we only need one "if" to rule out both. Call the new glyphForCharacter. Check for the
        character '\t' first since that's cheaper than looking at tabWidth. Check tabWidth for 0
        first so that we don't have to convert it to floating point when not using it. Changed
        the special case for spaces to first check width, so that we don't bother with the rest
        of the code for glyphs not the same width as spaces. Fixed substitution code to call
        CG_floatWidthForRun -- no need to reconsider whether to use CG or ATSU. Also changed to
        properly get width from the result of that function. Merged the handling of letter spacing,
        padding, and word spacing into a single boolean so that we typically only have to do one
        "if" to rule out all three. Check for letterSpacing of 0 first so that we don't have to
        convert it to floating point when not using it. Same for padding and wordSpacing.
        Move the work from ceilCurrentWidth in line into this function. Assume that either we have
        all three pointers (widths, renderers, glyphs), or none of the three, to cut down on branches.
        (fillStyleWithAttributes): Use bool instead of BOOL.
        (shouldUseATSU): Ditto.

        * Misc.subproj/WebKitNSStringExtras.m: (-[NSString _web_widthWithFont:]): Update since
        the floatWidthForRun method no longer takes a widths parameter.
        * Misc.subproj/WebStringTruncator.m: (stringWidth): Ditto.

2005-10-19  Tim Omernick  <tomernick@apple.com>

        Reviewed by eseidel & darin.

	Changed some of the run measurement methods to C functions
        to avoid overhead associated with objc_msgSend().
		
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer floatWidthForRun:style:widths:]):
	Updated to call new run measurement functions instead
        of calling ObjC methods.
        (-[WebTextRenderer CG_drawRun:style:geometry:]): ditto
        (floatWidthForRun): ditto
        (CG_floatWidthForRun): ditto
        (ATSU_floatWidthForRun): ditto
        (widthForNextCharacter): ditto

2005-10-14  Vicki Murley  <vicki@apple.com>

	Changes by Mitz Pettel, reviewed by Maciej.

	Fix http://bugs.webkit.org/show_bug.cgi?id=5029 (Assertion failure in -[NSPasteboard(WebExtras) 
	_web_writeImage:URL:title:archive:types:] when trying to drag an image from a site with no favicon)

        * Misc.subproj/WebNSPasteboardExtras.m:
        (-[NSPasteboard _web_writeImage:URL:title:archive:types:]): Prefer the main resource if it is an image

2005-10-12  Vicki Murley  <vicki@apple.com>

        Reviewed by Darin.

	- fix <rdar://problem/4043643> iframe swallows events for overlapping elements (3449)

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView hitTest:]): 
        (-[WebHTMLView _updateMouseoverWithEvent:]): eliminate _hitViewForEvent hackery and self
	dependency from this function

2005-10-12  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.
        
        Define WebNSInt and WebNSUInt to wrap around NSInt on Leopard and still build on Tiger
        Once building on Tiger isn't needed we will drop WebNSInt and use NSInt

        * WebView.subproj/WebDefaultResourceLoadDelegate.m:
        (-[WebDefaultResourceLoadDelegate webView:resource:didReceiveContentLength:fromDataSource:]):
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _sendRemainingDelegateMessagesWithIdentifier:response:length:error:]):
        * WebView.subproj/WebLoader.m:
        (-[NSURLProtocol didReceiveData:lengthReceived:]):
        * WebView.subproj/WebResourceLoadDelegate.h:
        * WebView.subproj/WebUIDelegate.h:
        * WebView.subproj/WebView.h:
        * WebView.subproj/WebView.m:
        (-[WebView _mouseDidMoveOverElement:modifierFlags:]):
        (-[WebView spellCheckerDocumentTag]):
        * WebView.subproj/WebViewInternal.h:
        * WebView.subproj/WebViewPrivate.h:

2005-10-12  Darin Adler  <darin@apple.com>

        * WebView.subproj/WebPolicyDelegate.h: Fix a comment.

2005-10-11  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.
        
        Test for 10.4 because of <rdar://problem/4243463>

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView conversationIdentifier]):

2005-10-11  Adele Peterson  <adele@apple.com>

        Rolling out fix for http://bugs.webkit.org/show_bug.cgi?id=5195
        since it caused:

        REGRESSION text areas draw focus ring around each glyph, no caret in text fields
        http://bugs.webkit.org/show_bug.cgi?id=5335

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _propagateDirtyRectsToOpaqueAncestors]):
        (-[WebHTMLView _recursiveDisplayRectIfNeededIgnoringOpacity:isVisibleRect:rectIsVisibleRectForView:topView:]):
        (-[WebHTMLView _recursiveDisplayAllDirtyWithLockFocus:visRect:]):

2005-10-09  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fixed http://bugs.webkit.org/show_bug.cgi?id=5195
          Would like API to flush rendering of pending DOM changes

        This was actually a Tiger regression. When AppKit added a new code path for rendering
        NSView, our special hack for doing layout when we draw didn't work any more. So we
        were able to fix this without adding any API.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _recursiveDisplayRectIgnoringOpacity:inContext:topView:]): Added.
        Does the same thing that other _recursiveDisplay methods do.

2005-10-08  Alexey Proskuryakov  <ap@nypop.com>

        Reviewed by Maciej.

        - fixed http://bugs.webkit.org/show_bug.cgi?id=5187
          UTF-8 in long text files breaks at some point

        * WebView.subproj/WebTextRepresentation.m:
        (-[WebTextRepresentation finishedLoadingWithDataSource:]):
        Call flushReceivedData on the WebTextView so it can decode any final bytes.

        * WebView.subproj/WebTextView.h: Added WebCoreTextDecoder field and flushReceivedData method.
        * WebView.subproj/WebTextView.m:
        (-[WebTextView dealloc]): Release WebCoreTextDecoder.
        (-[WebTextView appendReceivedData:fromDataSource:]): Create a WebCoreTextDecoder to decode
        the text; use the textEncodingName from the data source. Use it to decode instead of the
        data source's stringWithData.
        (-[WebTextView flushReceivedData]): Call flush on the decoder and append any last bytes to
        the text view.

2005-10-07  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Omernick.
        
        WebKit support for allowing clients to know which frame originated a particular JavaScript alert/dialog.

        * WebView.subproj/WebUIDelegatePrivate.h:
        New optional delegate methods for the three JavaScript alert/dialogs. These are just like the existing
        ones in WebUIDelegate.h except that each adds a parameter specifying the frame that the JavaScript was
        running in. Eventually we'll deprecate the old three methods in favor of these in the public API.
        
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge runJavaScriptAlertPanelWithMessage:]):
        Call version of the delegate method that has the frame parameter if the delegate supports it.
        (-[WebBridge runJavaScriptConfirmPanelWithMessage:]):
        ditto
        (-[WebBridge runJavaScriptTextInputPanelWithPrompt:defaultText:returningText:]):
        ditto
        
        * WebView.subproj/WebDefaultUIDelegate.m:
        (-[WebDefaultUIDelegate webView:runJavaScriptAlertPanelWithMessage:initiatedByFrame:]):
        Now implements the new version of the delegate method that includes the frame parameter. (Still
        doesn't do anything though.)
        (-[WebDefaultUIDelegate webView:runJavaScriptConfirmPanelWithMessage:initiatedByFrame:]):
        Now implements the new version of the delegate method that includes the frame parameter. (Still
        doesn't do anything though.)
        (-[WebDefaultUIDelegate webView:runJavaScriptTextInputPanelWithPrompt:defaultText:initiatedByFrame:]):
        Now implements the new version of the delegate method that includes the frame parameter. Doesn't
        actually use the frame parameter here yet though.
        
2005-10-06  Darin Adler  <darin@apple.com>

        - fixed compiling on Deployment

        * WebCoreSupport.subproj/WebTextRenderer.m: (-[WebTextRenderer initWithFont:]):
        Put initialFont inside !LOG_DISABLED.

2005-10-06  Darin Adler  <darin@apple.com>

        Reviewed by Eric.

        - tweaked formatting

        * WebCoreSupport.subproj/WebTextRenderer.m: Changed function names to remove underscores;
        fixed formatting to match our coding guidelines, other related tweaks.

2005-10-06  Darin Adler  <darin@apple.com>

        Reviewed by Eric.

        - fixed regression in drawing of text in non-flipped contexts from my last check-in

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (drawGlyphs): Only flip the matrix if the NSGraphicsContext is flipped.
        (-[WebTextRenderer _ATSU_drawRun:style:geometry:]): Use -[NSGraphicsContext isFlipped]
        instead of [[NSView focusView] isFlipped].

2005-10-06  Darin Adler  <darin@apple.com>

        Reviewed by Hyatt.

        - fixed <rdar://problem/3217793> Monaco bold comes out as Helvetica bold, very bad if you choose Monaco as your fixed-width font
        - fixed <rdar://problem/3256269> CSS1: bold/italic font styles not programmatically created if font doesn't include them (3231)
          also <http://bugs.webkit.org/show_bug.cgi?id=3231>

        * WebCoreSupport.subproj/WebTextRenderer.h: Removed public declarations of private structures that are not
        used in the header. Removed the separate 16-bit character map; the difference in code size is only a few
        bytes per page and there's no measurable performance difference by always using the 32-bit character version.
        Removed substitute font width maps altogether, since we now use the width map in the substitute font's renderer.
        Also removed a few more now-unused fields and methods. Changed initWithFont to take WebCoreFont. Changed
        the setAlwaysUseATSU: method to remove the underscore prefix.

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (getUncachedWidth): Get font from WebCoreFont directly instead of taking a parameter, since we now use only
        one NSFont per WebTextRenderer.
        (widthFromMap): Removed NSFont parameter for same reason as above; simplified.
        (widthForGlyph): Ditto.
        (overrideLayoutOperation): Updated for change to WebCoreFont.
        (-[WebTextRenderer initWithFont:]): Changed to use WebCoreFont. Removed code to deal with substitute font maps.
        Changed lineGap computation to use floats instead of doubles. Added code to compute a synthetic bold offset.
        Currently this is the font size divided by 24 and then rounded up to an integer.
        (-[WebTextRenderer dealloc]): Updated for change to WebCoreFont and other related changes.
        (-[WebTextRenderer finalize]): Ditto.
        (-[WebTextRenderer xHeight]): Ditto.
        (-[WebTextRenderer drawRun:style:geometry:]): Remove small caps case here; no longer needed. Also updated as above.
        (-[WebTextRenderer floatWidthForRun:style:widths:]): Ditto.
        (-[WebTextRenderer drawHighlightForRun:style:geometry:]): Ditto.
        (-[WebTextRenderer pointToOffset:style:position:reversed:includePartialGlyphs:]): Ditto.
        (+[WebTextRenderer setAlwaysUseATSU:]): Renamed to remove underscore prefix.
        (-[WebTextRenderer smallCapsRenderer]): Ditto. Changed to create a renderer for the smaller sized font.
        (-[WebTextRenderer _substituteFontForString:families:]): Reorganized this to be more readable and to call
        the new rendererForAlternateFont method.
        (-[WebTextRenderer rendererForAlternateFont:]): Added. Used to select an alternate font taking into account
        bold and italic synthesis.
        (-[WebTextRenderer substituteRendererForCharacters:length:families:]): Renamed to remove underscore prefix.
        Updated to use rendererForAlternateFont.
        (-[WebTextRenderer _computeWidthForSpace]): Updated for name changes and to remove unnecessary parameters.
        (-[WebTextRenderer setUpFont]): Renamed to remove underscore prefix. Added code to get printer or screen
        font as specified by WebCoreFont so calers don't need to do this.
        (drawGlyphs): Renamed to remove underscore prefix. Added code for synthetic oblique (14 degree slant), and
        synthetic bold (add offset and draw text a second time).
        (-[WebTextRenderer _CG_drawRun:style:geometry:]): Keep an array of substitute renderers instead of fonts.
        Changed around the loop to reverse the run to be a single loop instead of 3.
        (-[WebTextRenderer floatWidthForRun:style:widths:substituteRenderers:glyphs:startPosition:numGlyphs:]):
        Renamed to remove the underscore prefix.
        (-[WebTextRenderer _CG_floatWidthForRun:style:widths:substituteRenderers:glyphs:startPosition:numGlyphs:]):
        Changed to use subsitute renderers rather than fonts.
        (-[WebTextRenderer updateGlyphEntryForCharacter:glyphID:substituteRenderer:]): Renamed to remove underscore
        prefix and changed to use a substitute renderer rather than a substitute NSFont.
        (-[WebTextRenderer extendCharacterToGlyphMapToInclude:]): Updated to work with all characters, both ones
        that fit into 16-bit and ones that don't.
        (-[WebTextRenderer _extendGlyphToWidthMapToInclude:]): Removed NSFont parameter and simplified. This fixes
        a bug where numberOfGlyphs was accidentally used from the main font instead of "subFont".
        (glyphForCharacter): Changed to use subsitute renderers instead of substitute fonts.
        (widthForNextCharacter): Ditto. Also removed small caps code no longer needed here and replaced it with
        simpler small caps code that no longer assumes glyphs match.
        (shouldUseATSU): Changed the code to check ranges in order to slightly reduce the number of cases and
        to create earlier exit for lower character codes.

        * WebCoreSupport.subproj/WebTextRendererFactory.h: Added caches for synthesized font and oblique
        variants so we can still use the NSFont as the dictionary key. Removed coalesceTextDrawing methods.
        Changed methods to use WebCoreFont as the parameters and results instead of NSFont.
        * WebCoreSupport.subproj/WebTextRendererFactory.m:
        (-[WebTextRendererFactory clearCaches]): Clear all 8 caches.
        (-[WebTextRendererFactory isFontFixedPitch:]): Changed code slightly so there's only one call to
        the CFDictionarySetValue function.
        (-[WebTextRendererFactory init]): Create all 8 caches.
        (-[WebTextRendererFactory dealloc]): Release all 8 caches.
        (-[WebTextRendererFactory rendererWithFont:]): Select the appropriate cache based on 3 booleans:
        synthetic bold, synthetic oblique, and printer. Use WebCoreFont instead of NSFont.
        (-[WebTextRendererFactory fontWithFamilies:traits:size:]): Set the synthetic bold and oblique flags
        when returning a WebCoreFont based on requested traits that are not present in the NSFont.
        (acceptableChoice): Ignore the synthesizable traits when deciding if a chosen font is acceptable.
        (betterChoice): Rather than assuming that every font has all the desired traits, implement a rule
        that says a font with an unwanted trait loses out over a font that does not have an unwanted trait.
        This lets us chose a bold font over a non-bold font that could use synthesized bold but treat both
        as candidates.

        * WebCoreSupport.subproj/WebGlyphBuffer.h: Removed.
        * WebCoreSupport.subproj/WebGlyphBuffer.m: Removed.
        * WebKit.xcodeproj/project.pbxproj: Removed WebGlyphBuffer source files.

        * Misc.subproj/WebKitNSStringExtras.m:
        (-[NSString _web_drawAtPoint:font:textColor:]): Update to use WebCoreFont.
        (-[NSString _web_widthWithFont:]): Ditto.
        * Misc.subproj/WebStringTruncator.m:
        (truncateString): Ditto.
        (+[WebStringTruncator widthOfString:font:]): Ditto.

        * WebView.subproj/WebHTMLView.m: (-[WebHTMLView drawRect:]): Removed text drawing coalesce method calls.
        * WebView.subproj/WebTextView.m: (-[WebTextView setFixedWidthFont]): Updated to use cachedFontFromFamily
        method, which we still have, rather than fontWithFamilies method which we don't (since it now uses WebCoreFont).
        * WebView.subproj/WebView.m: (+[WebView _setAlwaysUseATSU:]): Updated for name change to underlying method.

2005-10-05  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Eric.

	<rdar://problem/4158439> Safari appears to hang when sending synchronous XMLHttpRequest that gets no server response

	No testcase - not testable w/o network.
	
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge syncLoadResourceWithURL:customHeaders:postData:finalURL:responseHeaders:statusCode:]): Set a timeout of 10.

2005-10-04  Beth Dakin  <bdakin@apple.com>

        Reviewed by Darin

	Fix for <rdar://problem/4285538> TOT fix for Denver Regression: Drawing glitch in the transparent dialog's cancel/ok 
	button in the widget manager. 

        * WebCoreSupport.subproj/WebImageData.m: Calls WKSetPatternPhaseInUserSpace() which is a new function that lies in 
						WebKitSystemInterface that and takes care of pattern-setting. Prevents 
						regression that occurred with image tiling in transparency layers. 
        (-[WebImageData tileInRect:fromPoint:context:]):

2005-10-03  Tim Omernick  <tomernick@apple.com>

        Reviewed by John Sullivan.

	<rdar://problem/4281095> Denver regression: Seed: Safari HTML 4.01 <object ...> tag problem

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge determineObjectFromMIMEType:URL:]):
	If no view class is registered to handle the MIME type, check to see if there is a plugin registered which can handle it.
	This check is required because the Java plugin does not register an NSView class, so that Java files are downloaded when
	not embedded.

	Prior to this fix, -determineObjectFromMIMEType:URL: would always return ObjectElementNone for Java applets (MIME type
	"application/x-java-applet"), which would cause Java applets embedded in <OBJECT> elements to not be loaded.

	This broke on 05-03-2005, when we changed how we handle fallback content for <OBJECT> elements so that we could pass the
	Acid2 test.

2005-09-28  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by geoff
        
        Fixed <rdar://problem/4276596> multipart/x-mixed-replace: saved inline images appear only partially loaded
        Fixed <rdar://problem/4265439> progress bar should look complete even if there is some more multipart content being loaded

        * WebCoreSupport.subproj/WebSubresourceLoader.h:
        * WebCoreSupport.subproj/WebSubresourceLoader.m:
        (-[WebSubresourceLoader didReceiveResponse:]):
        Now calls signalFinish and saveResource.
        
        (-[WebSubresourceLoader signalFinish]): 
        Added.  Does the part of didFinishLoading that signals to the WebDataSource and load delegates that the load is finished.
        
        (-[WebSubresourceLoader didFinishLoading]):
        * WebView.subproj/WebLoader.h:
        * WebView.subproj/WebLoader.m:
        (-[NSURLProtocol signalFinish]):
        Similar to above
        
        (-[NSURLProtocol didFinishLoading]):

2005-09-28  Adele Peterson  <adele@apple.com>

        Reviewed by John.

        Moved _downloadWithLoadingConnection and _downloadWithRequestfrom WebDownload.h to WebDownloadInternal.h

        * Misc.subproj/WebDownload.h:
        * Misc.subproj/WebDownloadInternal.h: Added.
        * WebKit.xcodeproj/project.pbxproj: Added WebDownloadInternal.h
        * WebView.subproj/WebMainResourceLoader.m: Added import of WebDownloadInternal.h
        * WebView.subproj/WebView.m: ditto.

2005-09-27  Adele Peterson  <adele@apple.com>

        Reviewed by Maciej.

        Changed ints to size_t where appropriate.

        * Misc.subproj/WebCoreStatistics.h:
        * Misc.subproj/WebCoreStatistics.m:
        (+[WebCoreStatistics javaScriptObjectsCount]):
        (+[WebCoreStatistics javaScriptInterpretersCount]):
        (+[WebCoreStatistics javaScriptNoGCAllowedObjectsCount]):
        (+[WebCoreStatistics javaScriptReferencedObjectsCount]):
        * WebView.subproj/WebPreferences.m:
        (-[WebPreferences _pageCacheSize]):
        (-[WebPreferences _objectCacheSize]):
        * WebView.subproj/WebPreferencesPrivate.h:

2005-09-26  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Omernick.

        - fixed <rdar://problem/4118126> Drag-and-drop text with text containing a colon causes a crash
        
        There were two problems here. One is that dragging and dropping text within the same WebTextView
        should have done nothing rather than try to navigate. The other is that navigating while processing
        the end of the drag would dealloc the drag-initiating WebTextView, leading to a crash. Fixing the
        former doesn't fix all cases of the latter, since dropping onto (e.g.) Safari's location field
        could cause a navigation during the drag. So these two issues needed to be fixed separately.

        * WebView.subproj/WebTextView.m:
        (-[WebTextView dragSelectionWithEvent:offset:slideBack:]):
        Before drag, retain self, and tell WebView that the drag is self-initiated. After drag, do the
        opposite. This is the same approach as WebImageView, but it can all be contained in one method
        here due to NSTextView's dragging API, which wraps up some of the drag-machinery guts.

2005-09-24  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed and landed by Darin.

        - fixed http://bugs.webkit.org/show_bug.cgi?id=5100
          -[WebTextRenderer _ATSU_drawRun:...] does not check view flippedness

        * WebCoreSupport.subproj/WebTextRenderer.m: (-[WebTextRenderer _ATSU_drawRun:style:geometry:]):
        Set up a the CGContext with a matrix that flips the text if the view is not flipped.

2005-09-24  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed, tweaked a tiny bit, and landed by Darin.

        - fixed http://bugs.webkit.org/show_bug.cgi?id=4940
          CG and ATSUI give different width to the same text

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (overrideLayoutOperation): Added. ATSU callback to do the rounding.
        (-[WebTextRenderer _trapezoidForRun:style:atPoint:]): Use the new createATSULayoutParameters
        function instead of calling _createATSUTextLayoutForRun.
        (-[WebTextRenderer _ATSU_drawHighlightForRun:style:geometry:]): Use createATSULayoutParameters,
        and also compute the width in a way that works for any direction combination.
        (-[WebTextRenderer _ATSU_drawRun:style:geometry:]): Use createATSULayoutParameters.
        (-[WebTextRenderer _ATSU_pointToOffset:style:position:reversed:includePartialGlyphs:]):
        Use createATSULayoutParameters. Also put in code that seems to work around an ATSU bug.
        (createATSULayoutParameters): Added.
        (disposeATSULayoutParameters): Added.

2005-09-24  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed by Dave.
        Landed by Darin.

        - fixed http://bugs.webkit.org/show_bug.cgi?id=4862
          Incorrect layout of bidi overrides

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (addDirectionalOverride): Renamed, and made it work in both directions.
        (-[WebTextRenderer _ATSU_drawHighlightForRun:style:geometry:]): Updated to call addDirectionalOverride.
        (-[WebTextRenderer _ATSU_drawRun:style:geometry:]): More of the same.
        (-[WebTextRenderer _ATSU_pointToOffset:style:position:reversed:includePartialGlyphs:]): Ditto.

2005-09-24  Alexey Proskuryakov  <ap@nypop.com>

        Tweaked, reviewed, and landed by Darin.

        - fixed http://bugs.webkit.org/show_bug.cgi?id=4394
          Mouse clicks ignored in inline input areas

        * WebView.subproj/WebHTMLView.m:
        (-[NSArray mouseDown:]): Removed misleading comment and added code to send mouse event to input manager.
        (-[NSArray mouseDragged:]): Added code to send mouse event to input manager.
        (-[NSArray mouseUp:]): Ditto.
        (-[WebHTMLView _discardMarkedText]): Umnmark text before calling markedTextAbandoned: to match behavior
        of NSTextView (not sure why we did things in the opposite order before).
        (-[WebHTMLView _updateSelectionForInputManager]): Ditto.

        - unrelated tweak

        * WebView.subproj/WebView.m:
        (-[WebView _performTextSizingSelector:withObject:onTrackingDocs:selForNonTrackingDocs:newScaleFactor:]):
        Fix typecast that used ... for no good reason.

2005-09-23  Duncan Wilcox  <duncan@mclink.it>

        Reviewed and landed by Darin.

        - name changes to prepare for fixing bugzilla bug 4582

        * WebView.subproj/WebHTMLView.m: Changed names to match WebCore changes.

2005-09-20  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Omernick.

        - fixed <rdar://problem/3228554> We should enforce one selection per WebView instead of per window
        
        Note that this checkin does not mean that we will always maintain a selection in a WebView when
        the focus is elsewhere. Instead it means that there should never be more than one frame containing
        a selection in a WebView, and that it's possible to maintain a selection in a WebView when the focus 
        is elsewhere.

        * WebView.subproj/WebView.m:
        (-[WebView searchFor:direction:caseSensitive:wrap:]):
        removed unnecessary and somewhat confusing comment
        (-[WebView selectedFrame]):
        now calls the extracted method -_focusedFrame
        (-[WebView _focusedFrame]):
        new method, extracted from -selectedFrame; returns frame containing first responder, if any
        (-[WebView _findSelectedFrameStartingFromFrame:skippingFrame:]):
        added skippingFrame parameter, which is never returned
        (-[WebView _findSelectedFrameSkippingFrame:]):
        new method, starts from main frame and passes a frame to skip
        (-[WebView _findSelectedFrame]):
        now calls _findSelectedFrameSkippingFrame:nil
        (-[WebView _selectedFrameDidChange]):
        new method, called by WebDocumentText protocol implementors; calls -deselectAll on frame that
        formerly displayed a selection, if any

        * WebView.subproj/WebViewInternal.h:
        added category WebDocumentSelectionExtras, with the one method _selectedFrameDidChange

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView becomeFirstResponder]):
        call -[WebView _selectedFrameDidChange]

        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView becomeFirstResponder]):
        call -[WebView _selectedFrameDidChange]
        (-[WebPDFView resignFirstResponder]):
        deselect all unless webview says not to; note that this doesn't work in all cases due to:
        <rdar://problem/4265966> PDFs continue to show a (secondary) selection when the focus moves elsewhere        

        * WebView.subproj/WebTextView.m:
        (-[WebTextView becomeFirstResponder]):
        call -[WebView _selectedFrameDidChange]
        (-[WebTextView resignFirstResponder]):
        deselect all unless webview says not to

2005-09-20  Eric Seidel  <eseidel@apple.com>

        Reviewed by mjs.

	Moved MIME type support from a hard coded list
        (in two places) to single lists in the corresponding
        *Representation classes.  Also moved the list of types
        supported by WebCore (WebHTMLRepresentation) into WebCore.
        http://bugs.webkit.org/show_bug.cgi?id=5037

        * WebView.subproj/WebDataSource.m:
        (addTypesFromClass): new inline function
        (+[WebDataSource _repTypesAllowImageTypeOmission:]):
        * WebView.subproj/WebFrameView.m:
        (addTypesFromClass): new inline function
        (+[WebFrameView _viewTypesAllowImageTypeOmission:]):
        * WebView.subproj/WebHTMLRepresentation.h:
        * WebView.subproj/WebHTMLRepresentation.m:
        (+[WebHTMLRepresentation supportedMIMETypes]):
        * WebView.subproj/WebHTMLView.m:
        (+[WebHTMLView supportedMIMETypes]):
        * WebView.subproj/WebHTMLViewPrivate.h:
        * WebView.subproj/WebImageRepresentation.h:
        * WebView.subproj/WebImageRepresentation.m:
        (+[WebImageRepresentation supportedMIMETypes]):
        * WebView.subproj/WebImageView.h:
        * WebView.subproj/WebImageView.m:
        (+[WebImageView supportedMIMETypes]):
        * WebView.subproj/WebPDFRepresentation.h:
        * WebView.subproj/WebPDFRepresentation.m:
        (+[WebPDFRepresentation supportedMIMETypes]):
        * WebView.subproj/WebPDFView.h:
        * WebView.subproj/WebPDFView.m:
        (+[WebPDFView supportedMIMETypes]):
        * WebView.subproj/WebTextRepresentation.h:
        * WebView.subproj/WebTextRepresentation.m:
        (+[WebTextRepresentation supportedMIMETypes]):
        * WebView.subproj/WebTextView.h:
        * WebView.subproj/WebTextView.m:
        (+[WebTextView supportedMIMETypes]):
        * WebView.subproj/WebView.m:
        (+[WebView _viewClass:andRepresentationClass:forMIMEType:]):
        (+[WebView MIMETypesShownAsHTML]): updated to match style
        (+[WebView setMIMETypesShownAsHTML:]): ditto

2005-09-16  John Sullivan  <sullivan@apple.com>

        * WebView.subproj/WebImageView.m:
        (-[WebImageView copy:]):
        fixed build-breaking silly error in previous checkin

2005-09-16  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Omernick
        
        - fixed <rdar://problem/4256557> CrashTracer: 238 crashes in Safari at 
        com.apple.AppKit: -[NSPasteboard setData:forType:] + 188

        * WebView.subproj/WebImageView.m:
        (-[WebImageView copy:]):
        declare types to pasteboard before starting to set their data
        (-[WebImageView writeSelectionToPasteboard:types:]):
        ditto

2005-09-16  Adele Peterson  <adele@apple.com>

        Rolling out the fix for http://bugs.webkit.org/show_bug.cgi?id=4924
            QPainter should use CGContext as much as possible rather than NSGraphicsContext 
        since it caused a performance regression.

2005-09-16  Adele Peterson  <adele@apple.com>

        Change by Darin, reviewed by me and Maciej.

        Fixes http://bugs.webkit.org/show_bug.cgi?id=4547
        use int instead of long for 32-bit (to prepare for LP64 compiling)

        * Plugins.subproj/npapi.m: changed types to match those defined in npapi.h
        (NPN_MemAlloc):
        (NPN_MemFlush):
        (NPN_PostURLNotify):
        (NPN_PostURL):
        (NPN_Write):

2005-09-14  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by john

        Fixes <rdar://problem/4237479> REGRESSION (Cambridge-Denver): old QuickTime movie continues to play sound after reload
        We were adding the movie to the document twice after the changes were added to handle fallback content.
        There are some errors for which we should not render fall back content

        * Misc.subproj/WebKitErrorsPrivate.h:
        Introduced WebKitErrorPlugInWillHandleLoad to represent the cancel we do
        to prevent loading plugin content twice
        
        * Plugins.subproj/WebPluginDocumentView.m:
        (-[WebPluginDocumentView dataSourceUpdated:]): Ditto
        
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource _receivedMainResourceError:complete:]):
        Don't handleFallbackContent on WebKitErrorPlugInWillHandleLoad or on a user cancel

2005-09-14  Timothy Hatcher  <thatcher@apple.com>

        Reviewed by Eric.
        
        * WebKit.xcodeproj/project.pbxproj:
        made WebDashboardRegion.h a private header

2005-09-14  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fixed http://bugs.webkit.org/show_bug.cgi?id=4924
          QPainter should use CGContext as much as possible rather than NSGraphicsContext

        * WebCoreSupport.subproj/WebImageRendererFactory.m: Remove setCGCompositeOperationFromString
        method, no longer needed.

2005-09-13  Tim Omernick  <tomernick@apple.com>

        Reviewed by Justin Garcia, Darin Adler.

	- <rdar://problem/3163393> Safari does not support Windowless mode in Flash

        * Plugins.subproj/WebBaseNetscapePluginView.h:
	Added 'isTransparent' instance variable.

        * Plugins.subproj/WebBaseNetscapePluginView.m:	
        (-[WebBaseNetscapePluginView saveAndSetPortStateForUpdate:]):
	When updating a plugin in "windowless" (transparent) mode, clip drawing to the dirty
	region of the opaque ancestor.  This means that a partially-transparent plugin, which
	by definition does not clear its port on redraw, will not overdraw the valid parts
	of its port.
        (-[WebBaseNetscapePluginView sendEvent:]):
	Disabled the "green debug background" for transparent plugins -- since they are not
	expected to cover their entire port every redraw, this debug code makes no sense.
        (-[WebBaseNetscapePluginView setVariable:value:]):
	Implemented -setVariable:value:, which is called from NPN_SetValue() (previously
	unimplemented).
	Right now we only handle NPPVpluginTransparentBool; if we choose to handle the other
	plugin variables, then we may do so here.
        * Plugins.subproj/WebBaseNetscapePluginViewPrivate.h:
	Added SPI for -[WebBaseNetscapePluginView setVariable:value].
        * Plugins.subproj/npapi.m:
        (NPN_SetValue):
	Implemented this function so that plugins may set state (such as window mode).
	
2005-09-11  Mark Rowe  <opendarwin.org@bdash.net.nz>

        Reviewed, tweaked, and landed by Darin.

        - fixed http://bugs.webkit.org/show_bug.cgi?id=4286
          .Mac prefpane crashes when Safari using CVS WebKit is running

        * WebView.subproj/WebView.m: (-[WebView initWithFrame:frameName:groupName:]):
        If ENABLE_WEBKIT_UNSET_DYLD_FRAMEWORK_PATH, and WEBKIT_UNSET_DYLD_FRAMEWORK_PATH
        is set in the environment, then unset DYLD_FRAMEWORK_PATH.

        * WebKit.xcodeproj/project.pbxproj: Set ENABLE_WEBKIT_UNSET_DYLD_FRAMEWORK_PATH
        in configurations other than Default -- we don't want that code in production
        builds, but we want it in builds we do ourselves and nightly builds.

2005-09-10  Ingmar J Stein  <IngmarStein@gmail.com>

        Reviewed and landed by Darin.

        * WebCoreSupport.subproj/WebImageRenderer.m:
        (-[WebImageRenderer drawImageInRect:fromRect:compositeOperator:context:]):
        Removed unused local variable.

2005-09-09  Tim Omernick  <tomernick@apple.com>

        Reviewed by John Sullivan.

        * History.subproj/WebBackForwardList.m:
        (-[WebBackForwardList removeItem:]):
	SPI to remove a given WebHistoryItem.

        * History.subproj/WebBackForwardListPrivate.h: Added.

        * WebKit.xcodeproj/project.pbxproj:
	Added WebBackForwardListPrivate.h as a private header.

2005-09-09  John Sullivan  <sullivan@apple.com>

        Reviewed by Tim Omernick.
        
        fixed http://bugs.webkit.org/show_bug.cgi?id=4070:
        Find in plain text won't find only occurrence if it overlaps selection

        * Misc.subproj/WebSearchableTextView.m:
        (-[NSString findString:selectedRange:options:wrap:]):
        in the wrap case, extend the search range far enough that text overlapping the
        selection (including the exact-match case) will be considered.

2005-09-08  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by darin
        
        WebKit portion of multipart/x-mixed-replace support

        * WebCoreSupport.subproj/WebSubresourceLoader.m:
        (+[WebSubresourceLoader startLoadingResource:withRequest:customHeaders:referrer:forDataSource:]):
        Subresource case: Check for Foundation level multipart support
        (-[WebSubresourceLoader didReceiveResponse:]): 
        Send previously received data in a multipart section to the coreLoader
        (-[WebSubresourceLoader didReceiveData:lengthReceived:]): 
        Don't send data to the coreLoader until it has been completely received
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource _startLoading:]): 
        Main resource case: check for Foundation level multipart support 
        (+[WebDataSource _repTypesAllowImageTypeOmission:]):
        Some server apps send data right after declaring content multipart/x-mixed-replace, and expect it to be treated as html
        (-[WebDataSource _commitIfReady:]):
        Don't ask the WebFrame to close its old WebDataSource when loading a multipart section, because we're going to reuse it
        (-[WebDataSource _receivedData:]):
        For non text/html multipart sections, we commit the data all at once, at the end
        (-[WebDataSource _doesProgressiveLoadWithMIMEType:]):
        Added heuristic for when to commit the load incrementally
        (-[WebDataSource _commitLoadWithData:]):
        Moved from _receivedData into its own function
        (-[WebDataSource _revertToProvisionalState]):
        (-[WebDataSource _setupForReplaceByMIMEType:]):
        Commits the data received for the previous multipart section if it wasn't loaded progresively, clears out the WebFrame and WebDatasource for the next multipart section
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _transitionToCommitted:]): 
        The very first multipart section is treated as a normal load, so that the back/forward list and history are updated.
        All later sections have a new load type, WebFrameLoadTypeReplace, and are treated like reloads
        (-[WebFrame _checkLoadCompleteForThisFrame]): Ditto
        (-[WebFrame _itemForRestoringDocState]): Ditto
        (-[WebFrame _setupForReplace]):
        Clears out the WebFrame for the next multipart section
        * WebView.subproj/WebFrameInternal.h:
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebFrameView.m:
        (+[WebFrameView _viewTypesAllowImageTypeOmission:]): See above
        * WebView.subproj/WebLoader.h:
        * WebView.subproj/WebLoader.m:
        (-[NSURLProtocol clearResourceData]):
        (-[NSURLProtocol setSupportsMultipartContent:]):
        * WebView.subproj/WebMainResourceLoader.m: Straightforward
        (-[WebMainResourceLoader didReceiveResponse:]):

2005-09-06  Geoffrey Garen  <ggaren@apple.com>

        - fixed build bustage from last checkin.
        
        Reviewed by haytt.

        * History.subproj/WebBackForwardList.m:
        (-[WebBackForwardList pageCacheSize]): updated debug printf since we no
        longer have a variable called 'multiplier'

2005-09-06  David Hyatt  <hyatt@apple.com>

	Reduce the # of cached pages for a back/forward list.  The old cache would cache the
	following per tab:
	> 1gb memory = 16 pages per tab/window
	> 512mb memory = 8 pages per tab/window
	<= 512mb memory = 4 pages per tab/window

	This consumes far too much memory and is way too aggressive.  The new cache sizes are
	as follows:
	>= 1gb memory = 3 pages per tab/window
	>= 512mb memory = 2 pages per tab/window
	< 512mb memory = 1 page per tab/window

        Reviewed by john

        * History.subproj/WebBackForwardList.m:
        (-[WebBackForwardList pageCacheSize]):
        * WebView.subproj/WebPreferences.m:
        (+[WebPreferences initialize]):

2005-09-05  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan.

        - fixed http://bugs.webkit.org/show_bug.cgi?id=4846
          REGRESSION: Carbon WebKit applications don't work at all

        * Carbon.subproj/HIWebView.m: Remove lots of unneeded declarations of private stuff.
        (Draw): Call WKNSWindowOverrideCGContext and WKNSWindowRestoreCGContext rather
        than calling a non-existent setCGContext: method on the context.

2005-09-05  John Sullivan  <sullivan@apple.com>

        Reviewed by Dave Hyatt.
        
        - change related to <rdar://problem/4211999> Safari quits when click-drag-hold an image 
        that is set to automatically change.

        * WebView.subproj/WebHTMLView.m:
        (-[NSArray namesOfPromisedFilesDroppedAtDestination:]):
        handle nil wrapper with ERROR and early return rather than ASSERT, since we now know
        of a way to reproduce this (written up as 4244861)

2005-09-05  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan.

        - fixed http://bugs.webkit.org/show_bug.cgi?id=4357
          crash related to animated GIFs, reproducible in non-Safari WebKit application

        * WebCoreSupport.subproj/WebImageData.m:
        (removeAnimatingRendererFromView): Added.
        (removeFromDictionary): Added.
        (-[WebImageData removeAnimatingRenderer:]): Rewrote using CF functions rather than
        NS functions so that we never retain the views, since this can be called from
        a view's dealloc method.
        (setNeedsDisplayInAnimationRect): Added.
        (-[WebImageData _nextFrame:]): Rewrote as above, even though in this case it can't
        be called from the dealloc method.

2005-08-26  David Hyatt  <hyatt@apple.com>

	Add support for a new scaling and tiling function so that border images from CSS3
	can be implemented.
	
        Reviewed by darin

        * WebCoreSupport.subproj/WebImageData.h:
        * WebCoreSupport.subproj/WebImageData.m:
        (-[WebImageData scaleAndTileInRect:fromRect:withHorizontalTileRule:withVerticalTileRule:context:]):
        * WebCoreSupport.subproj/WebImageRenderer.m:
        (-[WebImageRenderer scaleAndTileInRect:fromRect:withHorizontalTileRule:withVerticalTileRule:context:]):
        (-[WebImageRenderer setAnimationRect:]):
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView updateFocusState]):

2005-08-26  Adele Peterson  <adele@apple.com>

        Reviewed by Beth.

        * WebKit.xcodeproj/project.pbxproj: Changed WebKit.Framework to WebKit.framework in UMBRELLA_FRAMEWORK.

2005-08-25  David Harrison  <harrison@apple.com>

        Reviewed by Maciej.

        <rdar://problem/4227734> Denver Regression: WebCore selection bug on lines starting with tab (clownfish)

        The text is in a DIV styled with "white-space:pre", and uses newline characters as linebreaks.
        WebKit's text renderer is erroneously considering the width of the lines leading up to the tab
        character when calculating the width of the tab.
        Easily fixed by having widthForNextCharacter ignore the widthToStart when working with tabWidth.
        Any prior text that fits in the same line is already factored into the xpos, which is paid attention to.

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (widthForNextCharacter):
        Ignore the widthToStart when working with tabWidth.

2005-08-23  John Sullivan  <sullivan@apple.com>

        Reviewed by Beth Dakin.
        
        - fixed <rdar://problem/4229167> 14 leaks of WebFileButton and associated objects, 
        seen after running webkit layout tests

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge fileButtonWithDelegate:]):
        this method was returning a retained object; I added an autorelease

2005-08-23  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Update for recent changes.

2005-08-23  Mitz Pettel  <opendarwin.org@mitzpettel.com>

        Reviewed and landed by Darin.

        - fixed http://bugs.webkit.org/show_bug.cgi?id=4604
          LEAK -[WebTextRenderer _ATSU_pointToOffset:style:position:reversed:includePartialGlyphs:] leaks an ATSUTextLayout
          <rdar://problem/4228787> ATSUTextLayout leak in _ATSU_pointToOffset:style:position:reversed:includePartialGlyphs: (4604)

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer _ATSU_pointToOffset:style:position:reversed:includePartialGlyphs:]):
        Added missing call to ATSUDisposeTextLayout.

2005-08-22  Geoffrey Garen  <ggaren@apple.com>

        - fixed <rdar://problem/4227011> Debugger SPI should be removed from WebView.h API
        
        Reviewed by mjs and adele.

        Cut and pasted debugging SPI from WebView to WebView(WebPendingPublic)
        
        * WebView.subproj/WebView.h:
        * WebView.subproj/WebView.m:
        (-[WebView setScriptDebugDelegate:]):
        (-[WebView scriptDebugDelegate]):
        * WebView.subproj/WebViewPrivate.h:

2005-08-20  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin Adler.
        
        - WebKit part of fix for 
        <rdar://problem/3977607> ER: Safari should check framework versions at launch

        * WebView.subproj/WebViewPrivate.h:
        * WebView.subproj/WebView.m:
        (+[WebView _minimumRequiredSafariBuildNumber]):
        new method, returns the minimum build number of Safari that this WebKit is
        willing to work with. (The Safari version has to be new enough to check
        for this value in order for this to have any effect.)

2005-08-19  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by rjw
        
        The boolean justOpenedForTargetedLink is never used to determine a course of action.  
        It was added long ago for findOrCreateFramedNamed, which has since been removed.

        * WebView.subproj/WebDataSource.m:
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _loadDataSource:withLoadType:formState:]):
        * WebView.subproj/WebFramePrivate.h:

2005-08-19  Darin Adler  <darin@apple.com>

        Reviewed by John.

        * English.lproj/Localizable.strings: Updated to include a new localizable string
        that was added a long while back. Apprently no one has run into the code using
        this string, because if they had, they'd have seen an assert.
        * English.lproj/StringsNotToBeLocalized.txt: Updated for various recent changes.

2005-08-17  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	- fix mysterious CGImageSource error message and possibly crash on layout tests.

        * WebView.subproj/WebMainResourceLoader.m:
        (-[WebMainResourceLoader receivedError:]): Retain the data source since it may
	prematurely self-destruct otherwise.
        (-[WebMainResourceLoader cancelWithError:]): ditto

2005-08-17  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by rjw
        
        Addresses <rdar://problem/4192534> new frame load delegate SPI needed for Dashboard
            Added handledOnloadEvents delegate method (private for now)

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge handledOnloadEvents]):
        * WebView.subproj/WebDefaultFrameLoadDelegate.m:
        (-[WebDefaultFrameLoadDelegate webView:didHandleOnloadEventsForFrame:]):
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _handledOnloadEvents]):
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebViewPrivate.h:

2005-08-17  John Sullivan  <sullivan@apple.com>

        Reviewed by Geoff Garen.
        
        - fixed <rdar://problem/4219817> Particular icon database + bookmarks + history crashes Safari on launch

        * Misc.subproj/WebIconDatabase.m:
        (-[WebIconDatabase releaseIconForURL:]):
        Move line that might remove last reference to iconURL to the end of the block.

2005-08-16  Darin Adler  <darin@apple.com>

        Reviewed by Trey.

	- improved fix for <rdar://problem/4211631>, tiled images tiled incorrectly when printing or 
	  drawing offscreen

        * WebCoreSupport.subproj/WebImageData.m: (-[WebImageData tileInRect:fromPoint:context:]):
        Fix pattern phase origin to use the image tile origin, which is clearly right, rather than
        the image rectangle, which isn't right, but often is the same.

2005-08-16  Adele Peterson  <adele@apple.com>

        Reviewed by John.

        - fixed <rdar://problem/4210320> URL tooltips should display a URL for elements that submit forms

        When the setShowsURLsInToolTips preference is set, we will display a tooltip containing 
        the form's url when you mouse over a submit button.

        * WebView.subproj/WebHTMLView.m: (-[WebHTMLView _updateMouseoverWithEvent:]):

2005-08-16  Darin Adler  <darin@apple.com>

        Reviewed by Beth Dakin.

        - removed Panther-only code that was not being compiled and was
          simply "bit-rotting"

        * Misc.subproj/WebFileDatabase.m:
        (-[WebFileDatabase _createLRUList:]):
        (+[WebFileDatabase _syncLoop:]):
        * Misc.subproj/WebKitErrors.m:
        (registerErrors):
        * Misc.subproj/WebNSObjectExtras.h:
        (WebCFAutorelease):
        * Misc.subproj/WebNSPasteboardExtras.m:
        (-[NSPasteboard _web_declareAndWriteDragImage:URL:title:archive:source:]):
        * WebCoreSupport.subproj/WebImageData.h:
        * WebCoreSupport.subproj/WebImageDecodeItem.h:
        * WebCoreSupport.subproj/WebImageDecodeItem.m:
        * WebCoreSupport.subproj/WebImageDecoder.h:
        * WebCoreSupport.subproj/WebImageDecoder.m:
        (decoderThread):
        (startDecoderThread):
        * WebCoreSupport.subproj/WebKeyGeneration.cpp: Removed.
        * WebCoreSupport.subproj/WebKeyGeneration.h: Removed.
        * WebCoreSupport.subproj/WebKeyGenerator.h:
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (getUncachedWidth):
        (_drawGlyphs):
        * WebCoreSupport.subproj/WebViewFactory.m:
        (-[WebViewFactory getBytes:fromTextMarker:length:]):
        * WebKit.xcodeproj/project.pbxproj:
        * WebKitPrefix.h:
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource _setPrimaryLoadComplete:]):
        (+[WebDataSource _repTypesAllowImageTypeOmission:]):
        (-[WebDataSource isLoading]):
        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        (localizedMenuTitleFromAppKit):
        (-[WebDefaultUIDelegate menuItemWithTag:]):
        (-[WebDefaultUIDelegate contextMenuItemsForElement:defaultMenuItems:]):
        (-[WebDefaultUIDelegate editingContextMenuItemsForElement:defaultMenuItems:]):
        * WebView.subproj/WebFormDataStream.m:
        (formCanRead):
        (webSetHTTPBody):
        * WebView.subproj/WebFrameView.m:
        (+[WebFrameView _viewTypesAllowImageTypeOmission:]):
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _documentFragmentFromPasteboard:allowPlainText:chosePlainText:]):
        (-[WebHTMLView resourceForData:preferredFilename:]):
        (-[WebHTMLView _lookUpInDictionaryFromMenu:]):
        (-[WebHTMLView validateUserInterfaceItem:]):
        (-[WebHTMLView _attributeStringFromDOMRange:]):
        (-[WebHTMLView toggleBaseWritingDirection:]):
        (-[WebHTMLView changeBaseWritingDirection:]):
        * WebView.subproj/WebPDFRepresentation.h:
        * WebView.subproj/WebPDFRepresentation.m:
        * WebView.subproj/WebPDFView.h:
        * WebView.subproj/WebPDFView.m:
        * WebView.subproj/WebPreferences.m:
        (+[WebPreferences _systemCFStringEncoding]):
        * WebView.subproj/WebView.m:
        (-[WebView _commonInitializationWithFrameName:groupName:]):

2005-08-16  Darin Adler  <darin@apple.com>

        Reviewed by Beth Dakin.

        - removed some unnecessary code

        * WebCoreSupport.subproj/WebGraphicsBridge.h: Removed pattern-phase related field and methods.
        * WebCoreSupport.subproj/WebGraphicsBridge.m: Ditto.

        * WebCoreSupport.subproj/WebImageData.m: Tweaked formatting and removed some unused code
        inside #if and comments.

        * WebCoreSupport.subproj/WebImageRenderer.h: Removed USE_CGIMAGEREF (which is always true now).
        * WebCoreSupport.subproj/WebImageRenderer.m: Removed old non-CGImageRef code.

        * WebCoreSupport.subproj/WebImageRendererFactory.m:
        (-[WebImageRendererFactory imageRendererWithMIMEType:]): Removed non-USE_CGIMAGEREF code.
        (-[WebImageRendererFactory imageRendererWithData:MIMEType:]): Ditto.
        (-[WebImageRendererFactory imageRendererWithSize:]): Ditto.
        (-[WebImageRendererFactory imageRendererWithName:]): Ditto.

2005-08-15  Darin Adler  <darin@apple.com>
	
        Reviewed by Beth.

	This is a fix for <rdar://problem/4211631> tiled images tiled incorrectly when printing or 
	drawing offscreen.

	Cayenne found there was a problem when they were trying to take screen shots of widgets, and
	it was ultimately a problem with the way we tile images. Darin was able to fix the problem
	by replacing some confusing hacked code with CG calls.

        * WebCoreSupport.subproj/WebImageData.m:
        (-[WebImageData tileInRect:fromPoint:context:]):
        * WebCoreSupport.subproj/WebImageRenderer.m:
        (-[WebInternalImage tileInRect:fromPoint:context:]):
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer drawLineForMisspelling:withWidth:]):

2005-08-14  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	- 1% speedup on HTML load speed iBench by avoiding icon database thrash
	http://bugs.webkit.org/show_bug.cgi?id=4423
	
        * Misc.subproj/WebIconDatabase.m:
        (-[WebIconDatabase _setIconURL:forURL:]): Be more aggressive about returning early, because
	updating the database does some expensive data structure copies.
	

2005-08-14  Duncan Wilcox  <duncan@mclink.it>

        Reviewed and landed by Darin.

        WebKit part of fix for <http://bugs.webkit.org/show_bug.cgi?id=4011>:
        "Editing delegate selection methods not called when using mouse"

        Clicking on editable content would move the cursor or alter the selection without
        calling the appropriate editing delegate method
        (webView:shouldChangeSelectedDOMRange:toDOMRange:affinity:stillSelecting:). The
        core of the patch is in the KHTMLPart::handleMousePressEvent* methods, the rest
        is glue needed to drill through all the layers.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge shouldChangeSelectedDOMRange:toDOMRange:affinity:stillSelecting:]):
        Bridge glue.

        * WebView.subproj/WebView.m:
        (-[WebView(WebViewEditingExtras) _shouldChangeSelectedDOMRange:toDOMRange:affinity:stillSelecting:]):
        Final step in glue, calling editing delegate.

        * WebView.subproj/WebViewInternal.h:
        Added _shouldChangeSelectedDOMRange:toDOMRange:affinity:stillSelecting: private method to WebViewEditingExtras
        category.

2005-08-11  Beth Dakin  <bdakin@apple.com>

        Reviewed by Vicki

	This is a fix for <rdar://problem/4141161> REGRESSION (Tiger): WebKit does not display in composited Carbon windows.
	I basically did what Troy suggests in his bug comments, and everything seems to work fine!

        * Carbon.subproj/HIViewAdapter.m:
        (-[HIViewAdapter setNeedsDisplayInRect:]):

2005-08-10  Adele Peterson  <adele@apple.com>

        Bumping version to 420+

        * Info.plist:

2005-08-08  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan.

        - fixed <rdar://problem/3996324> REGRESSION (1.2-2.0): scroll bars sometimes not updated properly (with >40 duplicate reports!)
          also http://bugs.webkit.org/show_bug.cgi?id=3416

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _recursiveDisplayRectIfNeededIgnoringOpacity:isVisibleRect:rectIsVisibleRectForView:topView:]):
        Propagate dirty rects after doing a layout, since a layout can create new dirty rects.

2005-08-05  Adele Peterson  <adele@apple.com>

        Reviewed by Darin.

        * WebKit.xcodeproj/project.pbxproj: Unchecked 'statics are thread safe' option.

2005-08-04  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by darin
        
        Fix for:
        <rdar://problem/3167884> Shockwave: 3D sprites rendered in OpenGL draw over the browser (3447)
        also as <http://bugs.webkit.org/show_bug.cgi?id=3447>
        
        The WindowRef created by -[NSWindow windowRef] has a QuickDraw GrafPort that covers 
        the entire window frame (or structure region in Carbon parlance) rather then just the window content.
        
        We filed this as an NSWindow bug <rdar://problem/4201099>

        To work around, we modify the CGrafPort to only cover the content area before we let the plug-in draw.

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView fixWindowPort]):
        (-[WebBaseNetscapePluginView saveAndSetPortStateForUpdate:]):

2005-08-03  John Sullivan  <sullivan@apple.com>

        Reviewed by Geoff Garen.
        
        - fixed <rdar://problem/3918675> Remove code to replace authentication dialog 
        with a subclass when out of localization freeze

        * Panels.subproj/WebAuthenticationPanel.h:
        moved declaration of NonBlockingPanel here so it can be accessed by the nib
        * Panels.subproj/WebAuthenticationPanel.m:
        (-[WebAuthenticationPanel replacePanelWithSubclassHack]):
        removed this method
        (-[WebAuthenticationPanel loadNib]):
        stop calling the removed method

        * Panels.subproj/English.lproj/WebAuthenticationPanel.nib/classes.nib:
        * Panels.subproj/English.lproj/WebAuthenticationPanel.nib/info.nib:
        * Panels.subproj/English.lproj/WebAuthenticationPanel.nib/objects.nib:
        the panel in the nib now has custom class NonBlockingPanel

2005-08-03  Beth Dakin  <bdakin@apple.com>

        Reviewed by cblu

	Removing calls to WKCreateUncorrectedRGBColorSpace and
        WKCreateUncorrectedGrayColorSpace in WebKit to patch up
	TOT...Eric removed them from WebCore last night.

        * WebCoreSupport.subproj/WebImageData.m:
        * WebCoreSupport.subproj/WebImageRenderer.m:
        (WebCGColorSpaceCreateRGB):
        (WebCGColorSpaceCreateGray):

2005-08-02  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin Adler.
        
        Preemptively moved some WebMenuItemTag values from SPI to API, in anticipation of
        approval from macosx-api-reviewers. Retitled one of them in response to API reviewers feedback:
        WebMenuItemSearchInGoogle -> WebMenuItemSearchWeb
        
        Note that as a side effect of this change, the actual numbers used for these WebMenuItemTags has
        changed from what it was in Tiger. This causes "Search in Spotlight", "Search in Google", and
        "Look Up in Dictionary" to not appear in Tiger Safari if running on tip of tree WebKit.

        * WebView.subproj/WebUIDelegatePrivate.h:
        removed WebMenuItemTagSearchInSpotlight, WebMenuItemTagSearchInGoogle, and WebMenuItemTagLookUpInDictionary

        * WebView.subproj/WebUIDelegate.h:
        added WebMenuItemTagSearchInSpotlight, WebMenuItemTagSearchWeb, and WebMenuItemTagLookUpInDictionary

        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        (-[WebDefaultUIDelegate menuItemWithTag:]):
        updated for rename
        (-[WebDefaultUIDelegate contextMenuItemsForElement:defaultMenuItems:]):
        ditto
        (-[WebDefaultUIDelegate editingContextMenuItemsForElement:defaultMenuItems:]):
        ditto
        
2005-08-01  Geoffrey Garen  <ggaren@apple.com>

        -fixed <rdar://problem/3572585> window.open fails if name param = 
        the name of a window just closed in same function

        Reviewed by darin.

        Test cases added:

        * manual-tests/open-after-close.html: Added.
        * manual-tests/resources/open-after-close-popup.html: Added.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge closeWindowSoon]): We now remove a WebView from 
        WebViewSets when the WebView is *scheduled* to close.

2005-08-01  John Sullivan  <sullivan@apple.com>

        * PublicHeaderChangesFromTiger.txt:
        added a comment about isTextField -> _isTextField

2005-08-01  John Sullivan  <sullivan@apple.com>

        Patch by Trey Matteson <trey@usa.net>
        Reviewed by me.

        Fixed http://bugs.webkit.org/show_bug.cgi?id=4255
          underlines still print too thick

        The real problem here is that we have code that scales a 0 width line to always
        be width=1.0 in device space.  I'm leaving that in for the screen, but when printing
        a width of 0.5 looks good.

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer drawLineForCharacters:yOffset:width:color:thickness:]):

2005-08-01  Eric Seidel  <eseidel@apple.com>

        Reviewed by darin.

        * WebCoreSupport.subproj/WebGraphicsBridge.m:
        removed create*ColorSpace methods, now using CG API directly.
        http://bugs.webkit.org/show_bug.cgi?id=4211

2005-07-31  John Sullivan  <sullivan@apple.com>

        Patch by Trey Matteson <trey@usa.net>
        Reviewed by me.

        Fixed http://bugs.webkit.org/show_bug.cgi?id=4014
          PDF files by default load with a poor choice of sizing

        For now the various PDF viewing settings are sticky, stored in 2 new defaults.  Since
        there are a number of ways these settings are changed, I made a proxy for the PDFView
        through which all view changing messages are sent.  The proxy adds the behavior of
        updating the defaults upon any change.

        * Misc.subproj/WebNSDictionaryExtras.h:
        * Misc.subproj/WebNSDictionaryExtras.m:
        (-[NSMutableDictionary _webkit_setFloat:forKey:]):  New support method.
        * WebView.subproj/WebPDFView.h:
        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView initWithFrame:]):  Create proxy for PDFView.
        (-[WebPDFView dealloc]):  Free proxy.
        (-[WebPDFView _menuItemsFromPDFKitForEvent:]):  For relevant context menu items, set the
            target to the proxy instead of the PDFView.
        (-[WebPDFView _readPDFDefaults]):  Init PDFView with settings from defaults.
        (-[WebPDFView layout]):  Call _readPDFDefaults, once.  This turned out to be the best hook.
        (-[WebPDFView _makeTextSmaller:]):  Change PDFView via proxy
        (-[WebPDFView _makeTextLarger:]):  Ditto
        (-[WebPDFView _makeTextStandardSize:]):  Ditto
        (-[PDFPrefUpdatingProxy initWithView:]):  trivial
        (-[PDFPrefUpdatingProxy forwardInvocation:]):  Forward the msg, then update defaults
        (-[PDFPrefUpdatingProxy methodSignatureForSelector:]):  Simple forwarding support.
        * WebView.subproj/WebPreferenceKeysPrivate.h:
        * WebView.subproj/WebPreferences.m:
        (+[WebPreferences initialize]):  Set initial values for new PDF viewing defaults.
        (-[WebPreferences _integerValueForKey:]):  Nuke stray comment.
        (-[WebPreferences _floatValueForKey:]):  New simple support method.
        (-[WebPreferences _setFloatValue:forKey:]):  Ditto.
        (-[WebPreferences PDFScaleFactor]):  4 accessors for new defaults 
        (-[WebPreferences setPDFScaleFactor:]):
        (-[WebPreferences PDFDisplayMode]):
        (-[WebPreferences setPDFDisplayMode:]):
        * WebView.subproj/WebPreferencesPrivate.h:

2005-08-01  Justin Garcia  <justin.garcia@apple.com>

        Patch by Trey Matteson <trey@usa.net>

        Reviewed by Maciej.

        Fixed <http://bugs.webkit.org/show_bug.cgi?id=4226>
          link underlines print too thickly

        Reinstate the fix made by sullivan on 1/11/05.  There was a merge
        error with an mjs fix on 1/13/05.

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer drawLineForCharacters:yOffset:width:color:thickness:]):

2005-07-30  Maciej Stachowiak  <mjs@apple.com>

        Build fixes for previous change (missing includes)

        * WebView.subproj/WebFrame.m:
        * WebView.subproj/WebScriptDebugDelegate.m:

2005-07-29  Maciej Stachowiak  <mjs@apple.com>

        Changes by Michael Kahl, reviewed by me.

	- fixed <rdar://problem/4164112> MASTER: JavaScript debugging support
	
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge windowObjectCleared]):
        * WebCoreSupport.subproj/WebSubresourceLoader.m:
        * WebKit.xcodeproj/project.pbxproj:
        * WebView.subproj/WebDefaultScriptDebugDelegate.h: Added.
        * WebView.subproj/WebDefaultScriptDebugDelegate.m: Added.
        (+[WebDefaultScriptDebugDelegate sharedScriptDebugDelegate]):
        (-[WebDefaultScriptDebugDelegate webView:didParseSource:fromURL:sourceId:forWebFrame:]):
        (-[WebDefaultScriptDebugDelegate webView:didEnterCallFrame:sourceId:line:forWebFrame:]):
        (-[WebDefaultScriptDebugDelegate webView:willExecuteStatement:sourceId:line:forWebFrame:]):
        (-[WebDefaultScriptDebugDelegate webView:willLeaveCallFrame:sourceId:line:forWebFrame:]):
        * WebView.subproj/WebFrame.m:
        (-[WebFramePrivate dealloc]):
        (-[WebFrame _attachScriptDebugger]):
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebScriptDebugDelegate.h: Added.
        * WebView.subproj/WebScriptDebugDelegate.m: Added.
        (-[WebScriptDebugger initWithWebFrame:]):
        (-[WebScriptDebugger dealloc]):
        (-[WebScriptDebugger globalObject]):
        (-[WebScriptDebugger newWrapperForFrame:]):
        (-[WebScriptDebugger parsedSource:fromURL:sourceId:]):
        (-[WebScriptDebugger enteredFrame:sourceId:line:]):
        (-[WebScriptDebugger hitStatement:sourceId:line:]):
        (-[WebScriptDebugger leavingFrame:sourceId:line:]):
        (-[WebScriptCallFrame _initWithFrame:]):
        (-[WebScriptCallFrame dealloc]):
        (-[WebScriptCallFrame setUserInfo:]):
        (-[WebScriptCallFrame userInfo]):
        (-[WebScriptCallFrame caller]):
        (-[WebScriptCallFrame scopeChain]):
        (-[WebScriptCallFrame functionName]):
        (-[WebScriptCallFrame exception]):
        (-[WebScriptCallFrame evaluateWebScript:]):
        * WebView.subproj/WebScriptDebugDelegatePrivate.h: Added.
        * WebView.subproj/WebView.h:
        * WebView.subproj/WebView.m:
        (-[WebViewPrivate dealloc]):
        (-[WebView _scriptDebugDelegateForwarder]):
        (-[WebView setScriptDebugDelegate:]):
        (-[WebView scriptDebugDelegate]):
        * WebView.subproj/WebViewInternal.h:
        * WebView.subproj/WebViewPrivate.h:

2005-07-26  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Dave Hyatt.

	- fixed http://bugs.webkit.org/show_bug.cgi?id=4153
	
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _purgePageCache]): Find the oldest candidate for
	purging that is not a snapback item.

2005-07-29  David Harrison  <harrison@apple.com>

        Reviewed by Dave Hyatt (rendering) and Maciej (editing and performance improvements).

        Test cases added: Existing tab-related basic editing tests were updated.  More complex tests are coming soon.

        <rdar://problem/3792529> REGRESSION (Mail): Tabs do not work the way they did in Panther (especially useful in plain text mail)
        
        Basic strategy is to put tabs into spans with white-space:pre style, and
        render them with tabs stops every 8th space, where the space width and
        the left margin are those of the enclosing block.

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (isSpace):
        (isRoundingHackCharacter):
        (getUncachedWidth):
        (-[WebTextRenderer drawLineForCharacters:yOffset:width:color:thickness:]):
        (-[WebTextRenderer _computeWidthForSpace]):
        (_drawGlyphs):
        (-[WebTextRenderer _CG_drawHighlightForRun:style:geometry:]):
        (-[WebTextRenderer _CG_floatWidthForRun:style:widths:fonts:glyphs:startPosition:numGlyphs:]):
        (-[WebTextRenderer _extendCharacterToGlyphMapToInclude:]):
        (-[WebTextRenderer _CG_pointToOffset:style:position:reversed:includePartialGlyphs:]):
        (glyphForCharacter):
        (initializeCharacterWidthIterator):
        (ceilCurrentWidth):
        (widthForNextCharacter):

2005-07-29  John Sullivan  <sullivan@apple.com>

        Reviewed by Dave Hyatt.
        
        - WebKit part of <rdar://problem/4187404> Redo form SPI so that it doesn't rely on NSViews
        
        Much of 4187404 was addressed in earlier checkins. This checkin completes the task.

        * WebView.subproj/WebHTMLRepresentation.h:
        * WebView.subproj/WebHTMLRepresentation.m:
        removed viewForElement:, which was the only remaining NSView-related SPI that Safari autofill was
        still using. I added viewForElement a week ago as a transitional measure, so removing it won't
        affect any other clients.

2005-07-29  John Sullivan  <sullivan@apple.com>

        Reviewed by Chris Blumenberg.

        * WebView.subproj/WebFrameView.m:
        (-[WebFrameView _firstResponderIsFormControl]):
        renamed from _firstResponderIsControl for clarity. Explicitly rejects WebHTMLView, since
        it's now a control.
        (-[WebFrameView keyDown:]):
        updated for renamed method.

2005-07-28  John Sullivan  <sullivan@apple.com>

        Reviewed by Beth Dakin.
        
        - removed method -[WebHTMLRepresentation elementForView:], which was SPI used only for
        Safari autofill. Tip of tree Safari no longer includes any calls to this method. Also, 
        Tiger Safari never gets around to actually calling it due to the other recent form-SPI-related
        changes, so removing this method doesn't break Tiger Safari running on tip of tree WebKit
        (though autofill continues to not work in that configuration).

        * WebView.subproj/WebHTMLRepresentation.h:
        * WebView.subproj/WebHTMLRepresentation.m:
        (-[WebHTMLRepresentation elementForView:]): removed
        
2005-07-27  John Sullivan  <sullivan@apple.com>

	Patch by Trey Matteson <trey@usa.net>
        Reviewed by me.

        Fixed http://bugs.webkit.org/show_bug.cgi?id=4169
          scaling PDF view up leaves later HTML view scaled too

        An additional step of separating scaling of HTML and PDF.  If we do a zoom and there
        are no docViews that track the common scaling factor, then don't change it.  Thus in
        the common PDF case where it is the only doc view, scaling the PDF does not affect
        HTML pages loaded in the same window.

        * WebView.subproj/WebView.m:
        (-[WebView canMakeTextSmaller]):  Pass 0 for new scaling factor, since we just querying.
        (-[WebView canMakeTextLarger]):  Ditto.
        (-[WebView makeTextSmaller:]):  Pass new scaling factor.
        (-[WebView makeTextLarger:]):  Ditto.
        (-[WebView canMakeTextStandardSize]):  Pass 0 for new scaling factor.
        (-[WebView makeTextStandardSize:]):  Pass new scaling factor.
        (-[WebView _performTextSizingSelector:withObject:onTrackingDocs:selForNonTrackingDocs:newScaleFactor:]):
          The meat of the change is that this Swiss Army Knife also takes a new scaling
          factor, which it will set as the common scaling factor if it finds any doc views that
          are able to be scaled which track the common scaling factor.

2005-07-27  John Sullivan  <sullivan@apple.com>

	Patch by Trey Matteson <trey@usa.net>
        Reviewed by me.

        Fixed http://bugs.webkit.org/show_bug.cgi?id=4015
          PDF views should remember viewing mode, scroll position across back/forward
          Note this doesn't work within frames because of a PDFKit bug - see 4164
        Fixed http://bugs.webkit.org/show_bug.cgi?id=4091
          PDF views should keep a separate scaling factor from shared text scaling factor

        Basic idea #1 is that we now have a general mechanism for a WebDocView to save/restore some UI
        state to the WebHistoryItem.
        Basic idea #2 is that _WebDocumentTextSizing is expanded to allow for the case of a WebDocView
        keeping its own notion of a scaling factor.  WebPDFView's -_tracksCommonSizeFactor has justification.

        * History.subproj/WebHistoryItem.m:
        (-[WebHistoryItem setViewState:]):  New methods to hold PList of arbitrary WebView state
        (-[WebHistoryItem viewState]):
        * History.subproj/WebHistoryItemPrivate.h:
        * WebKit.xcodeproj/project.pbxproj:  Add Quartz to framework path so we can import PDFKit files
        * WebView.subproj/WebDocumentInternal.h:  New methods added to _WebDocumentTextSizing.
          Also the _ prefix is sufficient instead of _web_WebDocumentTextSizing.
          Added _WebDocumentViewState protocol.
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _createItemTreeWithTargetFrame:clippedAtTarget:]):  Rename of save/restore methods.
        (-[WebFrame _detachFromParent]):  Ditto
        (-[WebFrame _transitionToCommitted:]):  Ditto
        (-[WebFrame _checkLoadCompleteForThisFrame]):  Ditto
        (-[WebFrame _loadItem:withLoadType:]):  Ditto
        (-[WebFrame _recursiveGoToItem:fromItem:withLoadType:]):  Ditto
        (-[WebFrame _saveViewStateToItem:]):  Call doc view to retrieve view state.
        (-[WebFrame _restoreViewState]):  Call doc view to set view state.
        (-[WebFrame _scrollToTop]):  Nuked dead code.
        (-[WebFrame _textSizeMultiplierChanged]):  This work now appears in WebView.
        (-[WebFrame _saveDocumentAndScrollState]):  Same rename, one code cleanup.
        (-[WebFrame _accumulateDocumentViews:]): Add our docview to the array, call kids.
        (-[WebFrame _documentViews]):  New helper to return all docviews.
        (-[WebFrame _didFirstLayout]):  Same name change.
        * WebView.subproj/WebFrameInternal.h:
        * WebView.subproj/WebFramePrivate.h:
        * WebView.subproj/WebHTMLView.m:  Removed redundant category decl.
        (-[WebHTMLView _makeTextSmaller:]):  Implement new protocol.
        (-[WebHTMLView _makeTextLarger:]):
        (-[WebHTMLView _makeTextStandardSize:]):
        (-[WebHTMLView _tracksCommonSizeFactor]):
        * WebView.subproj/WebPDFRepresentation.m:  Tweak #imports.
        * WebView.subproj/WebPDFView.h:
        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView _menuItemsFromPDFKitForEvent:]):  No longer intercept context menu text sizing items.
        (-[WebPDFView setDataSource:]):  No longer track the WebView's scaling factor.
        (-[WebPDFView scrollPoint]):  Dig through PDFKit view tree to get real scroll position
        (-[WebPDFView setScrollPoint:]):  Ditto
        (-[WebPDFView viewState]):  Return bundle of viewing params
        (-[WebPDFView setViewState:]):  Restore bundle of viewing params
        (-[WebPDFView _makeTextSmaller:]):  Implement new text sizing protocol
        (-[WebPDFView _makeTextLarger:]):
        (-[WebPDFView _makeTextStandardSize:]):
        (-[WebPDFView _tracksCommonSizeFactor]):
        (-[WebPDFView _canMakeTextSmaller]):
        (-[WebPDFView _canMakeTextLarger]):
        (-[WebPDFView _canMakeTextStandardSize]):
        * WebView.subproj/WebTextView.m:
        (-[WebTextView _makeTextSmaller:]):  Implement new text sizing protocol
        (-[WebTextView _makeTextLarger:]):
        (-[WebTextView _makeTextStandardSize:]):
        (-[WebTextView _tracksCommonSizeFactor]):
        * WebView.subproj/WebView.m:
        (-[WebView setTextSizeMultiplier:]):  Calling docViews is now more complicates than just posting
           a notification to the frame.
        (-[WebView _performTextSizingSelector:withObject:onTrackingDocs:selForNonTrackingDocs:]):  Workhorse
           that sends the text sizing method to the right doc views.
        (-[WebView canMakeTextSmaller]):  Call workhorse.
        (-[WebView canMakeTextLarger]):  Ditto
        (-[WebView makeTextSmaller:]):  Ditto
        (-[WebView makeTextLarger:]):  Ditto
        (-[WebView canMakeTextStandardSize]):  Ditto
        (-[WebView makeTextStandardSize:]):  Ditto

2005-07-26  Justin Garcia  <justin.garcia@apple.com>

        Patch by Trey Matteson <trey@usa.net>

        Reviewed by John Sullivan.
        
        Fixed <http://bugs.webkit.org/show_bug.cgi?id=4072>
        Pressing back in browser misses out a page
        
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _transitionToCommitted:]):  When reloading the same page or refreshing the
        page, update the URL in the b/f item with the URL that we wind up at.  Due to cookies,
        it might be different than the result we just got when we loaded the same page.

2005-07-26  David Hyatt  <hyatt@apple.com>

	Make WebHTMLView inherit from NSControl instead of NSView.
	This change is necessary because the theme renderer for
	WebCore that draws controls with the Aqua appearance does so
	using NSCells.  NSCells must be hosted within a control view
	in order to paint properly.

	The method updateCell must be overridden because it wants to
	repaint the whole control when the windows resigns/becomes
	key, and this would result in behavior that we don't want
	(the repainting of the whole view).  We already have hooks
	in WebHTMLView for the window resigning/becoming key so
	we will do our proper control updating there instead (in a
	future patch).

        Reviewed by john

        * WebView.subproj/WebHTMLView.h:
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView updateCell:]):
        
2005-07-26  John Sullivan  <sullivan@apple.com>

        Reviewed by Chris Blumenberg.
        
        - more work to wean form-related SPI from NSView. All that's left (but this is a big "all")
        is viewForElement: and elementForView:        

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge textField:doCommandBySelector:]):
        changed signature to pass along DOMElement* rather than NSView*
        
        * WebView.subproj/WebFormDelegate.h:
        * WebView.subproj/WebFormDelegate.m:
        (-[WebFormDelegate textField:doCommandBySelector:inFrame:]):
        ditto

2005-07-25  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin Adler.
        
        - big hunk of weaning form-related SPI from NSView; autofill continues to
        work (but only on tip of tree Safari)
        
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge textFieldDidBeginEditing:]):
        changed name from controlTextXXX:, now takes a DOMHTMLInputElement*
        (-[WebBridge textFieldDidEndEditing:]):
        ditto
        (-[WebBridge textDidChangeInTextField:]):
        ditto
        (-[WebBridge textDidChangeInTextArea:]):
        changed name from textDidChange:, now takes a DOMHTMLTextAreaElement*
        (-[WebBridge control:textShouldBeginEditing:]):
        removed this method as it wasn't being used by autofill, and did nothing in WebKit
        (-[WebBridge control:textShouldEndEditing:]):
        ditto
        (-[WebBridge textField:shouldHandleEvent:]):
        changed name from control:textView:shouldHandleEvent:, now takes a DOMHTMLInputElement*.
        The textView parameter wasn't being used, so I eliminated it.
        
        * WebView.subproj/WebFormDelegate.h:
        * WebView.subproj/WebFormDelegate.m:
        (-[WebFormDelegate textFieldDidBeginEditing:inFrame:]):
        (-[WebFormDelegate textFieldDidEndEditing:inFrame:]):
        (-[WebFormDelegate control:textShouldBeginEditing:inFrame:]):
        (-[WebFormDelegate control:textShouldEndEditing:inFrame:]):
        (-[WebFormDelegate textDidChangeInTextField:inFrame:]):
        (-[WebFormDelegate textDidChangeInTextArea:inFrame:]):
        (-[WebFormDelegate textField:shouldHandleEvent:inFrame:]):
        These all changed in the same way as the WebBridge methods
        

2005-07-25  Vicki Murley <vicki@apple.com>

        Reviewed by Darin.
 
	- fixed <rdar://problem/3470523> Safari's user agent should be changed to say Intel rather 
	than PPC on Intel machines

        * WebView.subproj/WebView.m: add conditional #defines for "PPC" and "Intel"
        (-[WebView userAgentForURL:]): use this variable when constructing the user agent string

2005-07-24  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by mjs
        
        - Fixes <rdar://problem/4120535> deleteToEndOfLine: does not delete thew newline when at the end of a line
            Fix to match NSTextView.  Delete the next character if deleteToEndOfLine fails

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView deleteToEndOfLine:]):

2005-07-24  Justin Garcia  <justin.garcia@apple.com>

        Patch by Trey Matteson <trey@apple.com>

        Reviewed by john
        
        Fixes <http://bugs.webkit.org/show_bug.cgi?id=3953> back-forward items have wrong titles after sub-frame navigations

        This was caused by a mistaken data structure, where WebDataSource tried to keep a list of
        b/f items it was responsible for.  The problem arose in the case of frames, where a subframe
        was loaded with new content.  When this happens a fresh tree of b/f items is created,
        but the reference in the DataSource still pointed to the old item.

        Since the WebFrame does a lot of work to track the current b/f item, the easiest thing is to
        get rid of the DataSource's reference, and have it ask the WebFrame to set the title on the
        right b/f item.

        * WebView.subproj/WebDataSource.m:
        (-[WebDataSourcePrivate dealloc]):
        (-[WebDataSource _setTitle:]):
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _createItem:]):
        (-[WebFrame _transitionToCommitted:]):
        (-[WebFrame _loadURL:referrer:loadType:target:triggeringEvent:form:formValues:]):
        (-[WebFrame _setTitle:]):
        * WebView.subproj/WebFramePrivate.h:

2005-07-24  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by kevin
        
        Fixed make clean problem

        * Makefile.am:

2005-07-23  Justin Garcia  <justin.garcia@apple.com>

        Patch by <opendarwin.org@mitzpettel.com>

        Reviewed by darin and hyatt
        
        Fixes <http://bugs.webkit.org/show_bug.cgi?id=3862>
        The fix for <http://bugs.webkit.org/show_bug.cgi?id=3545> enclosed each run of visually ordered
        hebrew with LRO and PDF control characters, but adjusted the run's to and from to include those characters,
        so that they would be rendered if the font includes a glyph for bidi control characters.
        
        Also adding a manual test

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (reverseCharactersInRun):

2005-07-22  John Sullivan  <sullivan@apple.com>

        Reviewed by Justin Garcia.
        
        Mail (running on tip of tree WebKit) was running into an assertion I recently added.
        The assertion is actually correct, catching an old bug in this code.

        * WebView.subproj/WebView.m:
        (-[WebView selectedFrame]):
        if the first responder is a WebFrameView, then we've found the WebFrameView we're 
        looking for, and we shouldn't look at its superviews.

2005-07-22  John Sullivan  <sullivan@apple.com>

        Reviewed by Chris Blumenberg.

        - some changes in the direction of weaning all the form-related SPI from NSView

        * PublicHeaderChangesFromTiger.txt:
        noted that the WebCore change to add -[DOMHTMLInputElement isTextField] to
        DOMExtensions.h is a public header change.

        * WebView.subproj/WebHTMLRepresentation.h:
        * WebView.subproj/WebHTMLRepresentation.m:
        (-[WebHTMLRepresentation viewForElement:]):
        added viewForElement: as a stopgap measure. This allowed me to convert controlsInForm:
        to return DOMElements rather than NSViews, while keeping autocomplete working in
        Safari tip of tree. When I finish the SPI conversion I'll delete this method. Note that
        from this point on, autocomplete will not work in Tiger Safari with tip of tree WebKit
        (it will always fail to find anything to autocomplete)

2005-07-21  Adele Peterson  <adele@apple.com>

        Reviewed by Darin.

        Changing temporary #ifndef to #if

        * WebCoreSupport.subproj/WebImageData.m:
        (-[WebImageData _checkSolidColor:]):

2005-07-21  Adele Peterson  <adele@apple.com>

        Reviewed by Chris Blumenberg.

        - fixed <rdar://problem/4132797> don't register thin PPC WebKit plug-ins
        Merged fix for:
        <rdar://problem/4127100> [WebKit] 8B1016: After installing Acrobat Reader, can no longer see pdf's in Safari

        * Plugins.subproj/WebBasePluginPackage.h: Added isNativeLibraryData method.
        * Plugins.subproj/WebBasePluginPackage.m: (-[WebBasePluginPackage isNativeLibraryData:]): Added isNativeLibraryData method.
        * Plugins.subproj/WebNetscapePluginPackage.m: (-[WebNetscapePluginPackage initWithPath:]):
          calls isNativeLibraryData to determine whether or not to register the plug-in.
        * Plugins.subproj/WebPluginPackage.m: (-[WebPluginPackage initWithPath:]): ditto.
        * WebCoreSupport.subproj/WebImageData.m: (-[WebImageData _checkSolidColor:]): added comment for #ifdef.

2005-07-21  Geoffrey Garen  <ggaren@apple.com>

        * WebKit.pbproj/project.pbxproj: Removed.

2005-07-21  Geoffrey Garen  <ggaren@apple.com>

        * WebKit.xcodeproj/.cvsignore: Added.

2005-07-21  Geoffrey Garen  <ggaren@apple.com>

        * WebKit.xcodeproj/project.pbxproj: Added.

2005-07-21  Geoffrey Garen  <ggaren@apple.com>

        * Makefile.am:

2005-07-20  John Sullivan  <sullivan@apple.com>

        Reviewed by Vicki Murley.

        - removed some form-related methods that weren't being used anywhere, in preparation
        for weaning WebKit's WebFormDelegate protocol from NSView.

        * WebCoreSupport.subproj/WebBridge.m:
        * WebView.subproj/WebFormDelegate.h:
        * WebView.subproj/WebFormDelegate.m:
        removed these methods:
        -control:didFailToFormatString:errorDescription:
        -control:didFailToValidatePartialString:errorDescription:
        -control:isValidObject:

2005-07-20  Adele Peterson  <adele@apple.com>

          Merged fix for:
          <rdar://problem/4125127> [WebKit] horizontal rulers don't render on Safari on web.apple.com

          * WebCoreSupport.subproj/WebImageData.m:
          (-[WebImageData _checkSolidColor:]):

2005-07-20  Adele Peterson  <adele@apple.com>

        Merged fix for :
        <rdar://problem/4118278> mail divide by zero navigating messages
  
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer _extendGlyphToWidthMapToInclude:font:]):

2005-07-20  John Sullivan  <sullivan@apple.com>

        Reviewed by Adele Peterson.
        
        - added -[WebView selectedFrame] to SPI (pending public API), needed for 4180958

        * WebView.subproj/WebView.m:
        (-[WebView selectedFrame]):
        new method, extracted from _selectedOrMainFrame
        (-[WebView _selectedOrMainFrame]):
        now calls extracted method
        
        * WebView.subproj/WebViewPrivate.h:
        add -selectedFrame to PendingPublic category

2005-07-19  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin Adler.
        
        - cleaned up code related to dealing with the "selected frame"; fixes radar bugs 4118830 and 4118820

        * WebView.subproj/WebTextView.m:
        (-[WebTextView resignFirstResponder]):
        call deselectAll here instead of replicating its guts, just for clarity
        
        * WebView.subproj/WebViewInternal.h:
        eliminated category WebInternal; all of these methods were used only inside WebView.m, so I moved
        them into the existing category WebFileInternal that was declared and implemented in WebView.m
        
        * WebView.subproj/WebView.m:
        (-[WebView searchFor:direction:caseSensitive:wrap:]):
        updated for name changes. Also, uses new _deselectFrame: to clear the selection if the found
        text is in a different frame.
        (-[WebView pasteboardTypesForSelection]):
        (-[WebView writeSelectionWithPasteboardTypes:toPasteboard:]):
        (-[WebView setSelectedDOMRange:affinity:]):
        (-[WebView selectedDOMRange]):
        (-[WebView selectionAffinity]):
        (-[WebView setTypingStyle:]):
        (-[WebView typingStyle]):
        (-[WebView styleDeclarationWithText:]):        
        (-[WebView replaceSelectionWithNode:]):
        (-[WebView replaceSelectionWithText:]):
        (-[WebView replaceSelectionWithMarkupString:]):
        (-[WebView replaceSelectionWithArchive:]):
        (-[WebView deleteSelection]):
        (-[WebView applyStyle:]):
        updated for name changes only
        
        (-[WebView _frameIsSelected:]):
        new method, returns YES if given frame has a non-zero-length selection
        (-[WebView _deselectFrame:]):
        new method, clears selection from given frame
        (-[WebView _findSelectedFrameStartingFromFrame:]):
        new method, recursive helper used by _findSelectedFrame
        (-[WebView _findSelectedFrame]):
        new method, finds first frame that returns YES for _frameIsSelected, or nil
        (-[WebView _debugCollectSelectedFramesIntoArray:startingFromFrame:]):
        new method, recursive helper used by _debugCheckForMultipleSelectedFrames
        (-[WebView _debugCheckForMultipleSelectedFrames]):
        new method for debugging, fires an assertion if there's more than one selected frame.
        (-[WebView _selectedOrMainFrame]):
        renamed from _frameForCurrentSelection, which was a misleading name since the returned
        frame does not necessarily have a selection (or even focus). Now checks for a selected
        but non-focused frame if the first responder is not in any frame. Also, moved in file
        from WebInternal category to WebFileInternal category.
        (-[WebView _bridgeForSelectedOrMainFrame]):
        renamed from _bridgeForCurrentSelection, which was a misleading name for the same
        reasons as _frameForCurrentSelection. Also, moved in file from WebInternal category to
        WebFileInternal category.
        (-[WebView _isLoading]):
        (-[WebView _frameViewAtWindowPoint:]):
        (-[WebView _bridgeAtPoint:]):
        just moved in file from WebInternal category to WebFileInternal category

2005-07-19  Darin Adler  <darin@apple.com>

        Reviewed by Geoff Garen.

        - improve handling of plug-ins when the WebView or a superview is hidden with -[NSView setHidden]

        * Plugins.subproj/WebBaseNetscapePluginView.m: (-[WebBaseNetscapePluginView saveAndSetPortStateForUpdate:]):
        Add "hidden" to the list of reasons to clip out all plug-in drawing.

2005-07-18  John Sullivan  <sullivan@apple.com>
        
        Written by Trey Matteson  <trey@usa.net>
        Reviewed by John Sullivan.

        Fixed http://bugs.webkit.org/show_bug.cgi?id=4049
          scroll position not restored when going back/forward at ebay
        Fixed http://bugs.webkit.org/show_bug.cgi?id=4061
          When going back/forward to some pages, they redraw at top before restoring scroll position

        The short story is that attempting to restore the scroll position
        at the time when the first layout finishes addresses both of these
        issues.  An explanation of the underlying race condition is in
        a large comment near -_restoreScrollPosition.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge didFirstLayout]):  Pass through to WebFrame.
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _transitionToCommitted:]):  Get rid of attempt to
          restoreScrollPosition that never did anything because the
          docView was always 0x0 size at that point.
        (-[WebFrame _opened]):  Get rid of redundant call to restoreScrollPosition.
          The imminent call to layoutCompleted makes the same call.
        (-[WebFrame _didFirstLayout]):  Restore the scroll position on
          first layout, if we're doing a b/f nav.
        * WebView.subproj/WebFrameInternal.h:

2005-07-18  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin Adler.

        - fixed these bugs:
        <rdar://problem/4158121> context menu in PDF view should contain the selection-based items like Copy
        <rdar://problem/4184691> WebPDFView should conform to the WebDocumentElement protocol
        <rdar://problem/4184663> "Search in Spotlight" is present but dimmed in context menu for plain-text documents

        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        (-[WebDefaultUIDelegate contextMenuItemsForElement:defaultMenuItems:]):
        added ASSERT and comments

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _searchWithGoogleFromMenu:]):
        removed this method (now handled by WebView)
        (-[WebHTMLView _searchWithSpotlightFromMenu:]):
        ditto
        (-[WebHTMLView validateUserInterfaceItem:]):
        removed validation for removed items. The validation wasn't necessary anyway, since we only put these items
        in the menu in the case where they should be enabled.

        * WebView.subproj/WebPDFView.h:
        now conforms to WebDocumentElement protocol (which lets [WebView elementAtPoint:] work better)
        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView copy:]):
        added, hands off to PDFView, needed to enable Copy in context menu
        (-[WebPDFView _pointIsInSelection:]):
        new method, checks whether given point is in the selected bounds
        (-[WebPDFView elementAtPoint:]):
        add WebElementIsSelectedKey to returned element
        (-[WebPDFView menuForEvent:]):
        use actual point instead of dummy placeholder, now that we have code that pays attention to the point

        * WebView.subproj/WebView.m:
        (-[WebView _searchWithGoogleFromMenu:]):
        moved here from WebHTMLView so it will work for any documentView that conforms to WebDocumentText.
        Rewrote slightly to be non-WebHTMLView-specific. (This menu item was always enabled in Safari because
        Safari replaces its action, but it would not have been always enabled in other WebKit clients, though
        it should have been.)
        (-[WebView _searchWithSpotlightFromMenu:]):
        moved here from WebHTMLView so it will work for any documentView that conforms to WebDocumentText.
        Rewrote slightly to be non-WebHTMLView-specific.

2005-07-18  John Sullivan  <sullivan@apple.com>

        Reviewed by Richard Williamson.
        
        - fixed <rdar://problem/4184366> WebPDFView should conform to the WebDocumentSelection protocol

        * Misc.subproj/WebNSAttributedStringExtras.h: Added.
        * Misc.subproj/WebNSAttributedStringExtras.m: Added.
        (-[NSAttributedString _web_attributedStringByStrippingAttachmentCharacters]):
        New category on NSAttributedString, initially contains this one method that had been in WebHTMLView.
        
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _writeSelectionWithPasteboardTypes:toPasteboard:cachedAttributedString:]):
        now uses _web_attributedStringByStrippingAttachmentCharacters
        
        * WebView.subproj/WebPDFView.h:
        now conforms to WebDocumentSelection protocol
        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView selectionRect]):
        new, implementation of WebDocumentSelection protocol method
        (-[WebPDFView pasteboardTypesForSelection]):
        ditto
        (-[WebPDFView writeSelectionWithPasteboardTypes:toPasteboard:]):
        ditto

        * WebKit.pbproj/project.pbxproj:
        updated for new files

2005-07-18  John Sullivan  <sullivan@apple.com>

        Reviewed by Chris Blumenberg.
        
        - some refactoring cleanup in the selection/searching code

        * Misc.subproj/WebSearchableTextView.h:
        moved WebDocumentSelection protocol conformation to this class, was in subclass WebTextView
        * Misc.subproj/WebSearchableTextView.m:
        (-[WebSearchableTextView selectionRect]):
        new method (moved here from Safari) to return a single rect encompassing all selected text
        (-[WebSearchableTextView pasteboardTypesForSelection]):
        moved here from WebTextView
        (-[WebSearchableTextView writeSelectionWithPasteboardTypes:toPasteboard:]):
        ditto
        
        * WebView.subproj/WebDocumentInternal.h:
        moved WebDocumentSelection protocol out of here
        
        * WebView.subproj/WebDocumentPrivate.h:
        moved WebDocumentSelection protocol into here, added selectionRect method
        
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView selectionRect]):
        new method, calls existing bridge method formerly called by _selectionRect
        (-[WebHTMLView _selectionRect]):
        now calls [self selectionRect]. We can't just delete _selectionRect because it's used by Mail.
        
        * WebView.subproj/WebHTMLViewPrivate.h:
        removed _selectionRect since it's in WebDocumentSelection now
        
        * WebView.subproj/WebTextView.h:
        removed WebDocumentSelection from protocol list since it's in superclass now
        
        * WebView.subproj/WebTextView.m:
        removed old WebDocumentSelection methods because they are in superclass now

2005-07-15  Adele Peterson  <adele@apple.com>

        Written by Trey Matteson  <trey@usa.net>
        Reviewed by John Sullivan.

        Fixed http://bugs.webkit.org/show_bug.cgi?id=3910 - REGRESSION: Replying "Cancel" to the form repost nag leaves wrong b/f cursor

        * WebView.subproj/WebFrame.m:
        (-[WebFrame _resetBackForwardList]):  new helper method
        (-[WebFrame _continueLoadRequestAfterNavigationPolicy:formState:]):
          If the delegate bailed on the navigation, tell the main frame
          to reset the b/f cursor back to where it was before we started.

2005-07-15  John Sullivan  <sullivan@apple.com>

        Written by Trey Matteson
        Reviewed by me.

        Fix for http://bugs.webkit.org/show_bug.cgi?id=4013
                text find doesn't wrap in PDF files

        This just works once WebPDFView implements the WebDocumentText protocol, which is
        mostly just a matter of forwarding the methods to PDFKit appropriately.

        * WebView.subproj/WebPDFView.h:
        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView supportsTextEncoding]):
        (-[WebPDFView string]):
        (-[WebPDFView attributedString]):
        (-[WebPDFView selectedString]):
        (-[WebPDFView selectedAttributedString]):
        (-[WebPDFView selectAll]):
        (-[WebPDFView deselectAll]):

2005-07-15  John Sullivan  <sullivan@apple.com>

        Reviewed by Kevin Decker.
        
        - fixed <rdar://problem/4181884> Searching for text that overlaps selection works 
        differently in PDFView than in HTMLView

        * WebView.subproj/WebPDFView.m:
        (PDFSelectionsAreEqual):
        new function, stand-in for nonexistent -[PDFSelection isEqual:] since calling isEqual:
        on two identical PDFSelections returns NO
        (-[WebPDFView searchFor:direction:caseSensitive:wrap:]):
        Make search algorithm match that in WebCore: initially search inside selection, then check for the case
        where the found text exactly matches the previous selection, and search from past the selection if so.
        The implementation is slightly more complicated than it should be due to PDFKit API limitations (about
        which I added FIXMEs and filed bugs)

2005-07-15  John Sullivan  <sullivan@apple.com>

        Reviewed by Maciej Stachowiak.
        
        - fixed these bugs:
        <rdar://problem/4181875> Searching for text that overlaps selection works differently in WebTextView than in HTMLView
        <rdar://problem/3393678> Find not finding text in plain (non-HTML) if all text is selected

        * Misc.subproj/WebSearchableTextView.m:
        (-[NSString findString:selectedRange:options:wrap:]):
        Make search algorithm match that in WebCore: initially search inside selection, then check for the case
        where the found text exactly matches the previous selection, and search from past the selection if so.

2005-07-14  John Sullivan  <sullivan@apple.com>

        Reviewed by Dave Hyatt.

        - WebKit part of fix for: 
        <rdar://problem/4181227> webpages incorrectly use standard instead of secondary highlighting in certain cases

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge formControlIsResigningFirstResponder:]):
        Implementation of new method defined in WebCore, passes call along to WebHTMLView
        
        * WebView.subproj/WebHTMLViewInternal.h:
        declare _formControlIsResigningFirstResponder: so bridge can call it

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView updateFocusState]):
        just moved in file so it could be called from a different category
        (-[WebHTMLView _formControlIsResigningFirstResponder:]):
        new method, updates focus state

2005-07-14  John Sullivan  <sullivan@apple.com>

	added missing #import to fix build
	* WebView.subproj/WebPDFView.m

2005-07-14  Kevin Decker  <kdecker@apple.com>

        Reviewed by cblu

	Fixed: <rdar://problem/4122282> clicking a link in an PDF file opens the link with NSWorkspace without the usual security checks or WebView delegate control

        * WebView.subproj/WebFrame.m:
        (-[WebFrame _safeLoadURL:]): added
        * WebView.subproj/WebFrameInternal.h:
        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView initWithFrame:]):
        (-[WebPDFView PDFViewWillClickOnLink:withURL:]): prevents evilness with a call to _safeLoadURL
        * WebView.subproj/WebTextView.m:
        (-[WebTextView clickedOnLink:atIndex:]): factored calling out to the bridge, and instead call _safeLoadURL

2005-07-14  Vicki Murley  <vicki@apple.com>

        Reviewed by Kocienda.

	- WebKit part of fix for  <rdar://problem/4172380> [GENENTECH] window.opener 
	not available when child opened via target="_new"

	Add a setOpener function to the WebCore bridge, and call this function when opening
	new windows through Web Kit.

        * WebView.subproj/WebFrame.m:
        (-[WebFrame _continueLoadRequestAfterNewWindowPolicy:frameName:formState:]):

2005-07-13  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by John
        
        Rolling in changes necessary to build with newer versions of gcc 4.0

        * History.subproj/WebHistoryItem.m:
        (-[WebHistoryItem copyWithZone:]):
        * Misc.subproj/WebNSPasteboardExtras.m:
        (-[NSPasteboard _web_writeImage:URL:title:archive:types:]):
        * Misc.subproj/WebNSURLExtras.m:
        (-[NSURL _web_URLWithLowercasedScheme]):
        (-[NSString _web_mapHostNameWithRange:encode:makeString:]):
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge MIMETypeForPath:]):
        * WebCoreSupport.subproj/WebImageRendererFactory.m:
        (-[WebImageRendererFactory imageRendererWithBytes:length:MIMEType:]):
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer initWithFont:usingPrinterFont:]):
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _webDataRequestForData:MIMEType:textEncodingName:baseURL:unreachableURL:]):
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _styleFromFontAttributes:]):
        * WebView.subproj/WebView.m:
        (-[WebView _writeImageElement:withPasteboardTypes:toPasteboard:]):
        (-[WebView mainFrameTitle]):

2005-07-13  John Sullivan  <sullivan@apple.com>

        Reviewed by Maciej Stachowiak.

        - cleaned up Find-related experimental code that I checked in a while back

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView searchFor:direction:caseSensitive:wrap:]):
        remove variant of this method that had findInSelection flag; this method is now
        the same as it was on Tiger.
        
        * WebView.subproj/WebView.m:
        (-[WebView searchFor:direction:caseSensitive:wrap:]):
        ditto

2005-07-12  Geoffrey Garen  <ggaren@apple.com>

        -rolled in patch by opendarwin.org@mitzpettel.com 
        for http://bugs.webkit.org/show_bug.cgi?id=3435
        Parentheses are backwards in Hebrew text (no bidi mirroring?)
        
        Reviewed by mjs.

        Layout test added to WebCore.

        * WebCoreSupport.subproj/WebTextRenderer.h:
        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer _initializeATSUStyle]):
        (applyMirroringToRun):
        (-[WebTextRenderer _ATSU_drawHighlightForRun:style:geometry:]):
        (-[WebTextRenderer _ATSU_drawRun:style:geometry:]):
        (-[WebTextRenderer _ATSU_pointToOffset:style:position:reversed:includePartialGlyphs:]):

2005-07-12  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Chris Blumenberg

        * WebCoreSupport.subproj/WebBridge.m: Removed some glue that allowed one
        of two unicode (TEC or ICU ) to be chosen at runtime. I just added this
        dual support yesterday, and while Maciej and I agreed that it was good
        to land in the tree in case we run into problems in the near future, we
        also agreed that cutting over to using ICU full time right now is
        probably the best way to find bugs.

2005-07-11  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Richard

        * WebCoreSupport.subproj/WebBridge.m:
        (+[WebBridge setTextConversionMethod:]): New method to support switching text conversion method.
        (+[WebBridge textConversionMethod]): Returns current text conversion method.

2005-07-11  Kevin Decker  <kdecker@apple.com>

        Reviewed by cblu and mjs.

	Fixed: <rdar://problem/4099552> REGRESSION: Safari 1.3 Netscape API NPN_PostURL[Notify] no longer allows manual headers
	
	Most plugins (flash) send 2 CRFL's between the header and body of their POST requests, while the adboe plugin sends two LF's. This caused us to send custom headers as part of the actual POST data itself, and correspondently, would skew Content-Length.

        * Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[NSData _web_locationAfterFirstBlankLine]): Look for two LF's as well

2005-07-09  Maciej Stachowiak  <mjs@apple.com>

        - back out my revent page cache changes, turns out they cause a
	major performance regression on PLT

        * WebView.subproj/WebFrame.m:
        (-[WebFrame _purgePageCache]):

2005-07-09  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by hyatt.

	Replace int with unsigned, to avoid going into a huge loop when
	back list count is 0.

        * WebView.subproj/WebFrame.m:
        (-[WebFrame _purgePageCache]):

2005-07-09  Maciej Stachowiak  <mjs@apple.com>

        - fixed broken Development build

        * WebView.subproj/WebFrame.m:
        (-[WebFrame _purgePageCache]):

2005-07-09  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by hyatt.

	- fix page cache purging logic; this gets rid of a bug where the
	page cache would grow without bound if the oldest page cache item
	was the snapback item, and changed the rule a bit so page cache
	items farther back than the max size get purged, even if fewer
	than the max size are in current use.

        * WebView.subproj/WebFrame.m:
        (-[WebFrame _purgePageCache]):

2005-07-08  Geoffrey Garen  <ggaren@apple.com>

        Rolled in patch by opendarwin.org@mitzpettel.com

        -fixes http://bugs.webkit.org/show_bug.cgi?id=3818
        Fallback font doesn't have requested weight in ATSUI-rendered text

        (See WebCore Changelog for layout test)

        Reviewed by mjs.

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer _createATSUTextLayoutForRun:style:]):

2005-07-05  Adele Peterson  <adele@apple.com>

       Rolling out changes for <rdar://problem/3792529> REGRESSION (Mail): Tabs do not work the way they did in Panther (especially useful in plain text mail)
       since it caused a 2% performance regression.

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (isSpace):
        (-[WebTextRenderer _CG_drawHighlightForRun:style:geometry:]):
        (-[WebTextRenderer _CG_floatWidthForRun:style:widths:fonts:glyphs:startPosition:numGlyphs:]):
        (-[WebTextRenderer _extendCharacterToGlyphMapToInclude:]):
        (-[WebTextRenderer _CG_pointToOffset:style:position:reversed:includePartialGlyphs:]):
        (initializeCharacterWidthIterator):
        (widthForNextCharacter):

2005-07-05  John Sullivan  <sullivan@apple.com>

        Reviewed by Chris Blumenberg.
        
        - fixed <rdar://problem/4158230> Zoom In/Zoom Out in PDF context menu don't update window's notion of text size

        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView _menuItemsFromPDFKitForEvent:]):
        Redirect Actual Size, Zoom In, and Zoom Out context menu items so that they behave exactly like Make Text Standard Size,
        Make Text Larger, and Make Text Smaller.

2005-07-01  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin Adler.
        
        - fixed http://bugs.webkit.org/show_bug.cgi?id=3711: Displayed PDF have limited options in contextual menu
        
        This was a problem with using Tiger's version of Safari with tip of tree WebKit.

        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView _anyPDFTagsFoundInMenu:]):
        new method, returns YES if the menu contains any items with any of the new PDF-related tags.
        (-[WebPDFView menuForEvent:]):
        If the executable was linked on Tiger or older (but it will never be older, since this code is
        new to Tiger), force all of the PDF-related items into the menu if none of them were there 
        after processing by the delegate.

2005-06-30  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan.

        - fixed <http://bugs.webkit.org/show_bug.cgi?id=3774>
          do renaming so that loaders are called "loader", not "client" or "delegate"

        * Misc.subproj/WebIconLoader.h:
        * Plugins.subproj/WebNetscapePluginStream.h:
        * Plugins.subproj/WebNetscapePluginStream.m:
        (-[WebNetscapePluginStream initWithRequest:pluginPointer:notifyData:sendNotification:]):
        (-[WebNetscapePluginStream start]):
        (-[WebNetscapePlugInStreamLoader didFinishLoading]):
        (-[WebNetscapePlugInStreamLoader didFailWithError:]):
        (-[WebNetscapePlugInStreamLoader cancelWithError:]):
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge startLoadingResource:withURL:customHeaders:]):
        (-[WebBridge startLoadingResource:withURL:customHeaders:postData:]):
        (-[WebBridge canRunModalNow]):
        * WebCoreSupport.subproj/WebSubresourceClient.h: Removed.
        * WebCoreSupport.subproj/WebSubresourceClient.m: Removed.
        * WebCoreSupport.subproj/WebSubresourceLoader.h:
        * WebCoreSupport.subproj/WebSubresourceLoader.m:
        (-[WebSubresourceLoader initWithLoader:dataSource:]):
        (-[WebSubresourceLoader dealloc]):
        (+[WebSubresourceLoader startLoadingResource:withRequest:customHeaders:referrer:forDataSource:]):
        (+[WebSubresourceLoader startLoadingResource:withURL:customHeaders:referrer:forDataSource:]):
        (+[WebSubresourceLoader startLoadingResource:withURL:customHeaders:postData:referrer:forDataSource:]):
        (-[WebSubresourceLoader didReceiveResponse:]):
        (-[WebSubresourceLoader didReceiveData:lengthReceived:]):
        (-[WebSubresourceLoader didFinishLoading]):
        (-[WebSubresourceLoader didFailWithError:]):
        (-[WebSubresourceLoader cancel]):
        * WebKit.pbproj/project.pbxproj:
        * WebView.subproj/WebBaseResourceHandleDelegate.h: Removed.
        * WebView.subproj/WebBaseResourceHandleDelegate.m: Removed.
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSourcePrivate dealloc]):
        (-[WebDataSource _setLoading:]):
        (-[WebDataSource _updateLoading]):
        (-[WebDataSource _setPrimaryLoadComplete:]):
        (-[WebDataSource _startLoading:]):
        (-[WebDataSource _addSubresourceLoader:]):
        (-[WebDataSource _removeSubresourceLoader:]):
        (-[WebDataSource _addPlugInStreamLoader:]):
        (-[WebDataSource _removePlugInStreamLoader:]):
        (-[WebDataSource _stopLoadingInternal]):
        (-[WebDataSource _defersCallbacksChanged]):
        (-[WebDataSource _stopLoadingWithError:]):
        (-[WebDataSource data]):
        (-[WebDataSource isLoading]):
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebLoader.h:
        * WebView.subproj/WebLoader.m:
        * WebView.subproj/WebMainResourceClient.h: Removed.
        * WebView.subproj/WebMainResourceClient.m: Removed.
        * WebView.subproj/WebMainResourceLoader.h:
        * WebView.subproj/WebMainResourceLoader.m:
        (-[WebMainResourceLoader didReceiveResponse:]):

2005-06-29  David Harrison  <harrison@apple.com>

        Reviewed by Dave Hyatt (rendering) and Maciej (editing).

        Test cases added:  Coming soon.  Will include with next round of changes for this bug.

        This is the first checkin for...
        
        <rdar://problem/3792529> REGRESSION (Mail): Tabs do not work the way they did in Panther (especially useful in plain text mail)
        
        Basic strategy is to put tabs into spans with white-space:pre style, and
        render them with tabs stops every 8th space, where the space width and
        the left margin are those of the enclosing block.
        
        What's left is to switch to implement white-space:pre-wrap so
        that we can coalesce consecutive tabs while maintaining proper
        line breaking.  That will keep the markup smaller.

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (isSpace):
        (-[WebTextRenderer _CG_drawHighlightForRun:style:geometry:]):
        (-[WebTextRenderer _CG_floatWidthForRun:style:widths:fonts:glyphs:startPosition:numGlyphs:]):
        (-[WebTextRenderer _extendCharacterToGlyphMapToInclude:]):
        (-[WebTextRenderer _CG_pointToOffset:style:position:reversed:includePartialGlyphs:]):
        (initializeCharacterWidthIterator):
        (widthForNextCharacter):

2005-06-29  John Sullivan  <sullivan@apple.com>

        Reviewed by Kevin.
        
        - deleted some never-used stub code

        * WebView.subproj/WebView.m:
        * WebView.subproj/WebViewInternal.h:
        * WebView.subproj/WebViewPrivate.h:

2005-06-27  Justin Garcia  <justin.garcia@apple.com>

        Patch by Anders Carlsson <andersca@mac.com>

        Reviewed by Darin.

        - Fixes <http://bugs.webkit.org/show_bug.cgi?id=3489>
        WebView's setSelectedDOMRange doesn't not implement clearing the selection as described in the WebView documentation:
        <http://developer.apple.com/documentation/Cocoa/Reference/WebKit/ObjC_classic/Classes/WebView.html>
	
        * WebView.subproj/WebView.m:
        (-[WebView setSelectedDOMRange:affinity:]):
        If range is nil, call deselectText.

2005-06-24  Justin Garcia  <justin.garcia@apple.com>

        Patch contributed by Duncan Wilcox <duncan@mclink.it>

        Reviewed by Darin

        - Fixed <http://bugs.webkit.org/show_bug.cgi?id=3535>
            Spelling suggestions in the context menu don't call the should* delegate methods

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _changeSpellingFromMenu:]):
        give delegate's webView:shouldInsertText:replacingDOMRange:givenAction: a chance
        to prevent replacing of selected text

2005-06-22  John Sullivan  <sullivan@apple.com>

        Reviewed by Chris Blumenberg.
        
        - fixed <rdar://problem/3764645> please add a way to allow WebKit clients to override the WebPDFView context menu

        * PublicHeaderChangesFromTiger.txt: Added.
        New file to keep track of changes made to public headers that haven't been through API review yet.
        Initially lists the WebMenuItem enum tags added to WebUIDelegate.h as part of this change.
        
        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        (-[WebDefaultUIDelegate appendDefaultItems:toArray:]):
        new method, handles initial separator
        (-[WebDefaultUIDelegate contextMenuItemsForElement:defaultMenuItems:]):
        now has defaultMenuItems: parameter. Any menu items in this array are appended at the end of
        the standard set.
        (-[WebDefaultUIDelegate editingContextMenuItemsForElement:defaultMenuItems:]):
        ditto
        (-[WebDefaultUIDelegate webView:contextMenuItemsForElement:defaultMenuItems:]):
        This had a defaultMenuItems parameter before but it was always nil. Now it passes the defaultMenuItems
        parameter on to the two methods that construct lists (one for editing, the other for viewing). Also
        tweaked variable name and type for clarity.
        
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView menuForEvent:]):
        passes nil for new defaultItems parameter of _menuForElement:
        
        * WebView.subproj/WebImageView.m:
        (-[WebImageView menuForEvent:]):
        ditto
        
        * WebView.subproj/WebTextView.m:
        (-[WebTextView menuForEvent:]):
        ditto

        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView elementAtPoint:]):
        new method to create the element dictionary needed for _menuForElement:defaultItems:. Only supplies the
        webFrame at this point.
        (-[WebPDFView _menuItemsFromPDFKitForEvent:]):
        new method to return copies of the menu items that PDFKit would include in the context menu, with
        WebKit tags applied
        (-[WebPDFView menuForEvent:]):
        now calls standard WebKit context menu mechanism, so clients' delegates can modify the context menu as
        desired. The initial set of items are the ones WebKit was already displaying for PDF context menus.
        
        * WebView.subproj/WebUIDelegate.h:
        added enum values for the menu items in the PDF context menu
        
        * WebView.subproj/WebViewPrivate.h:
        * WebView.subproj/WebView.m:
        (-[WebView _menuForElement:defaultItems:]):
        Added the defaultItems: parameter to this method, which is then passed along to WebDefaultUIDelegate.
        All callers pass nil except for WebPDFView, at least for now.

2005-06-22  Darin Adler  <darin@apple.com>

        Change by Mitz Pettel.
        Reviewed by me.

        - fixed <http://bugs.webkit.org/show_bug.cgi?id=3618>
          RTL runs drawn by CG not reversed properly

        * WebCoreSupport.subproj/WebTextRenderer.m: (-[WebTextRenderer _CG_drawRun:style:geometry:]):
        Fix off-by-one mistake in order-swapping loops.

2005-06-22  Darin Adler  <darin@apple.com>

        Change by Michael Gaiman.
        Reviewed by me.

        - fixed <http://bugs.webkit.org/show_bug.cgi?id=3436>
          Missing implementation of -[NSData(WebNSDateExtras) _webkit_parseRFC822HeaderFields]

        * Misc.subproj/WebNSDataExtras.h: Fixed name of category say NSData, not NSDate.
        * Misc.subproj/WebNSDataExtras.m: (-[NSData _webkit_parseRFC822HeaderFields]): Fixed method name.

2005-06-21  John Sullivan  <sullivan@apple.com>

        Reviewed by Vicki Murley
        
        - fixed assertion failure Vicki ran into

        * Misc.subproj/WebIconDatabase.m:
        (-[WebIconDatabase _forgetIconForIconURLString:]):
        Handle the case where there are no associated page URLs for the icon URL

2005-06-20  John Sullivan  <sullivan@apple.com>

        Reviewed by Chris Blumenberg.
        
        - fixed <rdar://problem/4155182> icon database retain counts can be incorrect after removing all icons
        
        Replaced the concept of "future retain count per page URL" with a simpler concept of "retain count per
        page URL", which is maintained even after the icon is actually loaded (unlike the future retain count).
        The total retain count for an icon is now the sum of the retain counts per page URL along with any retain
        count not associated with a page URL -- this is still needed for some internal housekeeping purposes.

        * Misc.subproj/WebIconDatabasePrivate.h:
        renamed iconURLToURLs -> iconURLToPageURLs for clarity
        renamed URLToIconURL -> pageURLToIconURL for clarity
        renamed futureURLToRetainCount -> pageURLToRetainCount (there's no more "future" aspect)
        renamed iconURLToRetainCount -> iconURLToExtraRetainCount (it now maintains only some of the retain count)
        
        * Misc.subproj/WebIconDatabase.m:
        (+[WebIconDatabase sharedIconDatabase]):
        updated for name changes only
        (-[WebIconDatabase init]):
        ditto
        (-[WebIconDatabase iconForURL:withSize:cache:]):
        ditto
        (-[WebIconDatabase iconURLForURL:]):
        ditto
        (-[WebIconDatabase retainIconForURL:]):
        just bump the retain count in pageURLToRetainCount, instead of behaving differently based on whether 
        an icon had been loaded for this URL; this let me delete the internal method _retainFutureIconForURL:
        (-[WebIconDatabase releaseIconForURL:]):
        decrement the retain count in pageURLToRetainCount, then handle the case where the retain count for 
        this page has gone to zero. I deleted the internal method _releaseFutureIconForURL: formerly called here.
        (-[WebIconDatabase removeAllIcons]):
        remove all the code that dealt with retain counts; this operation no longer affects retain counts
        (-[WebIconDatabase _setIconURL:forURL:]):
        remove the code that consolidated multiple retain counts for different page URLs into a single retain 
        count; the multiple retain counts are now maintained even after the icon is loaded
        (-[WebIconDatabase _clearDictionaries]):
        updated for name changes only
        (-[WebIconDatabase _loadIconDictionaries]):
        ditto
        (-[WebIconDatabase _updateFileDatabase]):
        ditto
        (-[WebIconDatabase _totalRetainCountForIconURLString:]):
        new method, sums the retain counts associated with specific page URLs and the extra retain count
        not associated with specific page URLs
        (-[WebIconDatabase _retainIconForIconURLString:]):
        updated for name changes
        (-[WebIconDatabase _forgetIconForIconURLString:]):
        no longer affects retain counts at all; this is up to callers
        (-[WebIconDatabase _releaseIconForIconURLString:]):
        this now distinguishes the case where the retain count not associated with any page URLs hits 
        zero from the case where the total retain count hits zero, and handles both

2005-06-20  John Sullivan  <sullivan@apple.com>

        Reviewed by Chris Blumenberg.
        
        - added support for emptying the icon database

        * Misc.subproj/WebIconDatabase.h: just fixed a typo
        * Misc.subproj/WebIconDatabasePrivate.h:
        added WebPendingPublic category with method removeAllIcons, and
        declared WebIconDatabaseDidRemoveAllIconsNotification string.
        
        * Misc.subproj/WebIconDatabase.m:
        (-[WebIconDatabase removeAllIcons]):
        new method, removes all known icons from memory and disk. There's one loose end,
        covered by radar bug 4155182, where it's possible for the icon database's retain
        counts to get off after this operation. I plan to fix this next.
        (-[WebIconDatabase _setIconURL:forURL:]):
        just fixed some extra whitespace
        (-[WebIconDatabase _forgetIconForIconURLString:]):
        new method, extracted from _releaseIconForIconURLString
        (-[WebIconDatabase _releaseIconForIconURLString:]):
        now calls extracted method

        * WebKit.exp:
        added _WebIconDatabaseDidRemoveAllIconsNotification

2005-06-19  Darin Adler  <darin@apple.com>

	Changes by Mitz Pettel
        Reviewed by me.
        
        - fixed <http://bugs.webkit.org/show_bug.cgi?id=3466>
          ATSUI text doesn't render at coordinates greater than 32K

        * WebCoreSupport.subproj/WebTextRenderer.m: (-[WebTextRenderer _ATSU_drawRun:style:geometry:]):
        Translate the matrix of the CGContext instead of passing the appropriate coordinates to ATSU.

2005-06-17  Richard Williamson   <rjw@apple.com>

	Changes by Mitz Pettel
        Reviewed by Richard Williamson.

	Fixed http://bugs.webkit.org/show_bug.cgi?id=3545

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (reverseCharactersInRun):
        (-[WebTextRenderer _ATSU_pointToOffset:style:position:reversed:includePartialGlyphs:]):

2005-06-17  John Sullivan  <sullivan@apple.com>

        Reviewed by Chris.

        - fixed <rdar://problem/4151001> Reloading javascript-spawned window with no URL erases its contents

        * WebView.subproj/WebFrame.m:
        (-[WebFrame reload]):
        do nothing if URL is zero-length

2005-06-14  John Sullivan  <sullivan@apple.com>

        Changes by Devin Lane.
        Reviewed by me.

        - fixed <rdar://problem/3766909> PDF viewing could use a zoom control other than the one in the context menu

        * WebView.subproj/WebPDFView.h:
        now implements protocol _web_WebDocumentTextSizing
        * WebView.subproj/WebPDFView.m:
        (-[WebPDFView _updateScalingToReflectTextSize]):
        new method, sets the PDF scaling from the text size multiplier
        (-[WebPDFView setDataSource:]):
        call _updateScalingToReflectTextSize
        (-[WebPDFView _web_textSizeMultiplierChanged]):
        implementation of protocol _web_WebDocumentTextSizing, calls _updateScalingToReflectTextSize

2005-06-14  John Sullivan  <sullivan@apple.com>

        Reviewed by Dave Harrison.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _delayedEndPrintMode:]):
        After discussing this with Dave, I made this method both more debugger-friendly with asserts for
        the cases we don't think could ever happen, and more paranoid by handling these cases in deployment
        builds.

2005-06-14  Darin Adler  <darin@apple.com>

        - fixed build for Xcode 2.1

        * WebKit.pbproj/project.pbxproj: Use BUILT_PRODUCTS_DIR instead of SYMROOT to search for the
        WebKitSystemInterface.h file. We could re-jigger this again later, but for now this is consistent
        with both the .a file's location and where build-webkit puts the file.

2005-06-13  John Sullivan  <sullivan@apple.com>

        Reviewed by Dave Harrison and Maciej.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _endPrintMode]):
        new method, extracted from identical code in beginDocument and endDocument. This method must be called
        once to counterbalance the code called from knowsPageRange that turns on "printing mode".
        (-[WebHTMLView _delayedEndPrintMode:]):
        new method, called from "perform after delay". Checks whether the same print operation is still underway
        and, if so, delays further. Otherwise calls _endPrintMode directly.
        (-[WebHTMLView knowsPageRange:]):
        after turning on "printing mode", queue up a delayed call to _delayedEndPrintMode:. If there's an early
        error in the print mechanism such that beginDocument is never called, this will cleanly end "printing
        mode" and make the webview usable again.
        (-[WebHTMLView beginDocument]):
        cancel any delayed call to _delayedEndPrintMode:. If we get this far along in printing, then we don't need
        the failsafe call to _delayedEndPrintMode: that was set up in knowsPageRange:. Also, call extracted method.
        (-[WebHTMLView endDocument]):
        call extracted method

2005-06-13  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Chris Blumenberg and Adele.

	- better fix for <rdar://problem/4142247> REGRESSION: List to browse widgets at Apple website failed. Closing tab afterwards caused Safari crash
	http://bugs.webkit.org/show_bug.cgi?id=3445

	With this change and the matching WebKit change we'll still stop loading the moment you click
	a download link, but the unload event and detaching of event handlers will not happen early any more.
	
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource _stopLoadingInternal]): call stopLoading on bridge instead of closeURL.
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _transitionToCommitted:]): Revert previous attempt at fix.
        (-[WebFrame _continueLoadRequestAfterNavigationPolicy:formState:]): ditto
        (-[WebFrame stopLoading]): ditto

2005-06-13  Chris Petersen  <cpetersen@apple.com>

        Changes by Darin.
        Reviewed by me.

        - fixed problems building deployment due to recent init change

        * WebView.subproj/WebArchive.m: (-[WebArchive initWithCoder:]):
        Put the [super init] call and check for nil outside the exception handler.
        * WebView.subproj/WebResource.m: (-[WebResource initWithCoder:]): Ditto.

2005-06-12  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fixed <rdar://problem/4141569> REGRESSION (412+): printing fails on any page with images, and for standalone images
          also <http://bugs.webkit.org/show_bug.cgi?id=3318>

        * WebCoreSupport.subproj/WebImageData.m: Got rid of use of tabs instead of spaces throughout the file.
        (-[WebImageData _checkSolidColor:]): Wrap use of NSGraphicsContext with an autorelease pool.
        (-[WebImageData _fillSolidColorInRect:compositeOperation:context:]): Ditto.
        (-[WebImageData tileInRect:fromPoint:context:]): Ditto.
        (-[WebImageData _PDFDrawFromRect:toRect:operation:alpha:flipped:context:]): Ditto.

2005-06-12  Darin Adler  <darin@apple.com>

        Changes by Nick Zitzmann.
        Reviewed by me.

        - fixed init methods that don't handle return values from the init methods they call

        * WebView.subproj/WebArchive.m:
        (-[WebArchive init]): Use value returned by init, check it for nil too.
        (-[WebArchive initWithMainResource:subresources:subframeArchives:]): Ditto.
        (-[WebArchive _initWithPropertyList:]): Ditto.
        (-[WebArchive initWithCoder:]): Ditto.
        * WebView.subproj/WebClipView.m:
        (-[WebClipView initWithFrame:]): Ditto.
        * WebView.subproj/WebDebugDOMNode.m:
        (-[WebDebugDOMNode initWithName:value:source:children:]): Ditto.
        * WebView.subproj/WebFrame.m:
        (-[WebFormState initWithForm:values:sourceFrame:]): Ditto.
        (-[WebFrame initWithName:webFrameView:webView:]): Ditto.
        * WebView.subproj/WebFrameView.m:
        (-[WebFrameView initWithFrame:]): Ditto.
        * WebView.subproj/WebHTMLRepresentation.m:
        (-[WebHTMLRepresentation init]): Ditto.
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView initWithFrame:]): Ditto.
        (-[WebTextCompleteController initWithHTMLView:]): Ditto.
        * WebView.subproj/WebImageView.m:
        (-[WebImageView initWithFrame:]): Ditto.
        * WebView.subproj/WebPreferences.m:
        (-[WebPreferences initWithIdentifier:]): Ditto.
        * WebView.subproj/WebRenderNode.m:
        (-[WebRenderNode initWithName:position:rect:view:children:]): Ditto.
        * WebView.subproj/WebResource.m:
        (-[WebResource init]): Ditto.
        (-[WebResource initWithCoder:]): Ditto.
        * WebView.subproj/WebView.m:
        (-[WebViewPrivate init]): Call super init.
        (-[_WebSafeForwarder initWithTarget:defaultTarget:templateClass:]): Use value returned by init, check it for nil too.
        (-[WebView initWithFrame:]): Ditto.

2005-06-12  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Chris Blumenberg.

	- fixed <rdar://problem/4142247> REGRESSION: List to browse widgets at Apple website failed. Closing tab afterwards caused Safari crash
	http://bugs.webkit.org/show_bug.cgi?id=3445
	
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _transitionToCommitted:]): Stop loading the non-provisional data
	source before swapping in the provisional.
        (-[WebFrame _continueLoadRequestAfterNavigationPolicy:formState:]): Stop only
	the provisional load here, we would not want to stop loading if this navigation
	later turns into a download or is cancelled before being committed.
        (-[WebFrame stopLoading]): Factored a bit.
        (-[WebFrame _cancelProvisionalLoad]): New method to stop only provisional load,
	and cancel any pending policy deicions.
        (-[WebFrame _stopNonProvisionalLoadOnly]): New mthod that stops only the main
	load.

2005-06-10  John Sullivan  <sullivan@apple.com>

        reviewed by Dave Harrison (first & second drafts) and Darin Adler (third draft)

        - WebKit part of fix for 
        <rdar://problem/4145214> REGRESSION (412+): Can't drag URLs from the location bar

        * Misc.subproj/WebNSPasteboardExtras.m:
        (+[NSPasteboard initialize]):
        Reinstate variation of old code that uses CreatePasteboardFlavorTypeName to set up our new pasteboard types.
        The newfangled way didn't work.

2005-06-07  Darin Adler  <darin@apple.com>

        Change by Mark Rowe <opendarwin.org@bdash.net.nz>.
        Reviewed by me.

        - fixed the WebKit half of build failure with spaces in the path
          http://bugs.webkit.org/show_bug.cgi?id=3291

        * WebKit.pbproj/project.pbxproj: Quote DERIVED_FILE_DIR when it is substituted
        into FRAMEWORK_SEARCH_PATHS, and SYMROOT when into HEADER_SEARCH_PATHS.

2005-06-06  Darin Adler  <darin@apple.com>

        * Info.plist: Bumped version to 412+. For some reason it was set to 312.1!

2005-06-05  Darin Adler  <darin@apple.com>

        Reviewed by Hyatt.

        - fixed build that I broke with the license change (some includes of WebException were still around)

        * WebKit.pbproj/project.pbxproj: Removed references to WebException.h/m.
        * WebView.subproj/WebDataSource.m: Removed include of WebException.h.
        * WebView.subproj/WebHTMLView.m: Ditto.
        * WebView.subproj/WebView.m: Ditto.

        - fixed build under gcc 4.0 (some code moved here from Foundation had warnings)

        * Misc.subproj/WebNSDataExtras.m:
        (-[NSString _web_capitalizeRFC822HeaderFieldName]): Use char instead of UInt8.
        (-[NSData _webkit_guessedMIMEType]):  Use char instead of UInt8, and take out now-
        unneeded type casts.

2005-06-05  Darin Adler  <darin@apple.com>

        - added appropriate license headers to most files and updated copyright to reflect publication dates

        * LICENSE: Added.
        * <lots of files>: Added license header.

        * WebKit.pbproj/project.pbxproj: Removed references to NP_objc.h.

        * API-Issues.rtf: Removed.
        * Misc.subproj/WebException.h: Removed.
        * Misc.subproj/WebException.m: Removed.
        * Plugins.subproj/NP_objc.h: Removed.

2005-06-01  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan.

        - WebKit part of fix for <rdar://problem/3166090> add IE JavaScript extension window.showModalDialog

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge createModalDialogWithURL:]): Added. Calls the UI delegate, falling back to the generic
        "create WebView" method.
        (-[WebBridge canRunModal]): Added. Checks the UI delegate to see if it implements runModal.
        (-[WebBridge canRunModalNow]): Added. Checks the "inConnectionCallback" field so we can prevent
        deadlock since we can't do any I/O while inside a connection callback until this aspect of NSURLConnection
        is changed.
        (-[WebBridge runModal]): Added. Sets "defersCallbacks" on all other web views in the group, then
        calls runModal on the UI delegate.

        * WebView.subproj/WebBaseResourceHandleDelegate.h: Added inConnectionCallback class method.
        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate connection:willSendRequest:redirectResponse:]): Bump count and then
        decrement count so we can tell if we are in a callback.
        (-[WebBaseResourceHandleDelegate connection:didReceiveAuthenticationChallenge:]): Ditto.
        (-[WebBaseResourceHandleDelegate connection:didCancelAuthenticationChallenge:]): Ditto.
        (-[WebBaseResourceHandleDelegate connection:didReceiveResponse:]): Ditto.
        (-[WebBaseResourceHandleDelegate connection:didReceiveData:lengthReceived:]): Ditto.
        (-[WebBaseResourceHandleDelegate connection:willStopBufferingData:]): Ditto.
        (-[WebBaseResourceHandleDelegate connectionDidFinishLoading:]): Ditto.
        (-[WebBaseResourceHandleDelegate connection:didFailWithError:]): Ditto.
        (-[WebBaseResourceHandleDelegate connection:willCacheResponse:]): Ditto.
        (+[WebBaseResourceHandleDelegate inConnectionCallback]): Added. Return YES if count is not 0.

        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient receivedError:]): Changed to use the method without the connection: parameter
        in the base class, since we no longer are overriding the connection: version.
        (-[WebMainResourceClient willSendRequest:redirectResponse:]): Change to override the version without
        the connection prefix/parameter; now only the base class overrides the actual connection delegate methods.
        (-[WebMainResourceClient continueAfterContentPolicy:response:]): Ditto.
        (-[WebMainResourceClient didReceiveResponse:]): Ditto.
        (-[WebMainResourceClient didReceiveData:lengthReceived:]): Ditto.
        (-[WebMainResourceClient didFinishLoading]): Ditto.
        (-[WebMainResourceClient didFailWithError:]): Ditto.
        (-[WebMainResourceClient loadWithRequestNow:]): Call the method without the connection parameter.

        * WebView.subproj/WebUIDelegatePrivate.h: Added new SPI here that WebBrowser implements.

2005-05-26  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - fix build failure from when I removed WebCoreUnicode

        * WebCoreSupport.subproj/WebTextRenderer.m: Removed import of WebUnicode.h that I missed.
        (-[WebTextRenderer _convertUnicodeCharacters:length:toGlyphs:]): Switch from our own macros
        to the ICU macros for surrogate pairs.
        (widthForNextCharacter): Ditto.

2005-05-26  David Harrison  <harrison@apple.com>

        <rdar://problem/4120518> Mail: control-T in an empty message crashes mail

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge issueTransposeCommand]):
        New, to support transpose in JS.

2005-05-26  Darin Adler  <darin@apple.com>

        Reviewed by Richard and Dave Harrison.

        - eliminate WebCoreUnicode and use ICU directly instead

        * Misc.subproj/WebKitNSStringExtras.m: (canUseFastRenderer): Use u_charDirection directly.
        * WebCoreSupport.subproj/WebTextRenderer.m: Removed import of <WebCore/WebCoreUnicode.h>.
        * WebView.subproj/WebHTMLView.m: (+[WebHTMLView initialize]): Removed call to WebKitInitializeUnicode.

        * Misc.subproj/WebUnicode.h: Removed.
        * Misc.subproj/WebUnicode.m: Removed.
        * Misc.subproj/WebUnicodeTables.m: Removed.

        * WebKit.pbproj/project.pbxproj: Removed files.

2005-05-24  Richard Williamson   <rjw@apple.com>

	Fixed <rdar://problem/4097289> -[WebView elementAtPoint:] failing when WebView is nested and offset

	Code to determine the correct frame under the window point was
	converting the point incorrectly.

        Reviewed by Chris.

        * WebView.subproj/WebView.m:
        (-[WebView _frameViewAtWindowPoint:]):

2005-05-23  John Sullivan  <sullivan@apple.com>

        Reviewed by Kevin.
        
        - WebKit part of <rdar://problem/4125783> WebKit needs a way to control whether textareas are resizable

        * WebView.subproj/WebPreferencesPrivate.h:
        added private-for-now getter and setter for new preference
        * WebView.subproj/WebPreferenceKeysPrivate.h:
        added private preference key controlling whether textareas are resizable
        * WebView.subproj/WebPreferences.m:
        (+[WebPreferences initialize]):
        initial value of new preference is NO, so other clients' behavior doesn't change
        (-[WebPreferences textAreasAreResizable]):
        new getter
        (-[WebPreferences setTextAreasAreResizable:]):
        new setter
        
        * WebView.subproj/WebView.m:
        (-[WebView _updateWebCoreSettingsFromPreferences:]):
        update this new setting in WebCore

        * English.lproj/StringsNotToBeLocalized.txt:
        updated for these changes

2005-05-23  Chris Blumenberg  <cblu@apple.com>

	Changed type for identifier parameter in WebResourceLoadDelegate-related calls to id from NSString.

        Reviewed by kevin.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge objectLoadedFromCacheWithURL:response:data:]):
        (-[WebBridge syncLoadResourceWithURL:customHeaders:postData:finalURL:responseHeaders:statusCode:]):
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _opened]):
        (-[WebFrame _requestFromDelegateForRequest:identifier:error:]):
        (-[WebFrame _sendRemainingDelegateMessagesWithIdentifier:response:length:error:]):
        (-[WebFrame _saveResourceAndSendRemainingDelegateMessagesWithRequest:identifier:response:data:error:]):
        * WebView.subproj/WebFrameInternal.h:

2005-05-20  Chris Blumenberg  <cblu@apple.com>

	Fixed: <rdar://problem/4098786> sync. XMLHttpRequest works w/o AllowNetworkAccess key because load delegate is not consulted

	Synchronous loads did not cause the willSendRequest method on the resource load delegate to be called. This is the method that Dashboard uses to enforce AllowNetworkAccess and this must be called to avoid exploits.

        Reviewed by sullivan.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge objectLoadedFromCacheWithURL:response:data:]): call [WebFrame _requestFromDelegateForRequest:identifier:error:] then 
	[WebFrame _saveResourceAndSendRemainingDelegateMessagesWithRequest:identifier:response:data:error:] so synthetic resource load delegate 
	methods are called and the data is saved as a WebResource for resources in the WebCore cache.

        (-[WebBridge syncLoadResourceWithURL:customHeaders:postData:finalURL:responseHeaders:statusCode:]): call [WebFrame _requestFromDelegateForRequest:identifier:error:],
	respect its result, do the load and then call [WebFrame _saveResourceAndSendRemainingDelegateMessagesWithRequest:identifier:response:data:error:] 
	for synchronous loads

        * WebView.subproj/WebFrame.m:
        (-[WebFrame _opened]): call [WebFrame _requestFromDelegateForRequest:identifier:error:] then 
	[WebFrame _sendRemainingDelegateMessagesWithIdentifier:response:length:error:] so synthetic resource load delegate methods are called 
	for subresrources in the page cache
        
	(-[WebFrame _requestFromDelegateForRequest:identifier:error:]): new, was part of the removed _sendResourceLoadDelegateMessagesForURL:::
	This method calls identifierForInitialRequest and willSendRequest.

        (-[WebFrame _sendRemainingDelegateMessagesWithIdentifier:response:length:error:]): new, was part of the removed _sendResourceLoadDelegateMessagesForURL:::
	This method calls the remaining resource load delegate messages.

        (-[WebFrame _saveResourceAndSendRemainingDelegateMessagesWithRequest:identifier:response:data:error:]): new, saves the resource and calls
	[WebFrame _sendRemainingDelegateMessagesWithIdentifier:response:length:error:]

        * WebView.subproj/WebFrameInternal.h:

2005-05-17  Chris Blumenberg  <cblu@apple.com>
	
	Fixed: <rdar://problem/4119282> clicking a link in an RTF file opens the link with NSWorkspace without the usual security checks or WebView delegate control

        Reviewed by mjs.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge loadURL:referrer:reload:userGesture:target:triggeringEvent:form:formValues:]): pass the passed referrer to canLoadURL::: not [self referrer]
        (-[WebBridge postWithURL:referrer:target:data:contentType:triggeringEvent:form:formValues:]): ditto
        * WebView.subproj/WebTextView.m:
        (-[WebTextView clickedOnLink:atIndex:]): call the loadURL bridge method so that security checks are made, command/option clicks work, policy delegate is consulted etc.

2005-05-17  Chris Blumenberg  <cblu@apple.com>

	Fixed: <rdar://problem/4120255> web archives on remote servers can be viewed directly (with major security issues); should download instead

        Reviewed by mjs.

        * WebView.subproj/WebBaseResourceHandleDelegate.h:
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient continueAfterContentPolicy:response:]): if the WebKit client has chosen to "use" a remote web archive, stop the load with an error

2005-05-16  Darin Adler  <darin@apple.com>

        - attempt to get things building under "Saffron" development tools

        * WebKit.pbproj/project.pbxproj: Use BUILT_PRODUCTS_DIR instead of SYMROOT.

2005-05-13  John Sullivan  <sullivan@apple.com>

        Reviewed by Kevin.
        
        - fixed <rdar://problem/4093306> Safari crashes if Esc key is held down during series 
        of authentication sheets

        * Panels.subproj/WebAuthenticationPanel.m:
        (-[WebAuthenticationPanel cancel:]):
        retain and autorelease self. This is a workaround for an AppKit key-handling issue, which I wrote up as:
        <rdar://problem/4118422> Key-down events can be sent to a closed window if a key is kept pressed down

2005-05-12  John Sullivan  <sullivan@apple.com>

        Reviewed by Kevin.

        - rolled in changes from experimental-ui-branch to support resizable textareas
        and find-as-you-type and confirming unsubmitted form changes. The files/functions 
        modified are listed just below. After that are the ChangeLog comments from the branch.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge textDidChange:]):
        * WebView.subproj/WebFormDelegate.h:
        * WebView.subproj/WebFormDelegate.m:
        (-[WebFormDelegate textDidChange:inFrame:]):
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView maintainsInactiveSelection]):
        (-[WebHTMLView searchFor:direction:caseSensitive:wrap:]):
        (-[WebHTMLView _searchFor:direction:caseSensitive:wrap:findInSelection:]):
        * WebView.subproj/WebView.m:
        (-[WebView _searchFor:direction:caseSensitive:wrap:findInSelection:]):
        (-[WebView searchFor:direction:caseSensitive:wrap:]):
        (-[WebView makeTextStandardSize:]):
        (-[WebView maintainsInactiveSelection]):
        * WebView.subproj/WebViewPrivate.h:
        
        2005-04-18  John Sullivan  <sullivan@apple.com>

                WebKit support for notifying a form delegate when a
                textarea's contents have changed (as opposed to a 
                textfield, which was already handled).

                Reviewed by Maciej.

                * WebView.subproj/WebFormDelegate.h:
                * WebView.subproj/WebFormDelegate.m:
                (-[WebFormDelegate textDidChange:inFrame:]):
                new form delegate method

                * WebCoreSupport.subproj/WebBridge.m:
                (-[WebBridge textDidChange:]):
                new method, calls through to form delegate
                
        2005-04-11  John Sullivan  <sullivan@apple.com>

                Fixed inability to wrap around in Find in Page 

                * WebView.subproj/WebView.m:
                (-[WebView _searchFor:direction:caseSensitive:wrap:findInSelection:]):
                changed wrapFlag from NO to YES on two lines (copy/paste error)

        2005-04-07  John Sullivan  <sullivan@apple.com>

                WebKit support for find-as-you-type. Needed an additional parameter on
                a method from WebDocumentSearching protocol. Since that's a public protocol, 
                I couldn't just add the parameter. For now I hacked it with an undeclared
                internal method that's discovered via respondsToSelector. Probably the right
                long-term approach is to deprecate the WebDocumentSearching protocol and introduce
                a replacement that has a more flexible set of parameters for possible future
                expansion.

                Reviewed by Dave Hyatt.

                * WebView.subproj/WebHTMLView.m:
                (-[WebHTMLView searchFor:direction:caseSensitive:wrap:]):
                now calls new one-more-parameter version passing NO for new parameter to match old behavior
                (-[WebHTMLView _searchFor:direction:caseSensitive:wrap:findInSelection:]):
                new method, adds findInSelection parameter and passes it through to bridge
                 
                * WebView.subproj/WebView.m:
                (-[WebView searchFor:direction:caseSensitive:wrap:]):
                now calls new one-more-parameter version passing NO for new parameter to match old behavior
                (-[WebView _searchFor:direction:caseSensitive:wrap:findInSelection:]):
                new method, adds findInSelection parameter and passes it through

        2005-04-07  John Sullivan  <sullivan@apple.com>

                WebKit support to allow clients to control whether the selection is still
                drawn when the first responder is elsewhere. Formerly this was hardwired
                to be true only when -[WebView isEditable] was true.

                Reviewed by Darin.

                * WebView.subproj/WebHTMLView.m:
                (-[WebHTMLView maintainsInactiveSelection]):
                check [WebView maintainsInactiveSelection] rather than just [WebView isEditable]
                
                * WebView.subproj/WebViewPrivate.h:
                * WebView.subproj/WebView.m:
                (-[WebView maintainsInactiveSelection]):
                new method for clients to override, returns -[self isEditable]
        

2005-05-10  John Sullivan  <sullivan@apple.com>

        Reviewed by Kevin.
        
        - WebKit support for <rdar://problem/3795701> Menu item/keyboard shortcut to 
        restore text zoom to normal

        * WebView.subproj/WebView.m:
        (-[WebView validateUserInterfaceItem:]):
        validate makeTextStandardSize by calling canMakeTextStandardSize
        (-[WebView canMakeTextStandardSize]):
        new method, returns YES unless text size multiplier is currently 1
        (-[WebView makeTextStandardSize:]):
        new method, sets text size multiplier to 1
        
        * WebView.subproj/WebViewPrivate.h:
        add makeTextStandardSize: and canMakeTextStandardSize to pending public category

2005-05-10  John Sullivan  <sullivan@apple.com>

        Reviewed by Chris.
        
        - fixed <rdar://problem/4067981> Mail places RTF flavor before RTFD flavor when dragging 
        mixed image/text content.

        * WebView.subproj/WebHTMLView.m:
        (+[WebHTMLView _selectionPasteboardTypes]):
        put RTFD type before RTF type in array of types to declare

2005-05-09  Chris Blumenberg  <cblu@apple.com>

	Turned assertion into error message to prevent crash when encountering this bug:
	<rdar://problem/4067625> connection:willCacheResponse: is called inside of [NSURLConnection initWithRequest:delegate:]
	
        * WebView.subproj/WebBaseResourceHandleDelegate.h:
        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate loadWithRequest:]): set flag to track when we're initializing the connection
        (-[WebBaseResourceHandleDelegate connection:willCacheResponse:]): log error

2005-05-09  Darin Adler  <darin@apple.com>

        * Makefile.am: Don't set up PBXIntermediatesDirectory explicitly;
        Not needed to make builds work, spews undesirable error messages too.

2005-05-06  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - make building multiple trees with make work better

        * Makefile.am: Set up Xcode build directory before invoking xcodebuild.

2005-05-04  Darin Adler  <darin@apple.com>

        Reviewed by Dave Hyatt.

        - fixed layout tests

        * WebKit.pbproj/project.pbxproj: Set deployment target to 10.3 in the build styles.
        When built without a build style (by Apple B&I) we want to get the target from the
        environment. But when built with a build style (by Safari engineers and others), we want
        to use 10.3. Because our deployment target was not set, we ran into this bug:

            <rdar://problem/4108717> CTFontGetGlyphWithName doesn't work with some strings

        * Makefile.am: Took out extra parameters that make command-line building different from
        Xcode building. Now that this is fixed, you should not get a full rebuild if you switch
        from command line to Xcode or back.

2005-05-04  Chris Blumenberg  <cblu@apple.com>

	Fixed: 
	<rdar://problem/4078417> REGRESSION (125-412): MLB gameday page doesn't update (Flash)
	<rdar://problem/4072280> XMLHttpRequest calls onReadyStateChange callback with bogus status value
        
	Reviewed by john.

	Our WebKit-level caching of subresources "dumbed-down" information held in NSURLResponse. This caused some loads to lack response headers and thus disabling cache directives. Status codes were also not retained and this caused XMLHttpRequest to fail frequently. The fix is to have WebResource retain the NSURLResponse and to use the NSURLResponse when we decide to load from WebResources.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge objectLoadedFromCacheWithURL:response:data:]): call new [WebResource _initWithData:URL:response:]
        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate _canUseResourceWithResponse:]): new, checks response cache directives
        (-[WebBaseResourceHandleDelegate loadWithRequest:]): call _canUseResourceWithResponse:
        (-[WebBaseResourceHandleDelegate saveResource]): call new [WebResource _initWithData:URL:response:]
        * WebView.subproj/WebResource.m:
        (-[WebResourcePrivate dealloc]):
        (-[WebResource initWithData:URL:MIMEType:textEncodingName:frameName:]): call renamed _initWithData:URL:MIMEType:textEncodingName:frameName:response:copyData:
        (-[WebResource initWithCoder:]): decode the NSURLReponse
        (-[WebResource encodeWithCoder:]): encode the NSURLReponse
        (-[WebResource _initWithData:URL:MIMEType:textEncodingName:frameName:response:copyData:]): take the NSURLReponse
        (-[WebResource _initWithData:URL:response:]): new
        (-[WebResource _initWithPropertyList:]): decode the NSURLReponse
        (-[WebResource _propertyListRepresentation]): encode the NSURLReponse
        (-[WebResource _response]): return ivar if we have one
        * WebView.subproj/WebResourcePrivate.h:

2005-05-03  David Hyatt  <hyatt@apple.com>

	Fix object element support so that fallback content works.  With this change Safari passes the Acid2 test.
	
        Reviewed by Maciej

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge determineObjectFromMIMEType:URL:]):
        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource _receivedMainResourceError:complete:]):
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient continueAfterContentPolicy:response:]):

2005-05-03  Darin Adler  <darin@apple.com>

        * WebView.subproj/WebUIDelegate.h: Fixed incorrect comment.

2005-05-01  Darin Adler  <darin@apple.com>

        - move to Xcode native targets and stop checking in generated files

        * WebKit.pbproj/project.pbxproj: Updated to use native targets and generate all the generated
        files, so we don't have to check them in any more.
        * Info.plist: Added. Native targets use a separate file for this.

        * Plugins.subproj/npapi.m: Fixed import statement to get npapi.h from <WebKit/> rather than current directory.

        * Makefile.am: Removed timestamp cleaning rules since we don't use it any more.

        * .cvsignore: Removed various timestamp files.

        * DOM.subproj/DOM-compat.h: Removed.
        * DOM.subproj/DOM.h: Removed.
        * DOM.subproj/DOMCSS.h: Removed.
        * DOM.subproj/DOMCore.h: Removed.
        * DOM.subproj/DOMEvents.h: Removed.
        * DOM.subproj/DOMExtensions.h: Removed.
        * DOM.subproj/DOMHTML.h: Removed.
        * DOM.subproj/DOMPrivate.h: Removed.
        * DOM.subproj/DOMRange.h: Removed.
        * DOM.subproj/DOMStylesheets.h: Removed.
        * DOM.subproj/DOMTraversal.h: Removed.
        * DOM.subproj/DOMViews.h: Removed.
        * Plugins.subproj/WebScriptObject.h: Removed.
        * Plugins.subproj/npapi.h: Removed.
        * Plugins.subproj/npruntime.h: Removed.
        * copy-webcore-files-to-webkit: Removed.
        * embed-frameworks.sh: Removed.
        * force-clean-timestamp: Removed.

2005-04-28  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fixed problems preventing us from compiling with gcc 4.0

        * WebKit.pbproj/project.pbxproj: Removed -fobjc-exceptions because I can't figure out an easy
        way to pass it only when compiling Objective-C/C++. Removed -Wmissing-prototypes from
        WARNING_CPLUSPLUSFLAGS since it's now a C-only warning.

        * History.subproj/WebHistoryItem.m: (-[WebHistoryItem pageCache]): Changed return type
        to match the declaration.
        * WebCoreSupport.subproj/WebBridge.m: (-[WebBridge _retrieveKeyboardUIModeFromPreferences:]):
        Fixed a BOOL that should have been a Boolean.
        * WebCoreSupport.subproj/WebTextRenderer.m: Removed redundant copy of ROUND_TO_INT, also in
        a WebCore header.
        (-[WebTextRenderer _computeWidthForSpace]): Had to add cast because of difference in type of
        ROUND_TO_INT vs. CEIL_TO_INT.
        (pathFromFont): Added a cast to convert UInt8 * to char *.
        * WebView.subproj/WebFrameView.m:
        (-[WebFrameView _setDocumentView:]): Fixed parameter type to match the declaration.
        (-[WebFrameView documentView]): Fixed return type to match the declaration.
        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _startDraggingImage:at:operation:event:sourceIsDHTML:DHTMLWroteData:]):
        Initialized a variable to quiet an incorrect gcc 4.0 uninitialized variable warning.
        (-[WebHTMLView deleteToMark:]): Switched from @try style to NS_DURING style of exception handler
        because we can't pass -fobjc-exceptions just to Objective-C at the moment (see above).
        (-[WebHTMLView selectToMark:]): Ditto.
        (-[WebHTMLView swapWithMark:]): Ditto.

2005-04-27  John Sullivan  <sullivan@apple.com>

        Reviewed by Dave Harrison.
        
        - fixed <rdar://problem/3547489> pop-up window blocking preference and 
        menu item can easily get out of sync.

        * WebView.subproj/WebPreferences.m:
        (-[WebPreferences _setStringValue:forKey:]):
        save local value before setting value in NSUserDefaults, so clients reacting to NSUserDefaults
        change notification but calling back on WebPreferences API will see the updated value.
        (-[WebPreferences _setIntegerValue:forKey:]):
        ditto
        (-[WebPreferences _setBoolValue:forKey:]):
        ditto

2005-04-26  Richard Williamson   <rjw@apple.com>

	Fixed <rdar://problem/4098713> Scripting API is incompatible with Mozilla

        Reviewed by Chris.

        * Plugins.subproj/npfunctions.h:
        * Plugins.subproj/npruntime.h:

2005-04-26  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - fixed <rdar://problem/3655817> please add support for mouse wheel events and the onmousewheel handler

        * WebView.subproj/WebHTMLView.m: (-[WebHTMLView scrollWheel:]): Call sendScrollWheelEvent: method
        instead of the old scrollOverflowWithScrollWheelEvent: (just a name change).

2005-04-18  Darin Adler  <darin@apple.com>

        Reviewed by Hyatt.

        - fixed <rdar://problem/4092614> REGRESSION (Tiger): progressively loaded background images "scroll around" instead of just appearing

        * WebCoreSupport.subproj/WebImageData.m:
        (-[WebImageData _imageSourceOptions]): Moved a global inside this function, since it's only used here.
        (-[WebImageData _cacheImages:allImages:]): Fixed a sizeof that was getting the size of the wrong thing.
        (-[WebImageData _isSizeAvailable]): Used calloc in a more consistent way.
        (drawPattern): Removed an unneeded cast.
        (-[WebImageData tileInRect:fromPoint:context:]): Here's the actual bug fix. Don't use the image size
        when deciding whether the image needs to be tiled as a pattern nor when creating the pattern: in both
        cases, use the tile size. The old way was wrong, and the new way works perfectly. Also removed uneeded
        error message when the image is not yet loaded enough to create a CGImageRef for it -- it's fine to
        draw nothing in that case.

2005-04-14  John Sullivan  <sullivan@apple.com>

        Reviewed by Chris.

        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate connection:willCacheResponse:]):
        Beefed up assertion that's been bugging me and Chris to include
        the two troublemaking values.

2005-04-05  David Hyatt  <hyatt@apple.com>

	Fix for 4077106, wheel scroll amount smaller in Tiger.  All along wheeling should have been 4x the default
	line height of 10 (just as arrow keys did).  Scroll arrows should have done this too for scroll views (they did
	already for overflow sections).  This patch puts the override into the scrollview itself, and removes the
	multipliers in the private frame methods.
	
        Reviewed by darin

        * WebView.subproj/WebFrameView.m:
        (-[WebFrameView _verticalKeyboardScrollDistance]):
        (-[WebFrameView initWithFrame:]):
        (-[WebFrameView _horizontalKeyboardScrollDistance]):

=== WebKit-312.1 ===

2005-03-31  Chris Blumenberg  <cblu@apple.com>

	Fixed: <rdar://problem/4070729> REGRESSION (125-311, Panther-only?): Safari crashes while reloading "My eBay" page

        Reviewed by rjw.

        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate resourceData]): retain and autorelease resourceData since releaseResources (which releases resourceData) may be called before the caller of this method has an opporuntity to retain the returned data

=== Safari-412 ===

=== Safari-411 ===

2005-03-23  Richard Williamson   <rjw@apple.com>

	Use Patti Yeh's hack to determine the appropriate rectangle
	to place the "associated word" window.  
	If there is no marked text firstRectForCharacterRange: will
	use the selected range to determine the returned rectangle,
	ignoring the input range.  This is the fix from
	4029491 that I previously backed out.

        Reviewed by Vicki.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView firstRectForCharacterRange:]):

2005-03-23  Richard Williamson   <rjw@apple.com>

	Fixed <rdar://problem/4062490> REGRESSION (WebKit-408): no subresources reported in Activity window after going back at hrweb.apple.com

	Stop collecting subresource responses after the document
	had loaded, not after it has been opened.

        Reviewed by Chris.

        * WebView.subproj/WebFrame.m:
        (-[WebFrame _setState:]):
        (-[WebFrame _opened]):

2005-03-21  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	<rdar://problem/4051145> The QuickTime Cocoa plug-in needs an SPI that it can call to check for URL policy

        * Plugins.subproj/WebPluginContainerCheck.h: Added.
        * Plugins.subproj/WebPluginContainerCheck.m: Added this new helper class to encapsulate
	an async plugin navigation check.
        (+[WebPluginContainerCheck checkWithRequest:target:resultObject:selector:controller:]): Convenience allocator that gives autoreleased value.
        (-[WebPluginContainerCheck initWithRequest:target:resultObject:selector:controller:]): Initializer.
        (-[WebPluginContainerCheck finalize]): Just assert that we're done, it would
	be bad to deallocate this object while request is still outstanding.
        (-[WebPluginContainerCheck dealloc]): Ditto.
        (-[WebPluginContainerCheck _continueWithPolicy:]): Method to continue after async
	policy check.
        (-[WebPluginContainerCheck _isDisallowedFileLoad]): Do "file: URL from remote content"
	check.
        (-[WebPluginContainerCheck _actionInformationWithURL:]): Helper to make action
	dictionary.
        (-[WebPluginContainerCheck _askPolicyDelegate]): Call policy delegate to let
	the app decide if this load is allowed.
        (-[WebPluginContainerCheck start]): Start the check.
        (-[WebPluginContainerCheck cancel]): Cancel a check in progress.
        * Plugins.subproj/WebPluginController.h:
        * Plugins.subproj/WebPluginController.m:
        (-[WebPluginController initWithDocumentView:]): Initialize new _checksInProgress field.
        (-[WebPluginController _webPluginContainerCancelCheckIfAllowedToLoadRequest:]): Implement
	this new SPI method.
        (-[WebPluginController _cancelOutstandingChecks]): New helper to make sure to cancel
	all outstanding requests when destroying all plugins.
        (-[WebPluginController destroyAllPlugins]): Call above helper.
        (-[WebPluginController _webPluginContainerCheckIfAllowedToLoadRequest:inFrame:resultObject:selector:]): Implement this new plug-in SPI method.
        (-[WebPluginController bridge]): New helper method.
        (-[WebPluginController webView]): New helper method.
        * WebView.subproj/WebPolicyDelegatePrivate.h: Add new navigation
	type WebNavigationTypePlugInRequest.
        * WebKit.pbproj/project.pbxproj: Add new files.
        * WebView.subproj/WebDefaultPolicyDelegate.m:
        (-[WebDefaultPolicyDelegate webView:decidePolicyForNavigationAction:request:frame:decisionListener:]): Don't open externally on a plug-in request.

2005-03-23  Richard Williamson   <rjw@apple.com>

	Fixed <rdar://problem/4053515> REGRESSION (Mail): Kotoeri input method reconversion does not work in WebViews

	We now use actual document NSRanges to represent both marked text
	ranges and selection ranges.

        Reviewed by Ken Kocienda.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView validAttributesForMarkedText]):
        (-[WebHTMLView firstRectForCharacterRange:]):
        (-[WebHTMLView selectedRange]):
        (-[WebHTMLView markedRange]):
        (-[WebHTMLView _selectMarkedText]):
        (-[WebHTMLView setMarkedText:selectedRange:]):

=== Safari-410 ===

2005-03-22  Darin Adler  <darin@apple.com>

        * English.lproj/StringsNotToBeLocalized.txt: Updated for recent changes.

=== Safari-409 ===

2005-03-20  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	<rdar://problem/4060020> Add stub version of security SPI for QuickTime plug-in so QuickTime team has something to compile and link against
        
	* Plugins.subproj/WebPluginContainerPrivate.h: Added.
        * Plugins.subproj/WebPluginController.m:
        (-[WebPluginController _webPluginContainerCheckIfAllowedToLoadRequest:inFrame:resultObject:selector:]):
        (-[WebPluginController _webPluginContainerCancelCheckIfAllowedToLoadRequest:]):
        * WebKit.pbproj/project.pbxproj:

2005-03-19  David Harrison  <harrison@apple.com>

        Reviewed by Maciej.
        
        <rdar://problem/4059479> Misspelling underline does underline the whole word, could go farther to the right

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer misspellingLinePatternGapWidth]):
        (-[WebTextRenderer drawLineForMisspelling:withWidth:]):
        Consider that the last pixel in the underline dot pattern is transparent.

2005-03-19  Darin Adler  <darin@apple.com>

        Reviewed by Maciej (a while back).

        - fixed <rdar://problem/4059323> local-file security check is allowing plug-in streams, but must not

        * Plugins.subproj/WebNetscapePluginStream.m:
        (-[WebNetscapePluginStream initWithRequest:pluginPointer:notifyData:sendNotification:]):
        Roll out change I made on 3-13. That change is needed for subresource, but not for plug-in streams.
        For plug-in streams it's too risky, and leaves a serious security hole open.

2005-03-19  Darin Adler  <darin@apple.com>

        Reviewed by Ken and John.

        - fixed <rdar://problem/4059123> REGRESSION (402-403): deleteWordForward: and deleteWordBackward: start deleting single characters after the first delete

        * WebView.subproj/WebHTMLView.m: (-[WebHTMLView _deleteWithDirection:granularity:killRing:isTypingAction:]):
        Fixed backwards logic in here and added missing check. Set action to one of the two typing actions only
        if isTypingAction is YES.

2005-03-19  David Harrison  <harrison@apple.com>

        Reviewed by me (written by Patti Yeh).
        
        <rdar://problem/4029491> <TCIM> CangJie: the candidate window appears at the top left hand corner during typing in Mail and iChat

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView firstRectForCharacterRange:]):
        Use selected range if there is no marked range.

=== Safari-408 ===

2005-03-18  David Harrison  <harrison@apple.com>

        Reviewed by Darin.

        <rdar://problem/3584942> AX: Safari Accessibility parent-child mismatch

        * WebView.subproj/WebFrameView.m:
        (-[WebFrameView webCoreBridge]):
        New to conform to WebCoreBridgeHolder protocol.

2005-03-18  Richard Williamson   <rjw@apple.com>
	
	Fixed <rdar://problem/4057004> Data from XMLHTTPRequest is never dealloced

	WebDataSource keeps an array of all the NSURLResponses associated
	with the load for a page.  This is used to playback delegate messages
	when loading from the page cache.  However, after the document
	has completed it's initial load, we continue to keep track of responses. 
	So, this has the consequence of keeping all the responses for a page
	around for the life of the page.  NSURLResponses are now very
	heavy.  They indirectly reference the resource data (via the
	download assessment dictionary).  This fix will keep
	references to responses around for those resources loaded during initial
	page load, but not after that point.

        Reviewed by Ken.

        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource _addResponse:]):
        (-[WebDataSource _stopRecordingResponses]):
        * WebView.subproj/WebDataSourcePrivate.h:
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _opened]):

2005-03-18  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Darin

        Fix for this bug:
        
        <rdar://problem/4053729> Copy/paste of page with frames into Blot or Mail does nothing and loses insertion point

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _selectedArchive]): Wrap frameset documents in an iframe, so they can be pasted into 
        existing documents which will have a body or frameset of their own.

=== Safari-407 ===

2005-03-17  Richard Williamson   <rjw@apple.com>

	Fixed <rdar://problem/4055562> REGRESSION (Tiger): Safari doesn't draw progressively-loaded JPEGs (www.theregister.co.uk, www.titantalk.com)

	Anothe side effect of lazy loading of image meta data.  We now
	don't cache image size until size meta data is actually available.

        Reviewed by Darin.

        * WebCoreSupport.subproj/WebImageData.m:
        (-[WebImageData size]):

2005-03-16  David Harrison  <harrison@apple.com>

        Reviewed by Maciej.
        
        <rdar://problem/4048506> Deleting from beginning of editable div deletes other document elements
        
        Also changed WebCore.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _shouldDeleteRange:]):
        Added call to new bridge method canDeleteRange.

2005-03-16  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Darin

        Fix for this bug:
        
        <rdar://problem/4042935> undo doesn't work properly during inline input

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView setMarkedText:selectedRange:]): Call new -[WebCoreBridge replaceMarkedTextWithText:] instead of 
        -[WebCoreBridge replaceSelectionWithText:selectReplacement:smartReplace:]. The former call was just added in 
        order to provide a better mapping of international text input onto the typing command/undo design.

2005-03-15  Richard Williamson   <rjw@apple.com>

	Fixed <rdar://problem/4040321> Exception: Someone's trying to encode a WebDataRequestParameters instance

	If client mutates request use new Foundation SPI to address remove applewebdata properties	from request.

        Reviewed by Ken Kocienda.

        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate willSendRequest:redirectResponse:]):
        * WebView.subproj/WebDataProtocol.h:
        * WebView.subproj/WebDataProtocol.m:
        (+[NSURLRequest _webDataRequestPropertyKey]):

2005-03-15  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Vicki

        Fox for this bug:
        
        <rdar://problem/4052642> Each delete keystroke is in its own undo group; not included in undo group with other typing

        Calling -[WebCore setSelectedDOMRange:range affinity:] had the result of "closing" any active set of typing
        keystrokes grouped together in a single undo operation. My change on 27 Jan to route delete keystrokes 
        through _deleteRange:killRing:... made this feature regress. Previous to that change, the backwards delete
        key went through separate code that is no longer in the tree that did not set the selection in the way
        it is done now.
        
        The solution is to add an extra argument to the set-selection call. The WebCoreBridge now offers this method:
        -[WebCore setSelectedDOMRange:range affinity:closeTyping:]. Now, callers must indicate whether setting the 
        selection will act to close typing or not. The code changes below all add this new argument with the
        appropriate value for closeTyping.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _deleteRange:killRing:prepend:smartDeleteOK:deletionAction:]): Passes NO for closeTyping when
        deletionAction is deleteKeyAction or forwardDeleteKeyAction; YES when deleteSelectionAction.
        (-[WebHTMLView _expandSelectionToGranularity:]): Passes YES for closeTyping.
        (-[WebHTMLView selectToMark:]): Passes YES for closeTyping.
        (-[WebHTMLView swapWithMark:]): Passes YES for closeTyping.
        (-[WebHTMLView transpose:]): Passes YES for closeTyping.
        (-[WebHTMLView _selectMarkedText]): Passes NO for closeTyping.
        (-[WebHTMLView _selectRangeInMarkedText:]): Passes NO for closeTyping.
        * WebView.subproj/WebView.m:
        (-[WebView setSelectedDOMRange:affinity:]): Passes YES for closeTyping.

2005-03-14  Richard Williamson   <rjw@apple.com>

	Fix <rdar://problem/4051389> 8A413: gifs animating too fast

        Reviewed by Maciej.

	Match Mozilla's policy for minimum frame duration, which is somewhat odd:

	<= 0.01 sec use .1 sec, otherwise use specified duration.

        * WebCoreSupport.subproj/WebImageData.m:
        (-[WebImageData _frameDurationAt:]):

2005-03-14  Darin Adler  <darin@apple.com>

        Reviewed by Harrison.

        - fixed <rdar://problem/4049776> Seed: Mail: Disable spellcheck leaves red artifacts

        * WebView.subproj/WebFrameInternal.h: Added _unmarkAllMisspellings.
        * WebView.subproj/WebFrame.m: (-[WebFrame _unmarkAllMisspellings]): Added.
        Calls unmarkAllMisspellings on the bridge and self and all subframes.

        * WebView.subproj/WebView.m: (-[WebView setContinuousSpellCheckingEnabled:]):
        Call _unmarkAllMisspellings on the main frame when turning continuous spell checking off.

2005-03-14  Richard Williamson   <rjw@apple.com>

	Fixed <rdar://problem/4027928> Tiger_8A394:Acrobat crashes while tried to remove the subscription errors by clicking on "Would you like to remove the subscription" from Tracker details view pane

	The Acrobat application triggers loads of new documents in it's policy delegate.  This
	ultimately causes the WebHTMLView to be released before their event handlers have
	returned.  To bullet proof against this case we retain/release self before passing
	the event on for further handling.
	
        Reviewed by Maciej.

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _updateMouseoverWithEvent:]):
        (-[WebHTMLView scrollWheel:]):
        (-[WebHTMLView mouseDown:]):
        (-[WebHTMLView mouseDragged:]):
        (-[WebHTMLView mouseUp:]):
        (-[WebHTMLView keyDown:]):
        (-[WebHTMLView keyUp:]):
        (-[WebHTMLView performKeyEquivalent:]):

2005-03-14  Vicki Murley  <vicki@apple.com>

	- roll out the fix for 4040321, since it is still pending CCC review.

    2005-03-10  Richard Williamson   <rjw@apple.com>

        Fixed <rdar://problem/4040321> Exception: Someone's trying to encode a WebDataRequestParameters instance 

        Reviewed by Darin.

        If a delegate returns a mutated applewebdata: request in it's willSendRequest:
        method, we don't load using the WebDataRequest.  Instead we do a normal load.
        Unfortunately, if the request they return is mutated *copy* of the applewebdata: 
        request it will hold the applewebdata: special properties.  These properties 
        will be encoded into the cache.   They should not be.  So, to fix, we sanitize the
        request, by removing the special properties from the request.

        Note that we had to dig into the private guts of NSURLRequest because there is
        no public mechanism to remove properties from a request, see 4046775.

        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate willSendRequest:redirectResponse:]):
        * WebView.subproj/WebDataProtocol.h:
        * WebView.subproj/WebDataProtocol.m:
        (-[NSURLRequest _webDataRequestExternalRequest]):
        (-[NSURLRequest _webDataRequestSanitize]):

=== Safari-406 ===

2005-03-13  Darin Adler  <darin@apple.com>

        Reviewed by Ken and Maciej.

        - fixed <rdar://problem/4049040> REGRESSION (403-405): security check prevents user stylesheet from loading (Dictionary.app doesn't work at all!)

        * Plugins.subproj/WebNetscapePluginStream.m: (-[WebNetscapePluginStream initWithRequest:pluginPointer:notifyData:sendNotification:]):
        Allow plug-in subresource streams to load with any URL, ignoring the "canLoadURL" method's restriction (only
        file URLs can load other file URLs), which now applies only to main resources, like web pages in frames or
        object tags and plug-in main resources.

        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge startLoadingResource:withURL:customHeaders:]): Allow subresources to load with any URL, as above.
        This allows things like images, stylesheets, and JavaScript to be loaded without the "canLoadURL" method's
        restriction.
        (-[WebBridge startLoadingResource:withURL:customHeaders:postData:]): Ditto.
        (-[WebBridge syncLoadResourceWithURL:customHeaders:postData:finalURL:responseHeaders:statusCode:]): Ditto.

2005-03-10  Richard Williamson   <rjw@apple.com>

	Fixed <rdar://problem/4040321> Exception: Someone's trying to encode a WebDataRequestParameters instance 

        Reviewed by Darin.

	If a delegate returns a mutated applewebdata: request in it's willSendRequest:
	method, we don't load using the WebDataRequest.  Instead we do a normal load.
	Unfortunately, if the request they return is mutated *copy* of the applewebdata: 
	request it will hold the applewebdata: special properties.  These properties 
	will be encoded into the cache.   They should not be.  So, to fix, we sanitize the
	request, by removing the special properties from the request.

	Note that we had to dig into the private guts of NSURLRequest because there is
	no public mechanism to remove properties from a request, see 4046775.

        * WebView.subproj/WebBaseResourceHandleDelegate.m:
        (-[WebBaseResourceHandleDelegate willSendRequest:redirectResponse:]):
        * WebView.subproj/WebDataProtocol.h:
        * WebView.subproj/WebDataProtocol.m:
        (-[NSURLRequest _webDataRequestExternalRequest]):
        (-[NSURLRequest _webDataRequestSanitize]):

=== Safari-405 ===

2005-03-10  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Vicki.

	<rdar://problem/4046510> REGRESSION (TOT): All Flash and Shockwave plugin-based web content missing
        
	* Plugins.subproj/WebNetscapePluginStream.m:
        (-[WebNetscapePluginStream initWithRequest:pluginPointer:notifyData:sendNotification:]):

2005-03-10  John Sullivan  <sullivan@apple.com>

        Reviewed by Vicki.
        
        - fixed <rdar://problem/4045843> Going back/forward to error page 
        hits assertion in -[WebDataSource(WebPrivate) _setData:]

        * WebView.subproj/WebDataSource.m:
        (-[WebDataSource _setData:]):
        Removed bogus assertion

2005-03-09  Deborah Goldsmith  <goldsmit@apple.com>

        Reviewed by Darin.

        - fixed <rdar://problem/3997044> default encoding for non-Latin incorrect

	* WebKit/WebView.subproj/WebPreferences.m: (+[WebPreferences _systemCFStringEncoding]):
        Call __CFStringGetUserDefaultEncoding to get region, and TECGetWebTextEncodings to get
        the first encoding to determine the default encoding.

2005-03-09  Darin Adler  <darin@apple.com>

        Reviewed by Richard.

        - fixed <rdar://problem/4034175> REGRESSION (Mail): Can't use any font with style Light/Condensed/Semibold/Extrabold, etc

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _styleFromFontAttributes:]): Use a constant instead of hard-coded weight for clarity.
        (-[WebHTMLView _originalFontA]): Ditto.
        (-[WebHTMLView _originalFontB]): Ditto.
        (-[WebHTMLView _addToStyle:fontA:fontB:]): Add code to detect the case where the family name is not good enough
        to specify the font precisely. In that case, use the Postscript font name instead. Also change variable names
        so it's easier to understand the method.

2005-03-06  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	<rdar://problem/4005575> Arbitrary file disclosure vulnerability due to ability to load local html from remote content
        
	* Plugins.subproj/WebBaseNetscapePluginView.m:
        (-[WebBaseNetscapePluginView requestWithURLCString:]):
        * Plugins.subproj/WebNetscapePluginEmbeddedView.m:
        (-[WebNetscapePluginEmbeddedView didStart]):
        * Plugins.subproj/WebNetscapePluginStream.m:
        (-[WebNetscapePluginStream initWithRequest:pluginPointer:notifyData:sendNotification:]):
        * WebCoreSupport.subproj/WebBridge.m:
        (-[WebBridge createWindowWithURL:frameName:]):
        (-[WebBridge startLoadingResource:withURL:customHeaders:]):
        (-[WebBridge startLoadingResource:withURL:customHeaders:postData:]):
        (-[WebBridge syncLoadResourceWithURL:customHeaders:postData:finalURL:responseHeaders:statusCode:]):
        (-[WebBridge loadURL:referrer:reload:userGesture:target:triggeringEvent:form:formValues:]):
        (-[WebBridge postWithURL:referrer:target:data:contentType:triggeringEvent:form:formValues:]):
        (-[WebBridge createChildFrameNamed:withURL:referrer:renderPart:allowsScrolling:marginWidth:marginHeight:]):
        (-[WebBridge viewForPluginWithURL:attributeNames:attributeValues:MIMEType:]):
        * WebView.subproj/WebFrame.m:
        (-[WebFrame _loadURL:referrer:intoChild:]):
        * WebView.subproj/WebFramePrivate.h:

2005-03-09  Richard Williamson   <rjw@apple.com>
	
	Fixed <rdar://problem/4032938> Safari: text layout for MS P Gothic font is corrupted

	The AppKit and ATS reports that MS P Gothic is fixed pitch.  It is
	not!  This is another case of "fixed pitch" being wrong.  I've
	coalesced all the special cases into our isFontFixedPitch:, and
	used a dictionary to improve speed.  No performance regression.

        Reviewed by Maciej.

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer _computeWidthForSpace]):
        * WebCoreSupport.subproj/WebTextRendererFactory.m:
        (-[WebTextRendererFactory clearCaches]):
        (-[WebTextRendererFactory isFontFixedPitch:]):

2005-03-09  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        <rdar://problem/4040388> REGRESSION (172-173): nonrepro crash in -[NSString(WebNSURLExtras) _web_isUserVisibleURL]

        * Misc.subproj/WebNSURLExtras.m:
        (-[NSString _web_isUserVisibleURL]): Fixed some pointer expressions that didn't include the index in the expression.
        (readIDNScriptWhiteListFile): Removed NSLog statements in here since we decided they aren't useful and they will
        write some messages on Tiger.

2005-03-09  Darin Adler  <darin@apple.com>

        * DOM.subproj/DOMPrivate.h: Checked in file copied from WebCore.

2005-03-08  Richard Williamson   <rjw@apple.com>

        Fixed <rdar://problem/4036949> many JPEG images fail to incremental-load due to change in ImageIO JPEG header parsing (to be fixed in WebKit)
	Fixed <rdar://problem/4042570> Need to check image properties for presence of width/height properties

	ImageIO-55 changed how image properties are created.  They
	are now created incrementally.  So we need "re-get" the image
	properties if the properties we care about (width/height) aren't
	in the property dictionary.

        Reviewed by John.

        * WebCoreSupport.subproj/WebImageData.h:
        * WebCoreSupport.subproj/WebImageData.m:
        (-[WebImageData init]):
        (-[WebImageData fileProperties]):
        (-[WebImageData propertiesAtIndex:]):
        (-[WebImageData _isSizeAvailable]):
        (-[WebImageData incrementalLoadWithBytes:length:complete:callback:]):
        (-[WebImageData size]):

2005-03-08  John Sullivan  <sullivan@apple.com>

        A couple of tweaks to the previous patch, from Darin's review.

        * Misc.subproj/WebNSPasteboardExtras.m:
        (_writableTypesForImageWithoutArchive):
        remove unnecessary _web prefix
        (_writableTypesForImageWithArchive):
        ditto
        (+[NSPasteboard _web_writableTypesForImageIncludingArchive:]):
        use mutableCopy rather than initWithArray:, and adjust for name changes

2005-03-08  John Sullivan  <sullivan@apple.com>

        Reviewed by Ken.
        
        - fixed <rdar://problem/4031826> REGRESSION (Mail): standalone images from 
        Safari can't be pasted into Mail (WebKit part of fix)
        
        We were always declaring webarchive-related pasteboard types, even in the standalone
        image cases where we had no webarchive. Unfortunately, the WebView pasteboard-related
        API doesn't prevent this kind of thing from happening, because the code that
        declares the types isn't guaranteed to be anywhere near the code that writes
        the pasteboard data.
        
        After this fix, I discovered that pasting standalone images into Mail still doesn't
        work right, but the remaining issues seem to be entirely in Mail. I wrote up 4041671
        to cover these.

        * Misc.subproj/WebNSPasteboardExtras.h:
        (+[NSPasteboard _web_writableTypesForImageIncludingArchive:]):
        Added boolean parameter; clients must specify whether or not there's an
        archive involved, because the array of types is different if there is.

        * Misc.subproj/WebNSPasteboardExtras.m:
        (_web_writableTypesForImageWithoutArchive):
        new static function, constructs (once) and returns the array of types
        for images that don't have archives
        (_web_writableTypesForImageWithArchive):
        new static function, constructs (once) and returns the array of types
        for images that do have archives
        (+[NSPasteboard _web_writableTypesForImageIncludingArchive:]):
        added boolean parameter, now calls one of the two new static functions
        
        (-[NSPasteboard _web_writeImage:URL:title:archive:types:]):
        added asserts that we aren't declaring the archive types if we don't have archive data
        
        (-[NSPasteboard _web_declareAndWriteDragImage:URL:title:archive:source:]):
        updated to pass parameter to _web_writableTypesForImageIncludingArchive:
        
        * WebView.subproj/WebDefaultContextMenuDelegate.m:
        (-[WebDefaultUIDelegate copyImageToClipboard:]):
        updated to pass parameter to _web_writableTypesForImageIncludingArchive:

        * WebView.subproj/WebImageView.m:
        (-[WebImageView copy:]):
        updated to pass parameter to _web_writableTypesForImageIncludingArchive:

        * WebView.subproj/WebView.m:
        (-[WebView pasteboardTypesForElement:]):
        updated to pass parameter to _web_writableTypesForImageIncludingArchive:

2005-03-07  Richard Williamson   <rjw@apple.com>

	More bullet proofing for <rdar://problem/4038304> CrashTracer: ....9 crashes at com.apple.WebKit: -[WebTextRenderer initWithFont:usingPrinterFont:] + 840

	Protect against removal of Times and Times New Roman from
	system.  If these fonts are removed attempt to get system font
	instead of FATAL_ALWAYS.

        Reviewed by John.

        * WebCoreSupport.subproj/WebTextRenderer.m:
        (-[WebTextRenderer initWithFont:usingPrinterFont:]):

=== Safari-403 ===

2005-03-06  Darin Adler  <darin@apple.com>

        - fixed obvious mistake in IDN script code (luckily it hasn't been in a submission yet!)

        * Misc.subproj/WebNSURLExtras.m: (readIDNScriptWhiteListFile): Use "index" to index into the array,
        not "script", which is the script number, not the 32-bit-word index.

2005-03-05  Kevin Decker  <kdecker@apple.com>

        Reviewed by Darin.

	Fixed: <rdar://problem/4038529> Infinite progress bar loading webcams and other sites that use multipart/x-mixed-replace

	The previous patch I landed prevented us from loading multipart/x-mixed-replace but did not always update the progress bar accordingly.  
        This stops websites from having seemingly infinite progress in the browser UI.  

        * WebCoreSupport.subproj/WebSubresourceClient.m:
        (-[WebSubresourceClient didReceiveResponse:]): If this is "multipart/x-mixed-replace", remove the WebBaseResourceHandleDelegate client from 
        the datasource's subresource array, otherwise -[WebDataSource isLoading] incorrectly returns YES.   Also it's possible at this point in
         time we're done loading now (loaded everything else except for the multipart/x-mixed-replace content) so go ahead and check to see if 
         in fact we're complete. 
        * WebView.subproj/WebMainResourceClient.m:
        (-[WebMainResourceClient connection:didReceiveResponse:]): ditto

2005-03-05  Richard Williamson   <rjw@apple.com>

	Fixed panther build problem.  Shouldn't include
	changes for 3968753 on panther.

        Reviewed by John.

        * WebView.subproj/WebView.m:
        (-[WebView _commonInitializationWithFrameName:groupName:]):

2005-03-05  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - fixed <rdar://problem/4034603> REGRESSION (185-188): RadarWeb can't send enclosures anymore

        * WebView.subproj/WebFormDataStream.m:
        (closeCurrentStream): Release currentData when closing the stream.
        (advanceCurrentStream): Set up and retain currentData when the current stream is reading that data, so the
        data won't be released while in use.
        (formCreate): Initialize currentData to NULL.

        - fixed <rdar://problem/4037562> Tiger8A402: Help Viewer crashed when viewing help for iChat (infinite recursion in WebView)

        * WebView.subproj/WebView.m: (-[WebView _responderValidateUserInterfaceItem:]):
        Check for the case where we ourselves are the responder. This avoids an infinite loop.
        The actual code to perform operations avoids this with a global variable, but this lighter weight
        solution is sufficient here because validate operations don't call through to the next responder.

2005-03-04  Richard Williamson   <rjw@apple.com>

	Fixed <rdar://problem/3968753> REGRESSION: Poor performance with differing multiple animated GIFs (was fast in Panther)

	Disable coalesced updates (in CG).  This restores the
	panther behavior.

        Reviewed by David Harrison.

        * WebView.subproj/WebView.m:
        (-[WebView _commonInitializationWithFrameName:groupName:]):

2005-03-04  Adele Amchan  <adele@apple.com>

        Reviewed by Darin.

        * English.lproj/StringsNotToBeLocalized.txt: added new strings "text/x-vcf" and "text/x-csv" to the list

2005-03-04  Adele Amchan  <adele@apple.com>

        Reviewed by Chris.

        Fix for <rdar://problem/4032982> Sun iPlanet app: not able to import AddressBook CSV format addresses properly
        Fix for <rdar://problem/4032985> Sun iPlanet app: not able to import vCard format addresses properly

        * WebView.subproj/WebTextView.m:
        (+[WebTextView unsupportedTextMIMETypes]): added "text/x-csv" and "text/x-vcf" to the list of MIME types that our text view doesn't handle

2005-03-04  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - fixed <rdar://problem/4036817> REGRESSION: ctrl-y broken when a line + carriage return cut

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _deleteRange:killRing:prepend:smartDeleteOK:deletionAction:]): Merged _handleKillRing behavior
        into this function, since there's now a more-complicated way the startNewKillRingSequence boolean needs to
        be handled. Set the startNewKillRingSequence boolean after the entire process so changing the selection before
        and during the editing dosn't clear it. Also change "isTypingAction" parameter to "deletionAction" so we can
        handle forward delete with this method.
        (-[WebHTMLView _deleteSelection]): Pass deleteSelectionAction for action rather than NO for isTypingAction,
        which is the way to say the same thing using the new parameter.
        (-[WebHTMLView _deleteWithDirection:granularity:killRing:isTypingAction:]): Refactor to use the _deleteRange
        method above. Also calls _shouldDeleteRange: for the pre-existing selection case; not doing that before was
        a bug.
        (-[WebHTMLView deleteToMark:]): Pass deleteSelectionAction for action rather than NO for isTypingAction,
        which is the way to say the same thing using the new parameter.

2005-03-04  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - fixed <rdar://problem/4020413> REGRESSION (Mail): can't use fonts with names that start with "#" in Mail (Korean fonts)

        * WebView.subproj/WebHTMLView.m:
        (-[WebHTMLView _styleFromFontAttributes:]): Quote font name when calling setFontFamily.
        (-[WebHTMLView _addToStyle:fontA:fontB:]): Ditto.

2005-03-04  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - fixed <rdar://problem/3965666> IDN spoofing vulnerability caused by Unicode characters that look like ASCII characters

        * Misc.subproj/WebNSURLExtras.m:
        (readIDNScriptWhiteListFile): Added. Reads file and parses script names.
        (readIDNScriptWhiteList): Added. Calls readIDNScriptWhiteList on each of the white list locations in succession.
        (allCharactersInIDNScriptWhiteList): Renamed from containsPossibleLatinLookalikes and changed sense.
        Now calls readIDNScriptWhiteList first time, and then uses the read-in list to check the scripts.
        (-[NSString _web_mapHostNameWithRange:encode:makeString:]): Call allCharactersInIDNScriptWhiteList instead of
        containsPossibleLatinLookalikes.
        * Resources/IDNScriptWhiteList.txt: Added.
        * WebKit.pbproj/project.pbxproj: Added IDNScriptWhiteList.txt file.

        * Misc.subproj/WebKitLocalizableStrings.m: Removed. This is simply unused.
        * English.lproj/StringsNotToBeLocalized.txt: Updated for recent changes.

2005-03-04  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - fixed <rdar://problem/3937667> REGRESSION (Mail): Zooming a window from titlebar button doesn't paint newly-exposed portions of window

        * WebView.subproj/WebHTMLView.m: (-[WebHTMLView _recursiveDisplayAllDirtyWithLockFocus:visRect:]):
        Re-set-up the visRect if the bounds changes due to layout.

=== Safari-402 ===

2005-03-03  Jens Alfke  <jens@apple.com>

        Reviewed by rjw.

